/*************************************** 
  2-NODE Truss Element: t2 
***************************************/
#include <stdio.h>
#include <math.h>
#define NN 2
/***********************************
 create stiffness of t2
************************************/
void mk_t2(
FILE *fp,
double xx[],double yy[],
double ee,double aa,
double stf[])
{
	double v[2];
	double length;
	double k,c,s;
	v[0]=xx[1]-xx[0];
	v[1]=yy[1]-yy[0];
	length=sqrt( v[0]*v[0] +v[1]*v[1] );
	c=v[0]/length;
	s=v[1]/length;
	k=ee*aa/length;
	stf[0]= k*c*c;
	stf[1]= k*c*s;
	stf[2]= k*s*s;
	stf[3]=-k*c*c;
	stf[4]=-k*c*s;
	stf[5]= k*c*c;
	stf[6]=-k*c*s;
	stf[7]=-k*s*s;
	stf[8]= k*c*s;
	stf[9]= k*s*s;
}
/***********************************
 recovery t2 
************************************/
void rcv_t2(		
FILE* fp,
double xx[],double yy[],
double ee,double aa,
double edisp[],
double *s11)
{
	double v[2];
	double length;
	double k,c,s;
	v[0]=xx[1]-xx[0];
	v[1]=yy[1]-yy[0];
	length=sqrt( v[0]*v[0] +v[1]*v[1] );
	c=v[0]/length;
	s=v[1]/length;
	k=ee/length;
	*s11=k*( c*(edisp[2]-edisp[0]) + s*(edisp[3]-edisp[1]) ) ;
}
