/*************************************** 
  2-NODE Truss Element: t3 
***************************************/
#include <stdio.h>
#include <math.h>
#define NN 2
/***********************************
 create stiffness of t3
************************************/
void mk_t3(
FILE *fp,
double xx[],double yy[],double zz[],
double ee,double aa,
double stf[])
{
	double v[3];
	double length;
	double k,l,m,n;
	v[0]=xx[1]-xx[0];
	v[1]=yy[1]-yy[0];
	v[2]=zz[1]-zz[0];
	length=sqrt( v[0]*v[0] +v[1]*v[1] +v[2]*v[2] );
	l=v[0]/length;
	m=v[1]/length;
	n=v[2]/length;
	k=ee*aa/length;
	stf[0]= k*l*l;
	stf[1]= k*l*m;
	stf[2]= k*m*m;
	stf[3]= k*l*n;
	stf[4]= k*m*n;
	stf[5]= k*n*n;
	stf[6]=-k*l*l;
	stf[7]=-k*l*m;
	stf[8]=-k*l*n;
	stf[9]= k*l*l;
	stf[10]=-k*l*m;
	stf[11]=-k*m*m;
	stf[12]=-k*m*n;
	stf[13]= k*l*m;
	stf[14]= k*m*m;
	stf[15]=-k*l*n;
	stf[16]=-k*m*n;
	stf[17]=-k*n*n;
	stf[18]= k*l*n;
	stf[19]= k*m*n;
	stf[20]= k*n*n;
}
/***********************************
 recovery t3 
************************************/
void rcv_t3(		
FILE* fp,
double xx[],double yy[],double zz[],
double ee,double aa,
double edisp[],
double *s11)
{
	double v[3];
	double length;
	double k,l,m,n;
	v[0]=xx[1]-xx[0];
	v[1]=yy[1]-yy[0];
	v[2]=zz[1]-zz[0];
	length=sqrt( v[0]*v[0] +v[1]*v[1] +v[2]*v[2]);
	l=v[0]/length;
	m=v[1]/length;
	n=v[2]/length;
	k=ee/length;
	*s11=k*( l*(edisp[3]-edisp[0]) + m*(edisp[4]-edisp[1]) + n*(edisp[5]-edisp[2])) ;
}
