/******************************************************************************
*          utility                                                            *
*******************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
/**********************
  zero clear vector
**********************/
void null(double *a,int m)
{
  int i;
  for(i=0;i<m;i++){
    a[i]=0.0;
  }
}
void nulli(int *a,int m)
{
  int i;
  for(i=0;i<m;i++){
    a[i]=0;
  }
}
/*******************************************************
* div_token                                            *
*******************************************************/
int div_token(char *string,char *token[])
{
     char *fs=" ";
     char *t;
     int number_of_fields=0;
     t=strtok(string,fs);
     token[number_of_fields]=t;
     while( t !=NULL){
         number_of_fields++;
         t=strtok(NULL,fs);
         token[number_of_fields]=t;
     }
       return number_of_fields;
}
/*******************************************************
* squeeze one characters                               *
*******************************************************/
void squeeze(char s[],int c)
{
    int i,j;
    for(i=j=0;s[i] !='\0';i++)
       if(s[i] != c)
          s[j++]=s[i];
    s[j]='\0';
}
/************************
* get_key function      *
************************/
void get_key(char *token,char *new_string,char *string)
{
	char *ptr=NULL;
	while(*token == *string){
		token++;
		string++;
		ptr=token;
	}
	strcpy(new_string,ptr);
}
/**************************
  allocate vector
**************************/
double* vectorR(int m)
{
  double *a;
  int i;
  if ( ( a=(double * )malloc( m * sizeof( double ) ) ) == NULL ) {
     printf("Error:Memory does not enough! a in vector \n");
     exit(1);
  }
/*** zero clear ***/  
  for(i=0;i<m;i++){
    a[i]=0.0;
  }
  return a;
}
/**************************
  delete vector
**************************/
void free_vectorR(double *a)
{
  free( (double *) a );
}
/**************************
  clear vector
**************************/
void null_vectorR(double *a,int m)
{
   int i;
   for(i=0;i<m;i++){
     a[i]=0.0;
   }
}
/**************************
  show vector
**************************/
void show_vectorR(double *a,int m)
{
   int i;
   printf("#### show vector####for %d \n",m);
   for(i=0;i<m;i++){
     printf(" %e\n",a[i]); 
   }
}
/**************************
  allocate vectorI
**************************/
int* vectorI(int m)
{
  int *a;
  int i;
  if ( ( a=(int * )malloc( m * sizeof( int ) ) ) == NULL ) {
     printf("Error:Memory does not enough! a in vectorI \n");
     exit(1);
  }
/*** zero clear ***/  
  for(i=0;i<m;i++){
    a[i]=0;
  }
  return a;
}
/**************************
  delete vectorI
**************************/
void free_vectorI(int *a)
{
  free( (int *) a );
}
/**************************
  clear vectorI
**************************/
void null_vectorI(int *a,int m)
{
   int i;
   for(i=0;i<m;i++){
     a[i]=0;
   }
}
/**************************
  show vectorI
**************************/
void show_vectorI(int *a,int m)
{
   int i;
   printf("#### show vectorI####for %d \n",m);
   for(i=0;i<m;i++){
     printf(" %d\n",a[i]); 
   }
}
/**************************
  allocate matrix 
**************************/
double** matrixR(int m,int n)
{
  double **aa;
  int i,j;
  if ( ( aa=(double ** )malloc( m * sizeof( double * ) ) ) == NULL ) {
     printf("Error:Memory does not enough! aa in matrix \n");
     exit(1);
  }
  if ( ( aa[0]=(double * )malloc( m * n * sizeof( double ) ) ) == NULL ) {
     printf("Error:Memory does not enough! aa in matrix \n");
     exit(1);
  }
  for(i=1;i<m;i++) aa[i]=aa[i-1]+n;
/*** zero clear ***/  
  for(j=0;j<n;j++){
    for(i=0;i<m;i++){
      aa[i][j]=0.0;
    }
  }
  return aa;
}
/**************************
  delete matrix 
**************************/
void free_matrixR(double **aa)
{
  free( (double *) aa[0] );
  free( (double **) aa );
}
/**************************
  clear matrix 
**************************/
void null_matrixR(double **a,int m,int n)
{
   int i,j;
   for(j=0;j<n;j++){
     for(i=0;i<m;i++){
       a[i][j]=0.0;
     }
   }
}
/**************************
  show matrix 
**************************/
void show_matrixR(double **a,int m,int n)
{
   int i,j;
   printf("#### show matrix####for %d x %d\n",m,n);
   for(i=0;i<m;i++){
     for(j=0;j<n;j++){
       printf(" %4.2f ",a[i][j]); 
     }printf("\n");
   }
}
/**************************
  allocate matrixI 
**************************/
int** matrixI(int m,int n)
{
  int **aa;
  int i,j;
  if ( ( aa=(int ** )malloc( m * sizeof( int * ) ) ) == NULL ) {
     printf("Error:Memory does not enough! aa in matrix \n");
     exit(1);
  }
  if ( ( aa[0]=(int * )malloc( m * n * sizeof( int ) ) ) == NULL ) {
     printf("Error:Memory does not enough! aa in matrix \n");
     exit(1);
  }
  for(i=1;i<m;i++) aa[i]=aa[i-1]+n;
/*** zero clear ***/  
  for(j=0;j<n;j++){
    for(i=0;i<m;i++){
      aa[i][j]=0;
    }
  }
  return aa;
}
/**************************
  delete matrixI
**************************/
void free_matrixI(int **aa)
{
  free( (int *) aa[0] );
  free( (int **) aa );
}
/**************************
  clear matrixI
**************************/
void null_matrixI(int **a,int m,int n)
{
   int i,j;
   for(j=0;j<n;j++){
     for(i=0;i<m;i++){
       a[i][j]=0;
     }
   }
}
/**************************
  show matrixI
**************************/
void show_matrixI(int **a,int m,int n)
{
   int i,j;
   printf("#### show matrixI####for %d x %d\n",m,n);
   for(i=0;i<m;i++){
     for(j=0;j<n;j++){
       printf(" %d ",a[i][j]); 
     }printf("\n");
   }
}


