/**************************
	ct3d.h
**************************/
/****************************
   define problem parameters
*****************************/
#define VERSION 1.090508
#define NAME_LENG   1024
#define NDOF      3
#define NNOD      2 
/*********************************
  define solver control parameters
*********************************/
#define LAPACK 0
#define LOWER  0
/*********************
   define structures 
**********************/
typedef struct cord{
	double x,y,z;
}CORD;
typedef struct node{
	CORD cord;
}NODE;
typedef struct truss{
	int sid;
	int id[2];
}TRUSS;
typedef struct material{
	double young;
}MATERIAL;
typedef struct section{
	double area;
	int    mid;
}SECTION;
typedef struct spc{
	int node_id;
	int dof_id;
	double value;
}SPC;
typedef struct cload{
	int node_id;
	int dof_id;
	double value;
}CLOAD;
typedef struct result_node{
	double u[3];/** u1 u2 u3**/
}RESULT_NODE;
typedef struct result_element{
	double s11;
}RESULT_ELEMENT;
/*******************
   CT3D OBJECT 
*******************/
typedef struct ct3d{
	char title[NAME_LENG];
	int numnp;
	int nume;
	int numat;
	int nsect;
	int nspc;
	int ncload;
	NODE  *node;/**** Node Object ****/
	TRUSS *truss;/**** Truss element Object ****/
	MATERIAL *material;/**** material Object ****/
	SECTION  *section;/**** section Object ****/
	SPC   *spc;  /**** spc Object ****/
	CLOAD *cload;/**** cload Object ****/
/** system matrices, vectors , scalars**/
	int nfreedom;/*** number of freedoms ***/
	int ncon;/*** number of constraint dofs ***/
	int *doftab;/*** doftable ***/
	double *cval;
	double *tempx;/***  solution vector in condensed form ***/
	double *temp;/**** solution vector ****/
/** result **/
	RESULT_NODE    *result_node;
	RESULT_ELEMENT *result_element;
}CT3D;
