#include <stdio.h>
#define MAX(x,y) (x>y?x:y)
#define MIN(x,y) (x<y?x:y)
void dbandc_(double *a, int *nbarg, int *narg, double *d){

  int j,i,k,j1,nb,n,nt,ij;
  double s,t;

  nb=*nbarg; n=*narg;
  d[0]=1.0/a[0];
  for(j=2; j<=n; j++){
    j1=MAX(j-nb+1,1);
    for(i=j1+1; i<=j-1; i++){
      nt=i-j1; ij=j-i;
      s=0;
      for(k=1; k<=nt; k++){
        s+=a[(i-nt+k-2)*nb+nt-k+1]*a[(j-ij-nt+k-2)*nb+nt+ij-k+1];
      }
      a[(i-1)*nb+j-i]=a[(i-1)*nb+j-i]-s;
    }
    s=0;
    for(k=MAX(j-nb+1,1); k<=j-1; k++){
      t=a[(k-1)*nb+j-k]*d[k-1];
      s+=t*a[(k-1)*nb+j-k];
      a[(k-1)*nb+j-k]=t;
    }
    a[(j-1)*nb]=a[(j-1)*nb]-s;
    d[j-1]=1.0/a[(j-1)*nb];
  }
}
void dbandsc_(double *a, int *nbarg, int *narg, double *x){
  int j,i,k,j1,nb,n,nt;
  double s;

  nb=*nbarg; n=*narg;
  for(j=2; j<=n; j++){
    j1=MAX(j-nb+1,1);
    nt=j-j1; s=0;
    for(k=1; k<=nt; k++){
      s+=a[(j-nt+k-2)*nb+nt-k+1]*x[j-nt+k-2];
    }
    x[j-1]=x[j-1]-s;
  }
  for(i=1; i<=n; i++){
    x[i-1]=x[i-1]/a[(i-1)*nb];
  }
  for(j=n; j>=1; j--){
    j1=MAX(j-nb+1,1);
    for(i=j1; i<=j-1; i++){
      x[i-1]-=a[(i-1)*nb+j-i]*x[j-1];
    }
  }
}
void dmpybndc_(double *a, int *nbarg, int *narg, double *x, double *y){
  int j,i,ie,nb,n;
  double s;
  nb=*nbarg; n=*narg;
  for(i=1; i<=n; i++){
    ie=MIN(n,i+nb-1); s=0;
    for(j=i+1; j<=ie; j++){
      s+=a[(i-1)*nb+j-i]*x[j-1];
      y[j-1]+=a[(i-1)*nb+j-i]*x[i-1];
    }
    y[i-1]+=s+a[(i-1)*nb]*x[i-1];
  }
}
void dbandc (double *a, int *nbarg, int *narg, double *d)
{    dbandc_(        a,      nbarg,      narg,         d);}
void dbandsc (double *a, int *nbarg, int *narg, double *x)
{    dbandsc_(        a,      nbarg,      narg,         x);}
void dmpybndc (double *a, int *nbarg, int *narg, double *x, double *y)
{    dmpybndc_(        a,      nbarg,      narg,         x,         y);}
