/*****************************************
* write VTF for V6.5
*******************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "ct3d.h"
void writeVTF(FILE *fp_log, FILE *fp_vtf, CT3D *ct3d)
{
	int i,j;
	int nid[NNOD];
	int count;
	fprintf(fp_vtf,"*VTF-1.00\n");
	fprintf(fp_vtf,"*NODES 1\n");
	fprintf(fp_vtf,"%%NO_ID\n");
	for( i=0;i< ct3d->numnp;i++){
		fprintf(fp_vtf,"%e %e %e\n",
		(ct3d->node)[i].cord.x,(ct3d->node)[i].cord.y,(ct3d->node)[i].cord.z);
	}
	count=1;
	if( ct3d->nume > 0 ) {
		fprintf(fp_vtf,"*ELEMENTS %d\n",count++);
		fprintf(fp_vtf,"%%NAME \"TRUSS\"\n");
		fprintf(fp_vtf,"%%DESCRIPTION \"THE TRUSS ELEMENTS\"\n");
		fprintf(fp_vtf,"%%NODES #1\n");
		fprintf(fp_vtf,"%%NO_ID\n");
		fprintf(fp_vtf,"%%BEAMS\n");
		for( i=0;i< ct3d->nume;i++){
			for( j=0;j<2;j++){
				nid[j]=(ct3d->truss)[i].id[j];
			}
			fprintf(fp_vtf,"%d %d\n",nid[0],nid[1]);
		}
	}
	fprintf(fp_vtf,"*GLVIEWGEOMETRY 1\n");
	fprintf(fp_vtf,"%%NAME \"%s\"\n",ct3d->title);
	fprintf(fp_vtf,"%%ELEMENTS\n");
	fprintf(fp_vtf,"1,\n");
/*** Results for static analysis ***/
/*** Result (Displacement) ***/
	fprintf(fp_vtf,"*RESULTS 1\n");
	fprintf(fp_vtf,"%%DIMENSION 3\n");
	fprintf(fp_vtf,"%%NO_ID\n");
	fprintf(fp_vtf,"%%PER_NODE #1\n");
	for(i=0;i<ct3d->numnp;i++){
		fprintf(fp_vtf,"%e %e %e\n",
		(ct3d->result_node)[i].u[0],
		(ct3d->result_node)[i].u[1],
		(ct3d->result_node)[i].u[2]);
	}
/*** Result (Element Stress) ***/
	fprintf(fp_vtf,"*RESULTS 2\n");
	fprintf(fp_vtf,"%%DIMENSION 1\n");
	fprintf(fp_vtf,"%%NO_ID\n");
	fprintf(fp_vtf,"%%PER_ELEMENT #1\n");
	for(j=0;j<ct3d->nume;j++){
		fprintf(fp_vtf,"%e\n",(ct3d->result_element)[j].s11);
	}
/** Visualize **/
	fprintf(fp_vtf,"*GLVIEWVECTOR 1\n");
	fprintf(fp_vtf,"%%NAME \"Displacement\"\n");
	fprintf(fp_vtf,"%%STEP 1\n");
	fprintf(fp_vtf,"%%STEPNAME \"Time:0.0\"\n");
	fprintf(fp_vtf,"1,\n");
	fprintf(fp_vtf,"*GLVIEWSCALAR 2\n");
	fprintf(fp_vtf,"%%NAME \"S11\"\n");
	fprintf(fp_vtf,"%%STEP 1\n");
	fprintf(fp_vtf,"%%STEPNAME \"Time:0.0\"\n");
	fprintf(fp_vtf,"2,\n");
}
