      read(*,*) nx,ny
      np=(nx+1)*(ny+1)+nx*ny
      ne=nx*ny*8
      nb=2
      nf=1
      write(*,*) 'TRUSS DATA symmetric structure'
      write(*,*) np   !  Number of nodes
      write(*,*) ne   !  Number of elements
      write(*,*) 1    !  Number of materials
      write(*,*) 1    !  Number of sections
      write(*,*) 4    !  Number of SPCs
      write(*,*) 1    !  Number of loads
      call grid (nx,ny)
      call cquad(nx,ny)
      write(*,*) 206000.  !  material data E
      write(*,*) 1., 1     !  section data  S
      call spc  (nx,ny)
      call load (nx,ny)
      stop
      end
      subroutine grid (nx,ny)
      dx=1./nx; dy=1./ny
      hx=dx/2.0   ; hy=dy/2.0
      k=0
       do j=1,ny+1
        y=(j-1)*dy
         do i=1,nx+1
          x=(i-1)*dx; k=k+1
          write(*,'(2f8.3)') x,y
         enddo
       if(j.le.ny) then
        y=(j-1)*dy+hy
         do i=1,nx
          x=(i-1)*dx+hx; k=k+1
          write(*,'(2f8.3)') x,y
         enddo
        endif
       enddo
      return
      end
      subroutine cquad (nx,ny)
      k=1
       do j=1,ny
        n1=(j-1)*(2*nx+1)+1
        n5=(j-1)*(2*nx+1)+nx+2
        n2=n1+1
        n3=n1+2*nx+1
        n4=n3+1
         do i=1,nx
          write(*,*) 1,n1,n2
          write(*,*) 1,n3,n4
          write(*,*) 1,n1,n3
          write(*,*) 1,n2,n4
          write(*,*) 1,n1,n5
          write(*,*) 1,n2,n5
          write(*,*) 1,n3,n5
          write(*,*) 1,n4,n5
          k=k+8 
          n1=n1+1
          n2=n2+1
          n3=n3+1
          n4=n4+1
          n5=n5+1
         enddo
       enddo
      return
      end
      subroutine spc (nx,ny)
      write(*,*) 1,1,0.
      write(*,*) 1,2,0.
      write(*,*) nx+1,1,0.
      write(*,*) nx+1,2,0.
      return
      end
      subroutine load (nx,ny)
      write(*,*) (nx+1)*(ny+1)+nx*ny,1,1.0
      return
      end
