!***********************************************************************!
!	FT2D entry
!***********************************************************************!
!-----------------------------------------------------------------------!
      subroutine ft2d_main(acfile,ft2d)
!-----------------------------------------------------------------------!
      use ft2d_m
      use solveSTATIC_m 
      implicit none
!
! INTERFACE
!
      character (len=NAME_LENG) :: acfile(5)
      type(strFT2D) :: ft2d
!
! LOCAL
!
      real (kind=4) :: cputime(20) ! CPU counter 
      real (kind=4) :: tarray(2)
      real (kind=4) :: DTIME
!
! FILE OPEN
!
      open(IIN ,file=acfile(1),status='OLD')
      open(IOUT,file=acfile(2),status='UNKNOWN')
      open(ILOG,file=acfile(3),status='UNKNOWN')
      open(IVTF,file=acfile(4),status='UNKNOWN')
      open(IPLT,file=acfile(5),status='UNKNOWN')
! Starting 
      cputime(1)=DTIME(tarray)
! Message 
      write(ILOG,*) "### STARTED!"
! Read input data
      call read_data(ft2d)
      close(IIN)
! Input data echo
      call input_echo(ft2d)
      cputime(2)=DTIME(tarray)
! Create dof table
      call create_doftab(ft2d)
! Create constList ***
      call create_constList(ft2d)
      cputime(3)=DTIME(tarray)
!*****************************
! 2D Truss Analysis 
!*****************************
      call solveSTATIC(ft2d)
      cputime(4)=DTIME(tarray)
      close(IVTF)
!****************************** 
! List of cpu time
!******************************
!-----------------------------------------------------------------------!
      write(IOUT,*) "#### CPU time informations (sec)"
      write(IOUT,*) " Input Data Phase..................", cputime(2)-cputime(1)
      write(IOUT,*) " Preprocessing for Solver..........", cputime(3)-cputime(2)
      write(IOUT,*) " Solver Process....................", cputime(4)-cputime(3)
      write(IOUT,*) " .................................."             
      write(IOUT,*) " total.............................", cputime(4)-cputime(1)
      write(ILOG,*) "#### CPU time informations (sec)"
      write(ILOG,*) " Input Data Phase..................", cputime(2)-cputime(1)
      write(ILOG,*) " Preprocessing for Solver..........", cputime(3)-cputime(2)
      write(ILOG,*) " Solver Process....................", cputime(4)-cputime(3)
      write(ILOG,*) " .................................."             
      write(ILOG,*) " total.............................", cputime(4)-cputime(1)
      close(IOUT)
      close(ILOG)
      end subroutine ft2d_main
