!************************************** 
! 2-NODE Truss Element: t2 
!**************************************
!**********************************
! create stiffness of t2
!**********************************
!-----------------------------------------------------------------------!
      subroutine mk_t2(ILOG,xx,yy,ee,aa,stf)
!-----------------------------------------------------------------------!
      implicit none
!
! INTERFACE
!
      integer (kind=4) :: ILOG
      real    (kind=8) :: xx(2),yy(2)
      real    (kind=8) :: ee,aa
      real    (kind=8) :: stf(10)
!
! LOCAL
!
      real    (kind=8) :: v(2)
      real    (kind=8) :: length
      real    (kind=8) :: k,c,s
      v(1)=xx(2)-xx(1)
      v(2)=yy(2)-yy(1)
      length=sqrt( v(1)*v(1) +v(2)*v(2) )
      c=v(1)/length
      s=v(2)/length
      k=ee*aa/length
      stf(1)= k*c*c
      stf(2)= k*c*s
      stf(3)= k*s*s
      stf(4)=-k*c*c
      stf(5)=-k*c*s
      stf(6)= k*c*c
      stf(7)=-k*c*s
      stf(8)=-k*s*s
      stf(9)= k*c*s
      stf(10)= k*s*s
      end subroutine mk_t2
!**********************************
!  recovery t2 
!**********************************
!-----------------------------------------------------------------------!
      subroutine rcv_t2(ILOG,xx,yy,ee,aa,edisp,s11)
!-----------------------------------------------------------------------!
      implicit none
!
! INTERFACE
!
      integer (kind=4) :: ILOG
      real    (kind=8) :: xx(2),yy(2)
      real    (kind=8) :: ee,aa
      real    (kind=8) :: edisp(4),s11
!
! LOCAL
!
      real    (kind=8) :: v(2)
      real    (kind=8) :: length
      real    (kind=8) :: k,c,s
      v(1)=xx(2)-xx(1)
      v(2)=yy(2)-yy(1)
      length=sqrt( v(1)*v(1) +v(2)*v(2) )
      c=v(1)/length
      s=v(2)/length
      k=ee/length
      s11=k*( c*(edisp(3)-edisp(1)) + s*(edisp(4)-edisp(2)) )
      end subroutine rcv_t2
