!-----------------------------------------------------------------------!
!     Definitions of module ft2d_m
!-----------------------------------------------------------------------!
      module ft2d_m
      implicit none
!***************************
! define problem parameters
!****************************
      real, parameter    :: VERSION=1.090508
      integer, parameter :: NAME_LENG=1024
      integer, parameter :: NDOF=2
      integer, parameter :: NNOD=2
      integer, parameter :: LAPACK=0
      integer, parameter :: LOWER=0
      integer, parameter :: DEBUG=0
      integer, parameter :: IIN=15,IOUT=16,ILOG=17,IVTF=18,IPLT=19
!********************
!  define structures 
!********************
!--------------------------
      type strCORD
        real (kind=8) :: x,y
      end type strCORD
!--------------------------
      type strNODE
        type(strCORD)    :: cord
      end type strNODE
!--------------------------
      type strTRUSS
        integer (kind=4) :: sid
        integer (kind=4) :: id(2)
      end type strTRUSS
!--------------------------
      type strMATERIAL
        real (kind=8) :: young
      end type strMATERIAL
!--------------------------
      type strSECTION
        real (kind=8) :: area
        integer (kind=4):: mid
      end type strSECTION
!--------------------------
      type strSPC
        integer (kind=4)::node_id
        integer (kind=4)::dof_id
        real    (kind=8) :: value
      end type strSPC
!--------------------------
      type strCLOAD
        integer (kind=4)::node_id
        integer (kind=4)::dof_id
        real    (kind=8) :: value
      end type strCLOAD
!--------------------------
      type strRESULT_NODE
        real    (kind=8) :: u(2)
      end type strRESULT_NODE
!--------------------------
      type strRESULT_ELEMENT
        real    (kind=8) :: s11
      end type strRESULT_ELEMENT
!*******************
!   FT2D OBJECT 
!*******************
      type strFT2D
        character (len=NAME_LENG) :: title
        integer (kind=4) :: numnp
        integer (kind=4) :: nume
        integer (kind=4) :: numat
        integer (kind=4) :: nsect
        integer (kind=4) :: nspc
        integer (kind=4) :: ncload
        type (strNODE),    pointer:: node(:)     ! Node Object 
        type (strTRUSS),   pointer:: truss(:)    ! Truss element Object 
        type (strMATERIAL),pointer:: material(:) ! material Object 
        type (strSECTION), pointer:: section(:)  ! section Object 
        type (strSPC),     pointer:: spc(:)      ! spc Object 
        type (strCLOAD),   pointer:: cload(:)    ! cload Object 
! system matrices, vectors , scalars
        integer (kind=4) :: nfreedom          ! number of freedoms 
        integer (kind=4) :: ncon              ! number of const dofs
        integer (kind=4),pointer :: doftab(:) ! doftable
        real    (kind=8),pointer :: cval(:)   ! constraint value
        real    (kind=8),pointer :: tempx(:)  ! sol.vector (cond.form)
        real    (kind=8),pointer :: temp(:)   ! sol.vector 
! result 
        type (strRESULT_NODE),pointer:: result_node(:)
        type (strRESULT_ELEMENT),pointer:: result_element(:)
      end type strFT2D
      end module ft2d_m
