!****************************************
! write VTF for V6.5
!****************************************
!-----------------------------------------------------------------------!
      subroutine writeVTF(ft2d)
!-----------------------------------------------------------------------!
      use ft2d_m
      implicit none
!
! INTERFACE
!
      type(strFT2D)    :: ft2d
!
! LOCAL
!
      integer (kind=4) :: i,j,nid(2),count
      write(IVTF,'(''*VTF-1.00'')')
      write(IVTF,'(''*NODES 1'')')
      write(IVTF,'(''%NO_ID'')')
      do i=1,ft2d%numnp
        write(IVTF,*) ft2d%node(i)%cord%x,ft2d%node(i)%cord%y,' 0.0'
      enddo
      count=1
      if( ft2d%nume .gt. 0 ) then
        write(IVTF,'(''*ELEMENTS'',I5)') count
        count=count+1
        write(IVTF,'(''%NAME "QUAD"'')')
        write(IVTF,'(''%DESCRIPTION "THE QUAD ELEMENTS"'')')
        write(IVTF,'(''%NODES #1'')')
        write(IVTF,'(''%NO_ID'')')
        write(IVTF,'(''%BEAMS'')')
        do i=1,ft2d%nume
          do j=1,2
            nid(j)=ft2d%truss(i)%id(j)
          enddo
          write(IVTF,*) nid(1),nid(2)
        enddo
      endif
      write(IVTF,'(''*GLVIEWGEOMETRY 1'')')
      write(IVTF,'(''%NAME "'',A20,''"'')') ft2d%title
      write(IVTF,'(''%ELEMENTS'')')
      write(IVTF,'(''1,'')')
! Results for static analysis
! Result (Displacement)
      write(IVTF,'(''*RESULTS 1'')')
      write(IVTF,'(''%DIMENSION 3'')')
      write(IVTF,'(''%NO_ID'')')
      write(IVTF,'(''%PER_NODE #1'')')
      do i=1,ft2d%numnp
        write(IVTF,*) ft2d%result_node(i)%u(1),ft2d%result_node(i)%u(2),' 0.0'
      enddo
! Result (Element Stress)
      write(IVTF,'(''*RESULTS 2'')')
      write(IVTF,'(''%DIMENSION 1'')')
      write(IVTF,'(''%NO_ID'')')
      write(IVTF,'(''%PER_ELEMENT #1'')')
      do j=1,ft2d%nume
        write(IVTF,*) ft2d%result_element(j)%s11
      enddo
! Visualize
      write(IVTF,'(''*GLVIEWVECTOR 1'')')
      write(IVTF,'(''%NAME "Displacement"'')')
      write(IVTF,'(''%STEP 1'')')
      write(IVTF,'(''%STEPNAME "Time:0.0"'')')
      write(IVTF,'(''1,'')')
      write(IVTF,'(''*GLVIEWSCALAR 2'')')
      write(IVTF,'(''%NAME "S11"'')')
      write(IVTF,'(''%STEP 1'')')
      write(IVTF,'(''%STEPNAME "Time:0.0"'')')
      write(IVTF,'(''2,'')')
      end subroutine writeVTF
