c
c   g77 -O bsolv.f
c
c     PARAMETER (N=16,NB=4)
c     PARAMETER (N=25,NB=5)
c     PARAMETER (N=36,NB=6)
c     PARAMETER (N=49,NB=7)
c     PARAMETER (N=64,NB=8)
c     PARAMETER (N=81,NB=9)
c     PARAMETER (N=100,NB=10)
      PARAMETER (N=121,NB=11)
      implicit double precision (a-h,o-z)
      dimension A(N,N),B(N),D(N),X(N),Y(N),ipvt(N)
      dimension S(N,N)
      dimension C(N*(N+1)/2)
      dimension F(NB,N), G(NB,N)
c   --- data generation ---
      do i=1,n
       b(i)=1.0
       x(i)=b(i)
        do j=1,n
          a(i,j)=0.0
        enddo
        a(i,i)=4.
        if(i.le.n-nb) then
          a(i,i+nb-1)=-1. ;  a(i,i+1)=-1
        endif
      enddo
      a(n/2,n/2+1)=0.1   ! pertabation for debug
      do i=1,n       
        do j=1,i-1
          a(i,j)=a(j,i) !  symmetric lower portion
        enddo
      enddo
      do i=1,n
        do j=1,n
          s(i,j)=a(i,j) !  save A into S
        enddo
c       write(*,*) 'row ',i
c       write(*,*) (a(i,j),j=1,n)
      enddo
c
      call dldlt (a,N,n)    ! LDL^T factorize
      call dldlts(a,N,n,x)    ! substitution
      write(*,*) 'X solved by dldlt'
      write(*,*) x       ! solution by dldlt/dldlts
      do i=1,n
       d(i)=x(i)         ! save solution in D
       x(i)=-x(i)
      enddo
      call dmvmul (s,N,n,n,x,b)   ! b <= b-Ax
      write(*,*) 'Residual b-Ax'
      write(*,*) b
c
c   --- data conversion to band format ---
      do j=1,n
        do i=max(1,j-nb+1),j
          f(nb-j+i,j)=s(i,j)
          g(nb-j+i,j)=s(i,j)  !  G saved for matrix vector multiply
        enddo
      enddo
c     write(*,*) 'before call dband'
*     call dbandprt(f,nb,n)     ! print L in band matrix format
C     call dbandt (f,nb,n)
C     call dbandt2(f,nb,n)
      call dbandt22(f,nb,n)
c     write(*,*) y
c     write(*,*) 'after  call dband'
c     call dbandprt(f,nb,n)
c
       do i=1,n
        y(i)=1.
       enddo
c
      call dbandts(f,nb,n,y)
c
      write(*,*) 'X solved by dband'
      write(*,*) y
      write(*,*) 'Difference X solved by dband and dldlt'
      write(*,*) (y(i)-d(i),i=1,n)
c
      do i=1,n
       b(i)=-1.0
      enddo
      call dmpybndt(g,nb,n,y,b)
      write(*,*) 'A*X-B for check'
      write(*,*) b
c
      stop
      end
      subroutine dmpybndt(a,nb,n,x,y)
      implicit double precision (a-h,o-z)
      dimension a(nb,n),x(n),y(n)
      do i=1,n
        i1=max(1,i-nb+1)
        s=0
        do j=i1,i-1
          s=s+a(nb-i+j,i)*x(j)
          y(j)=y(j)+a(nb-i+j,i)*x(i)
        enddo
        y(i)=y(i)+s+a(nb,i)*x(i)
      enddo
      return
      END
      subroutine dbandprt (a,nb,n)
      implicit double precision (a-h,o-z)
      dimension a(nb,n)
      write(*,*) 'dbandprt'
      Do j=1,n
        write(*,*) 'col=',j
        write(*,*) (a(i,j),i=1,nb)
      Enddo
      return
      END
      subroutine dbandt(a,nb,n)  ! LDL^T factorization
      implicit double precision (a-h,o-z)
      dimension a(nb,n)
      Do j=2,n
        j1=max(j-nb+1,1)
        do i=j1+1,j-1          !   do i=1,j-1
          s=dot(i-j1,a(nb-i+j1,i),a(nb-j+j1,j))
          a(nb-j+i,j)=a(nb-j+i,j)-s
        enddo
        s=0.
        do k=j1,j-1
          t=a(nb-j+k,j)/a(nb,k) !   t=a(k,j)/a(k,k)
          s=s+t*a(nb-j+k,j)     !   s=s+t*a(k,j)
          a(nb-j+k,j)=t         !   a(k,j)=t
        enddo 
        a(nb,j)=a(nb,j)-s       !   a(j,j)=a(j,j)-s
c       write(*,*) 'j=',j,' A(nb,j)=',a(nb,j),' j1=',j1
      Enddo
      return
      END
      subroutine dbandt2(a,nb,n)
      implicit double precision (a-h,o-z)
      dimension a(nb,n)
c=======================================================================
      Do j=2,n
        j1=max(j-nb+1,1)
        nres=(j-j1-1)-((j-j1-1)/2)*2
        if(nres.gt.0) then
c         Aj1+1,j                      Lj1+1,j1@Aj1,j1+1 Uj1,j
          a(nb-j+j1+1,j)=a(nb-j+j1+1,j)-a(nb-1,j1+1)*a(nb-j+j1,j)
        endif
c-----------------------------------------------------------------------
        do i=j1+1+nres,j-1,2
c         s0=dot(i-j1,a(nb-i+j1,i),a(nb-j+j1,j))
c         s1=dot(i-j1,a(nb-i-1+j1,i+1),a(nb-j+j1,j))
c                            Li,j1@Aj1,i  Li+1,j1@Aj1,i+1  Aj1,j
        call dot2(s0,s1,i-j1,a(nb-i+j1,i),a(nb-i-1+j1,i+1),a(nb-j+j1,j))
          a(nb-j+i,j)=a(nb-j+i,j)-s0      ! Ai,j==>Ui,j
          s1=s1+a(nb-1,i+1)*a(nb-j+i,j)   ! s1+Li+1,i*Ui,j ..Li+1,i@Ai,i+1
          a(nb-j+i+1,j)=a(nb-j+i+1,j)-s1  ! Ai+1,j==>Ui+1,j
        enddo
c-----------------------------------------------------------------------
        s=0.
        do k=j1,j-1
          t=a(nb-j+k,j)/a(nb,k) !   t=Ak,j/Ak,k
          s=s+t*a(nb-j+k,j)     !   s=s+t*Ak,j
          a(nb-j+k,j)=t         !   Ak,j=t
        enddo 
        a(nb,j)=a(nb,j)-s       !   Aj,j==>Uj,j
      Enddo
c=======================================================================
      return
      END
      subroutine dbandt22(a,nb,n)
      implicit double precision (a-h,o-z)
      dimension a(nb,n)
      jres=n-1-((n-1)/2)*2
      if(jres.gt.0) then
        t=a(nb-1,2)/a(nb,1) ! t=A1,2/A11=L2,1
        s=t*a(nb-1,2)       ! s=L2,1*U1,2
        a(nb-1,2)=t         ! L2,1@A1,2
        a(nb,2)=a(nb,2)-s   ! A2,2=>U2,2
      endif
c=======================================================================
      DO j=2+jres,n-1,2
        j1=max(j-nb+1,1);             j2=max(j-nb+2,1)
        nres=(j-j1-1)-((j-j1-1)/2)*2; mres=(j-j2-1)-((j-j2-1)/2)*2
        if(nres.gt.0) then ! Aj1+1,j     Lj1+1,j1@Aj1,j1+1 Uj1,j
          a(nb-j+j1+1,j)=a(nb-j+j1+1,j)-a(nb-1,j1+1)*a(nb-j+j1,j)
        endif
        if(mres.gt.0) then ! Aj2+1,j+1   Lj2+1,j2@Aj2,j2+1 Uj2,j+1
          a(nb-j+j2,j+1)=a(nb-j+j2,j+1)-a(nb-1,j2+1)*a(nb-j-1+j2,j+1)
        endif
        If(j1+nres.lt.j2+mres) Then  !!! nres always =0 when go through
c         s0=a(nb-1,j1+1)*a(nb-j+j1,j)      ! s0=Lj1+1,j1@Aj1,j1+1*Uj1,j
c         s1=a(nb-2,j1+2)*a(nb-j+j1,j)      ! s1=Lj1+2,j1@Aj1,j1+2*Uj1,j
          a(nb-j+j1+1,j)=a(nb-j+j1+1,j)-a(nb-1,j1+1)*a(nb-j+j1,j)  
c         s1=s1+a(nb-1,j1+2)*a(nb-j+j1+1,j)
          a(nb-j+j1+2,j)=a(nb-j+j1+2,j)-a(nb-2,j1+2)*a(nb-j+j1,j)
     &                                 -a(nb-1,j1+2)*a(nb-j+j1+1,j)
        Endif
c-----------------------------------------------------------------------
        Do i=j2+1+mres,j-1,2
          s0=0; s1=0; t0=0; t1=0
          if(j1.lt.j2) then
            s0=a(nb-i+j1,i)    *a(nb-j+j1,j)  ! s0=Aj1,i  *Aj1,j
            s1=a(nb-i-1+j1,i+1)*a(nb-j+j1,j)  ! s1=Aj1,i+1*Aj1,j
          endif
*                                        Li,j2@Aj2,i  Li+1,j2@Aj2,i+1
          call dot2x2(s0,s1,t0,t1,i-j2,a(nb-i+j2,i),a(nb-i-1+j2,i+1)
*                                        Aj2,j        Aj2,j+1
     &                                ,a(nb-j+j2,j),a(nb-j-1+j2,j+1))
          a(nb-j+i,j)=a(nb-j+i,j)-s0      ! Ai,j==>Ui,j
c         s1=s1+a(nb-1,i+1)*a(nb-j+i,j)
          a(nb-j+i+1,j)=a(nb-j+i+1,j)-s1-a(nb-1,i+1)*a(nb-j+i,j) ! Ai+1,j==>Ui+1,j
          a(nb-j-1+i,j+1)=a(nb-j-1+i,j+1)-t0 ! Ai,j+1==>Ui,j+1
c         t1=t1+a(nb-1,i+1)*a(nb-j-1+i,j+1)  ! Li+1,i@Ai,i+1*Ui,j+1
          a(nb-j+i,j+1)=a(nb-j+i,j+1)-t1-a(nb-1,i+1)*a(nb-j-1+i,j+1)
        Enddo
c-----------------------------------------------------------------------
        s=0
        do k=j1,j-1
          t=a(nb-j+k,j)/a(nb,k) !   t=a(k,j)/a(k,k)
          s=s+t*a(nb-j+k,j)     !   s=s+t*a(k,j)
          a(nb-j+k,j)=t         !   a(k,j)=t
        enddo 
        a(nb,j)=a(nb,j)-s       !   a(j,j)=a(j,j)-s
c                    Aj2,j       Aj2,j+1
        s=dot(j-j2,a(nb-j+j2,j),a(nb-j-1+j2,j+1))
        a(nb-1,j+1)=a(nb-1,j+1)-s  ! Aj,j+1==>Uj,j+1
        s=0
        do k=j2,j
          t=a(nb-j-1+k,j+1)/a(nb,k) ! t=a(k,j+1)/a(k,k)
          s=s+t*a(nb-j-1+k,j+1)     ! s=s+t*a(k,j+1)
          a(nb-j-1+k,j+1)=t         ! a(k,j+1)=t
        enddo 
        a(nb,j+1)=a(nb,j+1)-s   !  a(j+1,j+1)-s
      ENDDO
c=======================================================================
      return
      END
      subroutine dldlt (a,lda,n)  ! LDL^T factorization in double precision
      implicit double precision (a-h,o-z)
      dimension a(lda,n)
      Do j=2,n
        do i=1,j-1
c         ------------------------------------
c         a(i,j)=a(i,j)-dot(i-1,a(1,i),a(1,j))
          s=0    !  dot (stride 1 ddot) replace
          do k=1,i-1
            s=s+a(k,i)*a(k,j)
          enddo
          a(i,j)=a(i,j)-s
c         ------------------------------------
        enddo
        s=0.
        do k=1,j-1
          t=a(k,j)/a(k,k)
          s=s+t*a(k,j)
          a(k,j)=t
        enddo
        a(j,j)=a(j,j)-s
      Enddo
      return
      END
      subroutine dbandts(a,nb,n,x)  ! LDL^T solve for band matrix
      implicit double precision (a-h,o-z)
      dimension a(nb,n),x(n)
      do i=2,n       
        j1=max(1,i-nb+1) 
        s=dot(i-j1,x(j1),a(nb-i+j1,i))
        x(i)=x(i)-s
      enddo
c     write(*,*) 'after forward solv'
c     write(*,*) (x(i),i=1,n)
      do i=1,n
        x(i)=x(i)/a(nb,i)
      enddo
      do i=n,2,-1
        j1=max(1,i-nb+1) 
        do k=j1,i-1         
          x(k)=x(k)-a(nb-i+k,i)*x(i)
        enddo
      enddo
      return
      END
      subroutine dldlts (a,lda,n,x)  ! Solve LDL^T factor
      implicit double precision (a-h,o-z)
      dimension a(lda,n),x(n)
      do j=2,n
        x(j)=x(j)-dot(j-1,a(1,j),x)
      enddo
      do i=1,n
        x(i)=x(i)/a(i,i)
      enddo
      do j=n,1,-1
        do i=1,j-1
          x(i)=x(i)-a(i,j)*x(j)
        enddo
      enddo
      return
      END
      SUBROUTINE dmvmul (a,lda,m,n,x,y)
      double precision a(lda,n),x(*),y(*)
       do I=1,m
         do J=1,n
          y(i)=y(i)+A(i,J)*X(J)  
         enddo
       enddo
      return
      END
      function dot (n,x,y)
      implicit double precision (a-h,o-z)
      dimension x(n),y(n)
c
      dot=0.d0
       do i=1,n
        dot=dot+x(i)*y(i)
       enddo
c
      return
      end
      subroutine dot2 (s0,s1,n,x0,x1,y)
      implicit double precision (a-h,o-z)
      dimension x0(n),x1(n),y(n)
c
      s0=0.d0; s1=0.d0
       do i=1,n
        s0=s0+x0(i)*y(i)
        s1=s1+x1(i)*y(i)
       enddo
c
      return
      end
      subroutine dot2x2 (s0,s1,t0,t1,n,x0,x1,y0,y1)
      implicit double precision (a-h,o-z)
      dimension x0(n),x1(n),y0(n),y1(n)
c
       do i=1,n
         s0=s0+x0(i)*y0(i)
         s1=s1+x1(i)*y0(i)
         t0=t0+x0(i)*y1(i)
         t1=t1+x1(i)*y1(i)
       enddo
c
      return
      end
