      parameter (mord1=2000,morder=2000) 
c
c   ***************************************
c    (gcc -O second.c -c )
c    g77 -O utilslct.f -c 
c  then
c    g77 -O decomp.f utilslct.o (second.o)
c
c    ./a.exe 1500 1.d-11 0 6000
c
c    ./a.exe 2000 1.d-12 0 6000
c    n=2000, iseed=68111 of setrandom makes ill-condition
c   ***************************************
c
      implicit double precision (a-h,o-z)     
      double precision d(33000)                         
      integer ipvt(morder)                                   
      common /xxx1/ aa(morder)                               
      common /xxx2/ a(mord1,morder)                           
      common /xxx3/ b(morder),x(morder)                      
      common /systm2/ lvs,ncache,ncline 
      character*80 arg
c
      call getarg(1,arg)
      read(arg,*) n
      call getarg(2,arg)
      read(arg,*) eps
      call getarg(3,arg)
      read(arg,*) kdata
      call getarg(4,arg)
      read(arg,*) ncache
c *** data type      =1 (frank matrix),  =2 (random) ******   
c
      lvs=128
c     ncache=8192
      ncline=16
cc    lvs=256
cc    ncache=8192*4
cc    ncline=32
c
c
      lda=mord1                                             
      xn=n                                              
      yn=xn/1000.                                         
      ops1=(2.0d0*yn*yn*xn)/3.0d0                         
      ops2=2.0d0*yn*yn                                   
c                                    
       if(kdata.eq.1) then
        call setfrank (a,lda,n)
       else
        call setrandm (a,lda,n)
       endif
c
       do i=1,n
        b(i)=1.0
        x(i)=0
       enddo
      call dmvmul (a,lda,n,n,b,x)
c     call dmatpr (x,lda,n,1,1,3)
c     call dmatpr (b,lda,n,1,1,3)
c     call dmatpr (a,lda,n,n,1,3)
c   ************************************                     
      t0=second()
c   -----------------------------------------------------     
      call dcompr (a,lda,n,ipvt,d)     
c   -----------------------------------------------------     
      t1=second()-t0
      t0=second()
c   ----------------------------------------------------- 
      call dsbpcs (a,lda,n,ipvt,x)  
c   -----------------------------------------------------   
      t2=second()-t0
      write(*,*) '      Time        Mflop/s'
      write(*,*) t1,ops1/t1
      write(*,*) t2,ops2/t2
c                                                         
c     verify results.               
c
       do i=1,n
        v=1.0
        derr=abs(v-x(i))
        if(derr.gt.eps) write(*,*) "Error i=",i," diff=",derr
       enddo
c
c  ** count-up the number of pivoting occured ***           
      npvt=0                                                 
      do i=1,n                                           
        if(ipvt(i).ne.i) npvt=npvt+1                         
      enddo                                               
      write(6,39) npvt                                      
c
      stop
   39 format('   number of pivoting occured',i7)             
      end   
      subroutine dcompr (a,lda,n,ipvt,d)    
c***********************************************     
c     dcompr : triangular decomposition           
c          using right-looking block lu algorithm.
c***********************************************
      implicit double precision (a-h,o-z)     
      dimension a(lda,n),ipvt(n),d(*)                                 
      common /systm2/ lvs,ncache,ncline  
c                                                                     
      call dcoblk (n,nx)
      p=ncache*0.5
      np=p
      ll=(np/nx)/ncline*ncline
      totfp=0.d0      
      write(6,4989) nx,ll
      mosout=(n-1)/nx+1 
c===============================================
c  this loop is for recursive formulation.
       do kk=1,mosout 
        j1=(kk-1)*nx+1  
        j2=min(n,j1+nx-1)
c **************************************************
c     flops count 
c      xflop1 : pivot block (column j1 to j2 decomposition) 
c      xflop2 : right upper factor (dfwdsm)
c      xflop3 : right lower square matrix update (dmpysb2)
        nf=n-j2
        mf=j2-j1+1                
        xflop1=(2*mf*mf*mf/3.d0+nf*mf*(mf+1.d0))*1.d-6
        xflop2=nf*mf*(mf-1.d0)*1.d-6
        xflop3=nf*nf*mf*2.d-6
        totfp=totfp+xflop1+xflop2+xflop3
c **************************************************
c   pivot block decomposed by dcomp2
        call dcomp2 (a,lda,n,ipvt,j1,j2)           
        if(n-j2.gt.0) then                                          
c  ** permutations left ** 
         do j=j2+1,n
          call dperm (a(1,j),j1,j2,ipvt)
         enddo 
c  ** upper triangular factor to be completed.              
         ldd=j2-j1
         if(iand(ldd,1).eq.1) ldd=ldd+1
         call dtcomp (a,lda,j1,j2,d,ldd)
         call dfwdsm (d,ldd,j2-j1,a(j1,j2+1),lda,n-j2)
c   ** right lower submatrix update 
c   ------------------------------------------------------------
         call dmpysb2 (a(j2+1,j1),lda,a(j1,j2+1),lda
     *                ,a(j2+1,j2+1),lda,n-j2,j2-j1+1,n-j2,d,ll)
c   ------------------------------------------------------------
c        call dgemm   ('N','N',n-j2,n-j2,j2-j1+1,-1.d0,
c    *                 a(j2+1,j1),lda,a(j1,j2+1),lda,1.d0,
c    *                 a(j2+1,j2+1),lda)
c   ------------------------------------------------------------
        endif
c                                                                
       enddo                  
c===============================================       
       write(6,4990) totfp     
 4989 format (' message from dcompr  blocksize =',i3,'   ll =',i4) 
 4990 format('  total flop count ',e13.4,' mega flops') 
c
      return
      end
      subroutine dcoblk (n,nx)    
c***********************************************     
      implicit doubleprecision (a-h,o-z)     
      common /systm2/ lvs,ncache,ncline   
      data nway/8/
c       
      x=ncache*0.8
c     x=ncache
      x=sqrt(x)  
      m=x
      nx=min(m,n)
      if(nx.ne.n) nx=(nx/nway)*nway
      return 
      end
      subroutine dtcomp  (a,lda,j1,j2,d,ldd)
      implicit double precision (a-h,o-z)
      dimension a(lda,j2),d(ldd,j2)
c
       do j=j1,j2-1
         do i=j+1,j2
          d(i-j1,j-j1+1)=a(i,j)
         enddo
       enddo
      return
      end
      subroutine dperm (a,k1,k2,ipvt)
      implicit doubleprecision (a-h,o-z)     
      dimension a(*),ipvt(k2)
       do k=k1,k2
        l=ipvt(k)
          t=a(k)
          a(k)=a(l)
          a(l)=t
       enddo
      return
      end
      subroutine dmpysb2 (a,lda,b,ldb,c,ldc,l,m,n,d,ll)
      implicit double precision (a-h,o-z)
      dimension a(lda,m),b(ldb,n),c(ldc,n),d(*)
c
c     cij <= cij - sum(aik * bkj) , sum is k=1,m,  i=1,l, j=1,n 
c 
       do ii=1,l,ll
        ls=min(l-ii+1,ll)
c       if(mod(ls,2).eq.0) ldd=ldd+1
c   
c     Data compaction:  Submatrix of A is made compaction into D.    
c   
        ind=0
         do k=1,m
           do i=1,ls
            d(ind+i)=a(ii-1+i,k)
           enddo
          ind=ind+ls
         enddo          
c
       call dmpylav(d,b,ldb,c(ii,1),ldc,ls,m,n)
c   
       enddo
      return
      end
      subroutine dmpylav(a,b,ldb,c,ldc,l,m,n)
      implicit double precision (a-h,o-z)
      dimension a(l,m),b(ldb,n),c(ldc,n)
c
c==========================================================
c  outer two loops are unrolled 4 by 4 ways  
c  
c  software unrolling is applied.
c
c    '-O -qarch=pwr3'
c
      mn=mod(n,4)
      ml=mod(l,4)
       do j=1,mn
         do i=1,l
           do k=1,m
            c(i,j)=c(i,j)-a(i,k)*b(k,j)
           enddo
         enddo
       enddo
c
       do j=mn+1,n
         do i=1,ml
           do k=1,m
            c(i,j)=c(i,j)-a(i,k)*b(k,j)
           enddo
         enddo
       enddo
       do j=mn+1,n,4
         do i=ml+1,l,4
          t00=c(i,j)
          t10=c(i+1,j)
          t20=c(i+2,j)
          t30=c(i+3,j)
          t01=c(i,j+1)
          t11=c(i+1,j+1)
          t21=c(i+2,j+1)
          t31=c(i+3,j+1)
          t02=c(i,j+2)
          t12=c(i+1,j+2)
          t22=c(i+2,j+2)
          t32=c(i+3,j+2)
          t03=c(i,j+3)
          t13=c(i+1,j+3)
          t23=c(i+2,j+3)
          t33=c(i+3,j+3)
c
          a0=a(i,1)
          a1=a(i+1,1)
          a2=a(i+2,1)
          a3=a(i+3,1)
          b0=b(1,j)  
          b1=b(1,j+1)  
          b2=b(1,j+2)  
          b3=b(1,j+3)  
          t00=t00-a0*b0
          t10=t10-a1*b0  
          t20=t20-a2*b0
          t30=t30-a3*b0
          t01=t01-a0*b1  
          t11=t11-a1*b1  
          t21=t21-a2*b1  
          t31=t31-a3*b1  
           do k=1,m-1
            b0=b(k+1,j)  
            b1=b(k+1,j+1)  
            t02=t02-a0*b2  
            t12=t12-a1*b2  
            t22=t22-a2*b2  
            t32=t32-a3*b2  
            t03=t03-a0*b3  
            t13=t13-a1*b3  
            t23=t23-a2*b3  
            t33=t33-a3*b3  
            a0=a(i,k+1)
            a1=a(i+1,k+1)
            a2=a(i+2,k+1)
            a3=a(i+3,k+1)
            b2=b(k+1,j+2)  
            b3=b(k+1,j+3)  
            t00=t00-a0*b0
            t10=t10-a1*b0  
            t20=t20-a2*b0
            t30=t30-a3*b0
            t01=t01-a0*b1  
            t11=t11-a1*b1
            t21=t21-a2*b1
            t31=t31-a3*b1
           enddo
          t02=t02-a0*b2  
          t12=t12-a1*b2  
          t22=t22-a2*b2  
          t32=t32-a3*b2  
          t03=t03-a0*b3  
          t13=t13-a1*b3  
          t23=t23-a2*b3  
          t33=t33-a3*b3  
          c(i,j)    =t00
          c(i+1,j)  =t10
          c(i+2,j)  =t20
          c(i+3,j)  =t30
          c(i,j+1)  =t01
          c(i+1,j+1)=t11
          c(i+2,j+1)=t21
          c(i+3,j+1)=t31
          c(i,j+2)  =t02
          c(i+1,j+2)=t12
          c(i+2,j+2)=t22
          c(i+3,j+2)=t32
          c(i,j+3)  =t03
          c(i+1,j+3)=t13
          c(i+2,j+3)=t23
          c(i+3,j+3)=t33
         enddo
       enddo
c
      return
      end
      subroutine dcomp2 (a,lda,n,ipvt,j1,j2)     
c***********************************************                       
c     dcomp2 : called from dcompr or dcompl 
c     dcomp2 has a capability to decompose A to L & U  
c        by itself (j1=1, and j2=n)       
c***********************************************                     
      implicit double precision (a-h,o-z)
      dimension a(lda,n),ipvt(n)
c                                                              
      l=idamax(n-j1+1,a(j1,j1),1)+j1-1
      ipvt(j1)=l
       if(l.ne.j1) then
        t=a(l,j1)
        a(l,j1)=a(j1,j1)
        a(j1,j1)=t
       endif
      call dscal (n-j1,1.d0/a(j1,j1),a(j1+1,j1),1)
c   --------------------------------------------------------
       do j=j1+1,j2-1,2
c     ---  apply p(j1:j-1) to a(,j),a(,j+1)  ---
        call dperm (a(1,j),j1,j-1,ipvt)
        call dperm (a(1,j+1),j1,j-1,ipvt)
c     --- a(,j)^(0),a(,j+1)^(0) ==> a(,j)^(j-1),a(,j+1)^(j-1)
        call dfwds2 (a(j1,j1),lda,j-j1+1,a(j1,j),lda)
        if(n-j.gt.0) call dmpys2 (a(j+1,j1),lda,a(j1,j),lda
     *                             ,a(j+1,j),lda,n-j,j-j1) 
c     --- p(j)   ---
        l=idamax(n-j+1,a(j,j),1)+j-1
        ipvt(j)=l
c     ---  apply p(j) to a(,j1),...,a(,j+1)  ---
         if(l.ne.j) call dswap(j-j1+2,a(j,j1),lda,a(l,j1),lda)
c     --- a(,j) ==> a(,j)/a(j,j)  and a(,j+1)^(j-1) ==> a(,j+1)^(j)
        t=1.d0/a(j,j)
        s=a(j,j+1)
         do i=j+1,n
          a(i,j)=t*a(i,j)
          a(i,j+1)=a(i,j+1)-s*a(i,j)
         enddo
c     --- p(j+1)   ---
        l=idamax(n-j,a(j+1,j+1),1)+j
        ipvt(j+1)=l
c     ---  apply p(j+1) to a(,j1),...,a(,j+1)  ---
        if(l.ne.j+1) call dswap(j-j1+2,a(j+1,j1),lda,a(l,j1),lda)
c     --- a(,j+1) ==> a(,j+1)/a(j+1,j+1) 
        call dscal (n-j-1,1.d0/a(j+1,j+1),a(j+2,j+1),1)
       enddo
c   --------------------------------------------------------
c
       if(iand(j2-j1,1).eq.1) then
        call dperm (a(1,j2),j1,j2-1,ipvt)
        call dfwdst (a(j1,j1),lda,j2-j1+1,a(j1,j2))
        if(n-j2.gt.0) call dmpys (a(j2+1,j1),lda,a(j1,j2)
     *                           ,a(j2+1,j2),n-j2,j2-j1) 
        l=idamax(n-j2+1,a(j2,j2),1)+j2-1
        ipvt(j2)=l
        if(l.ne.j2) call dswap(j2-j1+1,a(j2,j1),lda,a(l,j1),lda)
        call dscal (n-j2,1.d0/a(j2,j2),a(j2+1,j2),1)
       endif
c
      return
      end
      subroutine dsbpcs (a,lda,n,ipvt,x) 
c***********************************************
c     substitute for single vector    
c      block pcs (partial column swap)
c***********************************************   
      parameter (nway=8)                     
      implicit double precision (a-h,o-z)    
      dimension a(lda,n),x(n),ipvt(n)   
      common /system/ lvs,ncache   
c 
      call dcoblk (n,nx)
      mosout=(n-1)/nx+1                                 
c-------forward pass----------------------------  
       do kk=1,mosout        
        i1=(kk-1)*nx+1          
        i2=min(n,i1+nx-1)        
        call dperm (x,i1,i2,ipvt)   
c    --------------------------------  
        call dfwdst (a(i1,i1),lda,i2-i1+1,x(i1))  
        if(i2.lt.n)call dmpys(a(i2+1,i1),lda,x(i1),x(i2+1),n-i2,i2-i1+1)
       enddo
c-------backward pass--------------------------- 
       do kk=1,mosout
        i2=n-(kk-1)*nx                           
        i1=max(1,i2-nx+1)                        
        call dbwdst (a(i1,i1),lda,i2-i1+1,x(i1))  
        if(i1.gt.1) call dmpys (a(1,i1),lda,x(i1),x(1),i1-1,i2-i1+1) 
       enddo
      return 
      end
      subroutine dfwdsm (a,lda,l,x,ldx,n)
      implicit double precision (a-h,o-z)
      dimension a(lda,l),x(ldx,n)
c
c   triangular system solve for multiple columns
c
c     X = A**(-1) * X
c
c        do j=1,n
c          do i=1,l
c           s=x(i+1,j)
c            do k=1,i
c             s=s-a(i,k)*x(k,j)
c            enddo
c           x(i+1,j)=s
c          enddo
c        enddo
c
       if(iand(l,1).eq.0) then
         do j=1,n-1,2
           do i=1,l-1,2
            s00=x(i+1,j)
            s10=x(i+2,j)
            s01=x(i+1,j+1)
            s11=x(i+2,j+1)
             do k=1,i-1,2
              s00=s00-a(i,  k)*x(k,j)-a(i  ,k+1)*x(k+1,j)
              s10=s10-a(i+1,k)*x(k,j)-a(i+1,k+1)*x(k+1,j)
              s01=s01-a(i,  k)*x(k,j+1)-a(i  ,k+1)*x(k+1,j+1)
              s11=s11-a(i+1,k)*x(k,j+1)-a(i+1,k+1)*x(k+1,j+1)
             enddo
            s00=s00-a(i,  i)*x(i,j)
            s10=s10-a(i+1,i)*x(i,j)
            s01=s01-a(i,  i)*x(i,j+1)
            s11=s11-a(i+1,i)*x(i,j+1)
            x(i+1,j)  =s00
            x(i+2,j)  =s10-a(i+1,i+1)*s00
            x(i+1,j+1)=s01
            x(i+2,j+1)=s11-a(i+1,i+1)*s01
           enddo 
         enddo 
       else 
         do j=1,n-1,2
          x(2,j)  =x(2,j)  -a(1,1)*x(1,j)
          x(2,j+1)=x(2,j+1)-a(1,1)*x(1,j+1)
           do i=2,l-1,2
            s00=x(i+1,j)
            s10=x(i+2,j)
            s01=x(i+1,j+1)
            s11=x(i+2,j+1)
             do k=1,i-1,2
              s00=s00-a(i,  k)*x(k,j)-a(i  ,k+1)*x(k+1,j)
              s10=s10-a(i+1,k)*x(k,j)-a(i+1,k+1)*x(k+1,j)
              s01=s01-a(i,  k)*x(k,j+1)-a(i  ,k+1)*x(k+1,j+1)
              s11=s11-a(i+1,k)*x(k,j+1)-a(i+1,k+1)*x(k+1,j+1)
             enddo
            x(i+1,j)  =s00
            x(i+2,j)  =s10-a(i+1,i+1)*s00
            x(i+1,j+1)=s01
            x(i+2,j+1)=s11-a(i+1,i+1)*s01
           enddo 
         enddo 
       endif
c
       if(iand(n,1).eq.1) then
         do i=1,l
           do k=1,i
            x(i+1,n)=x(i+1,n)-a(i,k)*x(k,n)
           enddo
         enddo
       endif
      return
      end   
      subroutine dfwds2 (a,lda,n,x,ldx)
      implicit double precision (a-h,o-z)
      dimension a(lda,n),x(ldx,2)
c
c      do i=2,n
c       t0=x(i,1)
c       t1=x(i,2)
c        do k=1,i-1
c         t0=t0-a(i,k)*x(k,1)
c         t1=t1-a(i,k)*x(k,2)
c        enddo
c       x(i,1)=t0
c       x(i,2)=t1
c      enddo
c
      if(n.le.1) return
      x(2,1)=x(2,1)-a(2,1)*x(1,1)
      x(2,2)=x(2,2)-a(2,1)*x(1,2)
       do i=3,n-1,2
        t00=x(i,1)
        t01=x(i,2)
        t10=x(i+1,1)
        t11=x(i+1,2)
         do k=1,i-2,2
          t00=t00-a(i,  k)*x(k,1)-a(i,  k+1)*x(k+1,1)
          t01=t01-a(i,  k)*x(k,2)-a(i,  k+1)*x(k+1,2)
          t10=t10-a(i+1,k)*x(k,1)-a(i+1,k+1)*x(k+1,1)
          t11=t11-a(i+1,k)*x(k,2)-a(i+1,k+1)*x(k+1,2)
         enddo
        x(i,1)=t00
        x(i,2)=t01
        x(i+1,1)=t10-a(i+1,i)*t00
        x(i+1,2)=t11-a(i+1,i)*t01
       enddo
      if(iand(n-2,1).eq.1) then
       t00=x(n,1)
       t01=x(n,2)
        do k=1,n-1
         t00=t00-a(n,k)*x(k,1)
         t01=t01-a(n,k)*x(k,2)
        enddo
       x(n,1)=t00
       x(n,2)=t01
      endif
c
      return
      end
      subroutine dfwdst (a,lda,n,x)
      implicit double precision (a-h,o-z)
      dimension a(lda,n),x(n)
c
c      do i=2,n
c       t=x(i)
c        do k=1,i-1
c         t=t-a(i,k)*x(k)
c        enddo
c       x(i)=t
c      enddo
c
      if(n.le.1) return
      x(2)=x(2)-a(2,1)*x(1)
       do i=3,n-1,2
        t0=x(i)
        t1=x(i+1)
         do k=1,i-2,2
          t0=t0-a(i,  k)*x(k)-a(i  ,k+1)*x(k+1)
          t1=t1-a(i+1,k)*x(k)-a(i+1,k+1)*x(k+1)
         enddo
        x(i)=t0
        x(i+1)=t1-a(i+1,i)*t0
       enddo
      if(iand(n-2,1).eq.1) then
       do k=1,n-1
        x(n)=x(n)-a(n,k)*x(k)
       enddo
      endif
c
      return
      end
      subroutine dbwdst (a,lda,n,x)
      implicit double precision (a-h,o-z)
      dimension a(lda,n),x(n)
       do k=n,1,-1
        s=0.d0
         do i=k+1,n
          s=s+a(k,i)*x(i)
         enddo
        x(k)=(x(k)-s)/a(k,k)
       enddo
      return
      end
      subroutine dmpys2 (a,lda,x,ldx,y,ldy,m,n)
      implicit double precision (a-h,o-z)
      dimension a(lda,n),x(ldx,2),y(ldy,2)
c
c     call dmpys (a,lda,x(1,1),y(1,1),m,n)
c     call dmpys (a,lda,x(1,2),y(1,2),m,n)
c
       do i=1,m-1,2
        t00=y(i,1)
        t01=y(i,2)
        t10=y(i+1,1)
        t11=y(i+1,2)
         do k=1,n
          t00=t00-a(i,  k)*x(k,1)
          t01=t01-a(i,  k)*x(k,2)
          t10=t10-a(i+1,k)*x(k,1)
          t11=t11-a(i+1,k)*x(k,2)
         enddo
        y(i,1)=t00
        y(i,2)=t01
        y(i+1,1)=t10
        y(i+1,2)=t11
       enddo
c
       if(mod(m,2).eq.1) then
        do k=1,n
         y(m,1)=y(m,1)-a(m,k)*x(k,1)
         y(m,2)=y(m,2)-a(m,k)*x(k,2)
        enddo    
       endif
c         
      return
      end 
      SUBROUTINE dmvmul (a,lda,m,n,x,y)
      double precision a(lda,n),x(*),y(*)
       do I=1,m
         do J=1,n
          y(i)=y(i)+A(i,J)*X(J)  
         enddo
       enddo
      return
      END
      subroutine dmpys (a,lda,x,y,m,n)
      implicit double precision (a-h,o-z)
      dimension a(lda,n),x(n),y(m)
       do I=1,m
         do J=1,n
          y(i)=y(i)-A(i,J)*X(J)  
         enddo
       enddo
      return
      end
      SUBROUTINE setfrank (a,lda,n)        !  set Frank matrix of order n
      double precision a(lda,n)
       do j=1,n
         do i=1,n
          a(i,j)=n-max(i,j)+1
c         a(i,j)=max(i,j)
         enddo
       enddo
      return
      END
      SUBROUTINE setrandm (a,lda,n)        !  set Ramdom matrix of order n
      double precision a(lda,n)
c     call srand48(68111)                  !  dranf2c.c
      integer*8 iseed
c     iseed=68111
      iseed=111
       do j=1,n
         do i=1,n
          a(i,j)=ddrand(iseed)
         enddo
       enddo
      return
      END
      DOUBLE PRECISION FUNCTION ddrand(iseed)
      implicit double precision (a-h,o-z)
      integer*8 iseed,k,iirand
      k=iirand(iseed)
      ddrand=dble(dble(k)/dble(2147483647))
      return
      end
      FUNCTION iirand(iseed) ! multiplicative congruential generator (I+1) <= (I)*A mod(2^31-1)
      integer*8 iseed,k,m,iirand 
*
*     m=2**31-1   !  Warning in GNU (Integer at (^) too large except as negative number)
      k=iseed*16807
c     iseed=mod(k,m)
      iseed=mod(k,2147483647)
      iirand=iseed
*
      return
      end
      function idamax (n,x,ldx)
c     *******************************
c     ** find abs max element index**
c     *******************************
      double precision x(ldx,n),t
      t=abs(x(1,1))
      ix=1
       do j=2,n
        if(abs(x(1,j)).gt.t) then
         ix=j         
         t=abs(x(1,j))
        endif
       enddo  
      idamax=ix 
      return
      end
      subroutine dswap (n,x,ldx,y,ldy)
c     *******************************
c     ** vector swapping : x<->y  ***
c     *******************************
      double precision x(ldx,n),y(ldy,n),t
       do j=1,n
        t=x(1,j)
        x(1,j)=y(1,j)
        y(1,j)=t
       enddo   
      return
      end
      subroutine dscal (n,a,x,ldx)
c     *******************************
c     ** vector scaling  : x=a*x  ***
c     *******************************
      double precision x(ldx,n),a
       do j=1,n
        x(1,j)=a*x(1,j)
       enddo    
      return
      end

