c
c     g77 -O mmmul.f (second.o)
c     echo 500 4000 0 | ./a.exe
c
      parameter (nsz=500)
      implicit double precision (a-h,o-z)
      dimension a(nsz,nsz),b(nsz,nsz),c(nsz,nsz),w(65536)
      common/systm2/ncache
      common/stpwchx/xtime(50),xmflop(50) 
c
      write(*,*) 'Input N, ncache, iwhich  N is less than',nsz
      read (*,*)        n,ncache,iwhich
      xn=n
      flopc=(2.d0*xn*xn*xn)/1.d6
      call dgegen (a,nsz,n,1)
      call dgegen (b,nsz,n,-1)
      call cleard (c,nsz*n)
      call stpwch0 (1)
      call stpwch1 (1)
      If(iwhich.eq.0) then
       call dmpyad0(a,nsz,b,nsz,c,nsz,n,n,n)
      Elseif(iwhich.eq.1) then
       call dmpyad1(a,nsz,b,nsz,c,nsz,n,n,n,w)
      Elseif(iwhich.eq.2) then
       call dmpyad2(a,nsz,b,nsz,c,nsz,n,n,n,w)
      Else
       call dmpyad3(a,nsz,b,nsz,c,nsz,n,n,n,w)
      Endif
      call stpwch2 (1,flopc)
      call stpwch3 (1)
      ermax=0.d0
      do j=1,n
        do i=1,n
          val=c(i,j)
          if(i.eq.j) val=val-1.d0
          if(abs(val).gt.ermax) ermax=abs(val)
        enddo
      enddo
      write(*,*) 'max error=',ermax
      stop
      end
      subroutine dmpyad0(a,lda,b,ldb,c,ldc,l,m,n)
      implicit double precision (a-h,o-z)
      dimension a(lda,m),b(ldb,n),c(ldc,n)
        do j=1,n
          do i=1,l
            do k=1,m
             c(i,j)=c(i,j)+a(i,k)*b(k,j)
            enddo
          enddo
        enddo
      return
      end  
      subroutine dmpyad1(a,lda,b,ldb,c,ldc,l,m,n,d)
      implicit double precision (a-h,o-z)
      dimension a(lda,m),b(ldb,n),c(ldc,n),d(*)
      common /systm2/ncache
c
c     Cij <= Cij - + Sum(Aik * Bkj) , Sum is k=1,m,  i=1,l, j=1,n 
c 
c    nef : effictive size of data cache,  lsect : section size for 'i'.
      ienter=0
   10 continue
      nef=ncache*0.7d0 
      t=nef
      lsect=sqrt(t)/2
      lsect=lsect*2
c    matrix division l and m are divided smaller, they become ll and mm.
      ll=min(l,lsect)
      mm=min(m,(nef/ll)/2*2)
       if(l*m.le.nef) then
        ll=l
        mm=m
       endif
c
       do kk=1,m,mm 
        ms=min(m-kk+1,mm)
         do ii=1,l,ll
          ls=min(l-ii+1,ll)
c
           if(ls.eq.lda) then
            if(ienter.eq.0) then
             call dmpy21 (a(ii,kk),b(kk,1),ldb,c(ii,1),ldc,ls,ms,n)
            else
             call dmpy22 (a(ii,kk),b(kk,1),ldb,c(ii,1),ldc,ls,ms,n)
            endif
           else          
c   
c        data compaction  submatrix of A is made compaction into d    
c   
            ind=0
             do k=1,ms
               do i=1,ls
                ind=ind+1
                d(ind)=a(ii-1+i,kk-1+k)
               enddo
             enddo     
c
            if(ienter.eq.0) then
             call dmpy21 (d,b(kk,1),ldb,c(ii,1),ldc,ls,ms,n)
            else
             call dmpy22 (d,b(kk,1),ldb,c(ii,1),ldc,ls,ms,n)
            endif
c   
           endif
c   
         enddo
       enddo
      return
c
      entry  dmpyad2(a,lda,b,ldb,c,ldc,l,m,n,d)
      ienter = 1
      go to 10
      end  
      subroutine dmpy21 (a,b,ldb,c,ldc,l,m,n)
      implicit double precision (a-h,o-z)
      dimension a(l,m),b(ldb,n),c(ldc,n)
c
c     Cij <= Cij + Sum(Aik * Bkj) , Sum is k=1,m,  i=1,l, j=1,n
c
c      do j=1,n
c        do i=1,l
c          do k=1,m
c           c(i,j)=c(i,j)+a(i,k)*b(k,j)
c          enddo
c        enddo
c      enddo
c  This loop is unrolled to 2 by 2 ways for RS/6000 performance
c
       do j=1,n-1,2
         do i=1,l-1,2
          t00=c(i,j)
          t10=c(i+1,j)
          t01=c(i,j+1)
          t11=c(i+1,j+1)
           do k=1,m
            t00=t00+a(i,k)  *b(k,j)
            t10=t10+a(i+1,k)*b(k,j)
            t01=t01+a(i,k)  *b(k,j+1)
            t11=t11+a(i+1,k)*b(k,j+1)
           enddo
          c(i,j)    =t00
          c(i+1,j)  =t10
          c(i,j+1)  =t01
          c(i+1,j+1)=t11
         enddo
c
         if(mod(l,2).eq.1) then
          t00=c(l,j)
          t01=c(l,j+1)
           do k=1,m
            t00=t00+a(l,k)*b(k,j)
            t01=t01+a(l,k)*b(k,j+1)
           enddo
          c(l,j  )=t00
          c(l,j+1)=t01
         endif
       enddo
c
       if(mod(n,2).eq.1) then
        do i=1,l
          do k=1,m
           c(i,n)=c(i,n)+a(i,k)*b(k,n)
          enddo
        enddo
       endif
c
      return
      end
      subroutine dmpy22 (a,b,ldb,c,ldc,l,m,n)
      implicit double precision (a-h,o-z)
      dimension a(l,m),b(ldb,n),c(ldc,n)
c
c     Cij <= Cij + Sum(Aik * Bkj) , Sum is k=1,m,  i=1,l, j=1,n 
c
c       do j=1,n
c         do i=1,l
c           do k=1,m
c            c(i,j)=c(i,j)+a(i,k)*b(k,j)
c           enddo
c         enddo
c       enddo
c  This loop is unrolled to 2 by 2 ways
c
       do j=1,n-1,2
         do i=1,l-1,2
          t00=c(i,j)
          t10=c(i+1,j)
          t01=c(i,j+1)
          t11=c(i+1,j+1)
           do k=1,m-1,2
            t00=t00+a(i,k)  *b(k,j)  +a(i,k+1)  *b(k+1,j)
            t10=t10+a(i+1,k)*b(k,j)  +a(i+1,k+1)*b(k+1,j)
            t01=t01+a(i,k)  *b(k,j+1)+a(i,k+1)  *b(k+1,j+1)
            t11=t11+a(i+1,k)*b(k,j+1)+a(i+1,k+1)*b(k+1,j+1)
           enddo
           if(iand(m,1).eq.1) then
            c(i,j)    =t00+a(i,m)  *b(m,j)
            c(i+1,j)  =t10+a(i+1,m)*b(m,j)  
            c(i,j+1)  =t01+a(i,m)  *b(m,j+1)
            c(i+1,j+1)=t11+a(i+1,m)*b(m,j+1)
           else 
            c(i,j)    =t00
            c(i+1,j)  =t10
            c(i,j+1)  =t01
            c(i+1,j+1)=t11
           endif
         enddo
c       
         if(mod(l,2).eq.1) then
          t00=c(l,j)
          t01=c(l,j+1)
           do k=1,m
            t00=t00+a(l,k)*b(k,j)
            t01=t01+a(l,k)*b(k,j+1)
           enddo
          c(l,j  )=t00
          c(l,j+1)=t01
         endif
       enddo
c
       if(mod(n,2).eq.1) then
        do i=1,l
          do k=1,m
           c(i,n)=c(i,n)+a(i,k)*b(k,n)
          enddo
        enddo
       endif
c
      return
      end
      subroutine dmpyad3(a,lda,b,ldb,c,ldc,l,m,n,d)
      implicit double precision (a-h,o-z)
      dimension a(lda,m),b(ldb,n),c(ldc,n),d(*)
      common /systm2/ncache
c
c     Cij <= Cij - + Sum(Aik * Bkj) , Sum is k=1,m,  i=1,l, j=1,n 
c 
c    nef : effictive size of data cache,  lsect : section size for 'i'.
      ienter=0
   10 continue
      nef=ncache*0.7d0 
      t=nef
      lsect=sqrt(t)/2
      lsect=lsect*2
c    matrix division l and m are divided smaller, they become ll and mm.
      ll=min(l,lsect)
      mm=min(m,(nef/ll)/2*2)
       if(l*m.le.nef) then
        ll=l
        mm=m
       endif
c
       do kk=1,m,mm 
        ms=min(m-kk+1,mm)
         do ii=1,l,ll
          ls=min(l-ii+1,ll)
c
           if(ls.eq.lda) then
             call dmpypw3 (a(ii,kk),b(kk,1),ldb,c(ii,1),ldc,ls,ms,n)
           else          
c   
c        data compaction  submatrix of A is made compaction into d    
c   
            ind=0
             do k=1,ms
               do i=1,ls
                ind=ind+1
                d(ind)=a(ii-1+i,kk-1+k)
               enddo
             enddo     
c
             call dmpypw3 (d,b(kk,1),ldb,c(ii,1),ldc,ls,ms,n)
c   
           endif
c   
         enddo
       enddo
      return
      end
      subroutine dmpypw3(a,b,ldb,c,ldc,l,m,n)
      implicit double precision (a-h,o-z)
      dimension a(l,m),b(ldb,n),c(ldc,n)
c
c==========================================================
c  outer two loops are unrolled 4 by 4 ways  
c  
c  software pipelining is applied.
c
      mn=mod(n,4)
      ml=mod(l,4)
       do j=1,mn
         do i=1,l
           do k=1,m
            c(i,j)=c(i,j)+a(i,k)*b(k,j)
           enddo
         enddo
       enddo
c
       do j=mn+1,n
         do i=1,ml
           do k=1,m
            c(i,j)=c(i,j)+a(i,k)*b(k,j)
           enddo
         enddo
       enddo
       do j=mn+1,n,4
         do i=ml+1,l,4
          t00=c(i,j);   t10=c(i+1,j);   t20=c(i+2,j);   t30=c(i+3,j)
          t01=c(i,j+1); t11=c(i+1,j+1); t21=c(i+2,j+1); t31=c(i+3,j+1)
          t02=c(i,j+2); t12=c(i+1,j+2); t22=c(i+2,j+2); t32=c(i+3,j+2)
          t03=c(i,j+3); t13=c(i+1,j+3); t23=c(i+2,j+3); t33=c(i+3,j+3)
          a0=a(i,1); a1=a(i+1,1); a2=a(i+2,1); a3=a(i+3,1)
          b0=b(1,j); b1=b(1,j+1); b2=b(1,j+2); b3=b(1,j+3)  
          t00=t00+a0*b0; t10=t10+a1*b0; t20=t20+a2*b0; t30=t30+a3*b0
          t01=t01+a0*b1; t11=t11+a1*b1; t21=t21+a2*b1; t31=t31+a3*b1  
           do k=1,m-1
            b0=b(k+1,j); b1=b(k+1,j+1)  
            t02=t02+a0*b2; t12=t12+a1*b2; t22=t22+a2*b2; t32=t32+a3*b2  
            t03=t03+a0*b3; t13=t13+a1*b3; t23=t23+a2*b3; t33=t33+a3*b3  
            a0=a(i,k+1); a1=a(i+1,k+1); a2=a(i+2,k+1); a3=a(i+3,k+1)
            b2=b(k+1,j+2) ; b3=b(k+1,j+3)  
            t00=t00+a0*b0; t10=t10+a1*b0; t20=t20+a2*b0; t30=t30+a3*b0
            t01=t01+a0*b1; t11=t11+a1*b1; t21=t21+a2*b1; t31=t31+a3*b1
           enddo
          t02=t02+a0*b2; t12=t12+a1*b2; t22=t22+a2*b2; t32=t32+a3*b2  
          t03=t03+a0*b3; t13=t13+a1*b3; t23=t23+a2*b3; t33=t33+a3*b3  
          c(i,j)=t00; c(i+1,j)=t10; c(i+2,j)=t20; c(i+3,j)  =t30
          c(i,j+1)=t01; c(i+1,j+1)=t11; c(i+2,j+1)=t21; c(i+3,j+1)=t31
          c(i,j+2)=t02; c(i+1,j+2)=t12; c(i+2,j+2)=t22; c(i+3,j+2)=t32
          c(i,j+3)=t03; c(i+1,j+3)=t13; c(i+2,j+3)=t23; c(i+3,j+3)=t33
         enddo
       enddo
c
      return
      end
      subroutine cleard (darray,n)
c                ------  >      <
c     clear 'darray'
c 
      double precision darray(n)
       do i=1,n
        darray(i)=0.d0
       enddo
      return
      end
      subroutine dgegen (a,lda,n,itype)
      implicit double precision (a-h,o-z)
      dimension a(lda,n)
c
      if(iabs(itype).ne.1) return
c **************************************************
c **  generate (inverse) frank matrix  of order n  *                    
c **************************************************                    
      If(itype.eq.1) Then
       do j=1,n                                                         
         do i=1,n                                                       
          a(i,j)=n+1-max(i,j)                                           
         enddo                                                          
       enddo                                                            
      write(6,1001) n
 1001 format(' dgegen generates Frank matrix  n =',i5)
      Else
       do j=1,n                                                         
         do i=1,n                                                       
          a(i,j)=0.d0                                                   
         enddo                                                          
       enddo                                                            
       do i=2,n                                                         
        a(i,i)=2.d0                                                     
        a(i,i-1)=-1.d0                                                  
        a(i-1,i)=-1.d0                                                  
       enddo                                                            
      a(1,1)=1.d0                                                       
      write(6,2001) n
 2001 format(' dgegen generates inverse of Frank matrix  n =',i5)       
      Endif
      return                                                            
      end
      subroutine stpwch0 (nwatch) 
c************************************************
c     stop-watch initiallization
c************************************************
      implicit double precision (a-h,o-z)  
      common/stpwchx/ xtime(50),xmflop(50) 
      n=min(nwatch,50)  
      do j=1,n         
        xtime(j)=0.d0  
        xmflop(j)=0.d0
      enddo  
      return  
      end 
      subroutine stpwch1 (i) 
c************************************************ 
c     stop-watch for start   
c************************************************ 
      implicit double precision (a-h,o-z)  
      common/stpwchx/ xtime(50),xmflop(50) 
      t2=second()
      xtime(i+10)=t2
      return   
      end 
      subroutine stpwch2(i,ymflop) 
c************************************************ 
c     stop-watch called for stop  
c************************************************ 
      implicit double precision (a-h,o-z)  
      common/stpwchx/ xtime(50),xmflop(50) 
      t2=second()
      xtime(i)=xtime(i)+(t2-xtime(i+10))
      xmflop(i)=xmflop(i)+ymflop    
      return                        
      end 
      subroutine stpwch3(m) 
c************************************************
c     stop-watch result print       
c************************************************
      implicit double precision (a-h,o-z)  
      common/stpwchx/ xtime(50),xmflop(50) 
      mn=min(m,50)                   
      write(*,90)  mn               
      do j=1,mn 
        if(xtime(j).gt.0.d0) then   
          p=xmflop(j)/xtime(j)
          q=xtime(j)  
          write(6,91) j,q,p   
        end if      
      enddo
      return        
c                 
   90 format(//,'  time measured   no. of stop-watches ',i2,/,  
*    *'   no.           CPU  sec         Mflop/s')  
     *'   no.        Elapsed sec         Mflop/s')  
   91 format(i6,e18.4,f17.3)   
      end 
