#
#  perl plotricks.pl 999999 0 999999 0 P66.dat > plotricks.tex
#

@dots=qw( o         triangle square triangle* pentagon square*
          pentagon* otimes   oplus  diamond   diamond* x    );
%$rangex=8; $rangey=8;
$rangex=7; $rangey=7;
$xmin=$ARGV[0]; $xmax=$ARGV[1]; $ymin=$ARGV[2]; $ymax=$ARGV[3]; $filename=$ARGV[4];

open(F,$filename) or die "Cannot open file $filename $!\n";
while(<F>){
    s/^\s+//;
    @w = split /\s+/;
    if($w[0] < $xmin) {$xmin=$w[0];}
    if($w[0] > $xmax) {$xmax=$w[0];}
    if($w[1] < $ymin) {$ymin=$w[1];}
    if($w[1] > $ymax) {$ymax=$w[1];}
}
close F;

$scalex=$rangex/($xmax-$xmin); $scaley=$rangey/($ymax-$ymin);
$xll=$xmin*$scalex; $yll=$ymin*$scaley; $xru=$xmax*$scalex; $yru=$ymax*$scaley;
$xunitm=$rangex/8; $yunitm=$rangey/8; 
$xulabel=($xmax-$xmin)/8; $yulabel=($ymax-$ymin)/8; 

print "\\documentclass{jarticle}\n";
print "\\usepackage{pstricks,pst-plot}\n";
print "\\begin{document}\n";
#print "\\begin{figure}\n";
#print "\\begin{center}\n";
print "\\begin{pspicture}($xll,$yll)($xru,$yru)\n";
print "\\psset{xunit=1cm,yunit=1cm}\n";
print "% xmin=$xmin, ymin=$ymin\n";
print "% xmax=$xmax, ymax=$ymax\n";
print "% scalex=$scalex, scaley=$scaley\n";
printf "\\psaxes[dx=%5.2f\\psxunit,\Dx=%5.2f,Ox=%5.2f,dy=%5.2f\\psyunit,Dy=%5.2f,Oy=%5.2f]
(%5.2f,%5.2f)(%5.2f,%5.2f)(%5.2f,%5.2f)\n",
$xunitm,$xulabel,$xmin,$yunitm,$yulabel,$ymin,$xll,$yll,$xll,$yll,$xru,$yru;

open(F,$filename) or die "Cannot open file $filename $!\n";

print "\\psdots";
$i=0; $linenum=-1;
while(<F>){
    s/^\s+//;
    @w = split /\s+/;
    if($w[0] < $lastx) {
      print "\n"; $i=0; $linenum=$linenum+1;
      print "\\psdots[dotstyle=$dots[$linenum]]";
    }
    $x= $w[0]*$scalex; $y= $w[1]*$scaley;
    printf "(%6.2f, %6.2f)",$x,$y;
    $i=$i+1;
    if($i%10 == 0){
       $i=0; print "\n";
    }
    $lastx=$w[0];
}
print "\n";
print "\\end{pspicture}\n";
#print "\\end{center}\n";
#print "\\end{figure}\n";
print "\\end{document}\n";
