      subroutine dgegen (a,lda,m,n,itype,val)                           
      implicit double precision (a-h,o-z)                               
      dimension a(lda,n)                                                
c                                                                       
      if(iabs(itype).ne.1) go to 10                                     
c **************************************************                    
c **  generate (inverse) frank matrix  of order n  *                    
c **************************************************                    
      if(itype.eq.-1) go to 5                                           
      dnorma=0.0                                                        
       do j=1,n                                                         
         do i=1,n                                                       
          a(i,j)=n+1-max(i,j)                                           
          dnorma=dmax1(dabs(a(i,j)),dnorma)                             
         enddo                                                          
       enddo                                                            
      val=dnorma                                                        
      write(6,1001) n,dnorma                                            
 1001 format(' dgegen generates frank matrix  n =',i5,'  norm=',e12.2)  
      return                                                            
c                                                                       
    5 continue                                                          
       do j=1,n                                                         
         do i=1,n                                                       
          a(i,j)=0.d0                                                   
         enddo                                                          
       enddo                                                            
       do i=2,n                                                         
        a(i,i)=2.d0                                                     
        a(i,i-1)=-1.d0                                                  
        a(i-1,i)=-1.d0                                                  
       enddo                                                            
      a(1,1)=1.d0                                                       
      write(6,2001) n                                                   
 2001 format(' dgegen generates inverse of frank matrix  n =',i5)       
      return                                                            
c                                                                       
c                                                                       
   10 continue                                                          
      if(itype.ne.2) go to 20                                           
c **************************************************                    
c **  generate dr.j.j.dongarra's matrix of order n *                    
c **************************************************                    
      init=1325                                                         
      dnorma=0.0                                                        
      xn=n                                                              
      xn=1.0d0/xn                                                       
       do j=1,n                                                         
         do i=1,n                                                       
          init=mod(3125*init,65536)                                     
          a(i,j)=((init-32768.0)/16384.0)*xn                            
          dnorma=dmax1(dabs(a(i,j)),dnorma)                             
         enddo                                                          
       enddo                                                            
      val=dnorma                                                        
      write(6,1002) n,dnorma                                            
 1002 format(' dgegen generates dongarra matrix  n =',i5,               
     *       '  norm=',e12.2)                                           
      return                                                            
c                                                                       
c                                                                       
   20 continue                                                          
      if(iabs(itype).ne.3) go to 30                                     
c **************************************************                    
c **  generate diagonal matrix order n, a(i,i)=val *                    
c **************************************************                    
      x=val                                                             
      if(itype.eq.-3) x=-1.d0/val                                       
       do j=1,n                                                         
         do i=1,n                                                       
          a(i,j)=0.d0                                                   
         enddo                                                          
        a(j,j)=x                                                        
       enddo                                                            
      write(6,1003) n,x                                                 
 1003 format(' dgegen generates diagonal matrix  n =',i5,               
     *       '   val=',e12.3)                                           
      return                                                            
c                                                                       
c                                                                       
   30 continue                                                          
c                                                                       
      if(iabs(itype).ne.4) go to 40                                     
c **************************************************                    
c **  generate (inverse) hilbert matrix  of order n  *                  
c **************************************************                    
      if(itype.eq.-4) go to 35                                          
      dnorma=0.0                                                        
       do j=1,n                                                         
         do i=1,n                                                       
          a(i,j)=1.d0/(i+j-1)                                           
          dnorma=dmax1(dabs(a(i,j)),dnorma)                             
         enddo                                                          
       enddo                                                            
      val=dnorma                                                        
      write(6,1004) n,dnorma                                            
 1004 format(' dgegen generates hilbert matrix n =',i5,'  norm=',e12.2) 
      return                                                            
c                                                                       
   35 continue                                                          
   40 continue                                                          
  100 continue                                                          
      if(itype.ne.11) go to 110                                         
c **************************************************                    
c     generate m*n matrix to be decomposed qr,                          
c      q is orthogonal, i.e.,                                           
c         q(i,j)=sin(i*j*t), where t=pai/m                              
c                            q(i,j) is normalized                       
c      r is upper triangular, i.e.,                                     
c         r(i,j)=1.0, for (i.le.j)                                      
c **************************************************                    
c     data pai /3.141592653589793238d0/  18 digits for vs fortran       
c     data pai /3.141592653589793238d0/  16 digits for ieee machine     
      data pai /3.14159265358979324d0/                                  
c     data pai /3.141592653589793d0/                                    
c                                                                       
      xm=m                                                              
      t=pai/(xm+1.d0)                                                   
c                                                                       
       do j=1,n                                                         
        tj=t*j                                                          
        s=0.d0                                                          
          do i=1,m                                                      
           a(i,j)=dsin(i*tj)                                            
           s=s+a(i,j)*a(i,j)                                            
          enddo                                                         
        sinv=1.d0/dsqrt(s)                                              
        sinv=sinv*1.1                                                   
         do i=1,m                                                       
          a(i,j)=sinv*a(i,j)                                            
         enddo                                                          
       enddo                                                            
c      call dmatpr (a,lda,m,n,1,3)                                      
c                                                                       
       do j=2,n                                                         
         do i=1,m                                                       
          a(i,j)=a(i,j)+a(i,j-1)                                        
         enddo                                                          
       enddo                                                            
      write(6,1011) m,n                                                 
 1011 format(' dgegen generates',i5,' *',i5,                            
     *       ' matrix for qr decomposition')                            
      return                                                            
c                                                                       
c                                                                       
  110 continue                                                          
      if(itype.ne.13) go to 200                                         
c **************************************************                    
c     generate m*n matrix with value=val                                
c **************************************************                    
       do j=1,n                                                         
         do i=1,m                                                       
          a(i,j)=val                                                    
         enddo                                                          
       enddo                                                            
c                                                                       
      write(6,1013) m,n,val                                             
 1013 format(' dgegen generates',i5,' *',i5,                            
     *       ' matrix with value=',e12.3)                               
      return                                                            
c                                                                       
  200 continue                                                          
      return                                                            
      end                                                               
      subroutine dgegeb (a,lda,m,n,b)   
      implicit double precision (a-h,o-z)          
      dimension a(lda,n),b(m) 
c                          
       do i=1,m
        b(i)=0.d0
       enddo
c
       do i=1,m
         do j=1,n
          b(i)=b(i)+a(i,j)
         enddo
       enddo
c
      write(6,1)
    1 format(' dgegeb generates b vector')
      return
      end        
      subroutine dmatpr(a,lda,m,n,itype,lvl)
c************************************************                   
c     dmatpr makes matrix print-out                               
c************************************************                      
      implicit double precision (a-h,o-z)                            
      dimension a(lda,n)                                            
      dtmin=1.d+30                                                 
      dtmax=-1.d+30                                                 
      it=iabs(itype)                                               
      itr=0                                                      
      if(itype.lt.0) itr=1                                      
      if(it.ne.1) go to 10                                     
c                                                            
c     rectangular matrix m*n                                            
c                                                                       
      if(lvl.ge.3) go to 5                                              
       do j=1,n                                                         
        call vecchk (a(1,j),1,m,damin,damax)                            
        if(damin.lt.dtmin) dtmin=damin                                  
        if(damax.gt.dtmax) dtmax=damax                                  
        if(lvl.eq.2) write(6,1002) j,damin,damax                        
       enddo                                                            
      if(lvl.eq.1) write(6,1001) dtmin,dtmax                            
      return                                                            
 1001 format('  max and min of matrix  =',2e13.4)                       
 1002 format('  a max and min (col',i4,' )=',2e13.4)                    
c                                                                       
c     in case print out level = 3                                       
c                                                                       
    5 continue                                                          
      if(itr.eq.1) go to 6                                              
       do j=1,n                                                         
        write(6,1003) j                                                 
        write(6,1000) (a(i,j),i=1,m)                                    
       enddo                                                            
 1003 format(6h  col ,i4)                                               
      return                                                            
c                                                                       
c                                                                       
c     in case print out is requested to be transposed                   
c                                                                       
    6 continue                                                          
       do i=1,m                                                         
        write(6,1004) i                                                 
        write(6,1000) (a(i,j),j=1,n)                                    
       enddo                                                            
 1000 format(1h ,10e12.4)                                               
 1004 format(6h  row ,i4)                                               
c                                                                       
c                                                                       
   10 continue                                                          
      if(it.ne.2) go to 20                                              
c                                                                       
c     rectangular matrix m*n,  only upper half is interested            
c                                                                       
      if(lvl.ge.3) go to 15                                             
       do j=1,n                                                         
        call vecchk (a(1,j),1,j,damin,damax)                            
        if(damin.lt.dtmin) dtmin=damin                                  
        if(damax.gt.dtmax) dtmax=damax                                  
        if(lvl.eq.2) write(6,1002) j,damin,damax                        
       enddo                                                            
      if(lvl.eq.1) write(6,1001) dtmin,dtmax                            
      return                                                            
c                                                                       
   15 continue                                                          
       do j=1,n                                                         
        write(6,1003) j                                                 
        write(6,1000) (a(i,j),i=1,j)                                    
       enddo                                                            
      return                                                            
c                                                                       
   20 continue                                                          
      if(it.ne.11) go to 30                                             
c                                                                       
c     triangular matrix in one dimensional array                        
c                                                                       
      call dmatpr1 (a,m,lvl)                                            
   30 continue                                                          
      return                                                            
      end                                                               
      subroutine dmatpr1 (a,n,lvl)                                      
c                                                                       
c     triangular matrix in one dimensional array                        
c                                                                       
      implicit double precision (a-h,o-z)                               
      double precision a(*)                                             
      dtmin=1.d+30                                                      
      dtmax=-1.d+30                                                     
      k2=0                                                              
       do i=1,n                                                         
        k1=k2+1                                                         
        k2=k1+(n-i)                                                     
        if(lvl.eq.3) write(6,1003) i                                    
        if(lvl.eq.3) write(6,1000) (a(k),k=k1,k2)                       
        if(lvl.le.2) call vecchk (a(k1),1,i,damin,damax)                
        if(damin.lt.dtmin) dtmin=damin                                  
        if(damax.gt.dtmax) dtmax=damax                                  
        if(lvl.eq.2) write(6,1002) i,damax,damin                        
       enddo                                                            
      if(lvl.eq.1) write(6,1001) dtmin,dtmax                            
      return                                                            
c                                                                       
c                                                                       
 1000 format(1h ,10e12.4)                                               
 1001 format('  max and min of matrix  =',2f10.4)                       
 1002 format('  a max and min (col',i4,' )=',2f10.4)                    
 1003 format(6h  col ,i4)                                               
c                                                                       
      end                                                               
      subroutine vecchk(a,lda,n,dmin,dmax)                              
c************************************************                       
c     find maximum/minimum element in matrix                            
c************************************************                       
      implicit double precision (a-h,o-z)                               
      double precision a(lda,n)                                         
      dtmin=1.d+30                                                      
      dtmax=-1.d+30                                                     
       do i=1,n                                                         
        if(a(1,i).lt.dtmin) dtmin=a(1,i)                                
        if(a(1,i).gt.dtmax) dtmax=a(1,i)                                
       enddo                                                            
      dmin=dtmin                                                        
      dmax=dtmax                                                        
      return                                                            
      end                                                               
      subroutine matchk(a,lda,m,n,dmin,dmax)                            
c************************************************                       
c     find maximum/minimum element in matrix                            
c************************************************                       
      implicit double precision (a-h,o-z)                               
      double precision a(lda,n)                                         
      dtmin=1.d+30                                                      
      dtmax=-1.d+30                                                     
       do j=1,n                                                         
        call vecchk (a(1,j),1,m,damin,damax)                            
        if(damin.lt.dtmin) dtmin=damin                                  
        if(damax.gt.dtmax) dtmax=damax                                  
       enddo                                                            
      dmin=dtmin                                                        
      dmax=dtmax                                                        
      return                                                            
      end                                                               
      subroutine cleari (iarray,n)
c                ------  >      <
c     clear 'iarray'
c 
      dimension iarray(n)
       do i=1,n
        iarray(i)=0
       enddo
      return
      end
      subroutine cleard (darray,n)
c                ------  >      <
c     clear 'darray'
c 
      double precision darray(n)
       do i=1,n
        darray(i)=0.d0
       enddo
      return
      end
      subroutine icopy (n,ix,incx,iy,incy)
c     *******************************
c     ** vector copy  iy <== ix   ***
c     *******************************
      dimension ix(*),iy(*) 
      jx=1-incx
      jy=1-incy
       do j=1,n
        iy(jy+j*incy)=ix(jx+j*incx)
       enddo    
      return
      end
      subroutine mvseed32 (ia,is,n)
      implicit double precision (a-h,o-z)
      integer*8 is,ibb,itt
c
c     move seed, i.e., s(new) = s(old) * a**n
c
      ib=ia
      it=1
       do i=1,30
        if(iand(n,2**(i-1)).ne.0) then
c                                        t(new)=t(old)*(a**(i-1))
c        call dran46 (b,t,dum,1)
         itt=it
c        call ddrand (ib,itt,dum,1)  ! ddrand -> dmyrand (Sep.8,2006)
         call dmyrand (ib,itt,dum,1)
         it=itt
        endif
c                                        aa=a**(2**i)
c       call dran46 (b,b,dum,1)
        ibb=ib
c       call ddrand (ib,ibb,dum,1)
        call dmyrand (ib,ibb,dum,1)
        ib=ibb
       enddo
c
c     call dran46 (t,s,dum,1)
c     call ddrand (it,is,dum,1)
      call dmyrand (it,is,dum,1)
      return
      end
      subroutine dmyrand(ia,iseed,x,n)
c     subroutine ddrand(ia,iseed,x,n)
      implicit double precision (a-h,o-z)
c     integer*8 iseed,k,iirand
      integer*8 iseed,k,imyrand
      dimension x(n)
       do i=1,n
c       k=iirand(ia,iseed)  !  iirand ==> imyrand (Sep.8,2006)
        k=imyrand(ia,iseed) 
        x(i)=dble(dble(k)/dble(2147483647))
       enddo
      return
      end
      function imyrand(ia,iseed) ! multiplicative congruential generator (I+1) <= (I)*A mod(2^31-1)
c     function iirand(ia,iseed) ! multiplicative congruential generator (I+1) <= (I)*A mod(2^31-1)
c     integer*8 iseed,k,m,iirand               !               A  is  'ia'
      integer*8 iseed,k,m,imyrand               !               A  is  'ia'
*
*     m=2**31-1   !  Warning in GNU (Integer at (^) too large except as negative number)
      m=2147483647
c     k=iseed*16807
      k=iseed*ia
      iseed=mod(k,m)
c     iirand=iseed
      imyrand=iseed
*
      return
      end
      subroutine dhsort (a,n)
c
c     heap-sort 
c       member of length n is sorted in ascending order
c
      implicit double precision (a-h,o-z)
      dimension a(n)
c
      k1=n/2+1
      k2=n
    1  continue
        if(k1.gt.1) then                 ! still in hiring phase.
         k1=k1-1
         ak=a(k1)
        else                             ! in retirement-and-promotion phase.
         ak=a(k2)                        ! clear a space at end of array.
         a(k2)=a(1)                      ! retire the top of the heap into it.
         k2=k2-1
          if(k2.eq.1) then               ! done with the last promotion.
           a(1)=ak                       ! the least competent worker of all!
           return
          endif
        endif
c
       i=k1     ! whether in the hiring phase or promotion phase, we here set up
       j=k1*2   ! to sift down element ak to its proper level.
c
    2   continue
         if(j.lt.k2.and.a(j).lt.a(j+1)) j=j+1 ! compare to the better underling.
         if(ak.lt.a(j)) then                ! demote ak
          a(i)=a(j)
          i=j
          j=j*2
         else                               ! This is mk's level.
          j=k2+1                            ! set j to terminate the shift-down.
         endif
        if(j.le.k2) go to 2
       a(i)=ak                             ! put ak into its slot.
       go to 1
      end
      subroutine dbsort (a,n)
c                ------  < <
      implicit double precision (a-h,o-z)
      dimension a(n)
c
       do j=1,n-1
        x=a(j)
        k=j
         do i=j+1,n
          if(a(i).lt.x) then
           x=a(i)
           k=i
          endif
         enddo
        a(k)=a(j)
        a(j)=x
       enddo
c
      return
      end
      subroutine dsorty (a,n,ind)
c                ------  < < >
      implicit double precision (a-h,o-z)
      dimension a(n),ind(n)
c
       do i=1,n
        ind(i)=i
       enddo
c 
       do j=1,n-1
        x=a(j)
        k=j
         do i=j+1,n
          if(a(i).lt.x) then
           x=a(i)
           k=i
          endif
         enddo
        a(k)=a(j)
        a(j)=x
        m=ind(k)
        ind(k)=ind(j)
        ind(j)=m
       enddo
c
      return
      end
      subroutine ibsort (ia,n)
c                ------  <> <
      implicit double precision (a-h,o-z)
      dimension ia(n)
c
       do j=1,n-1
        ix=ia(j)
        k=j
         do i=j+1,n
          if(ia(i).lt.ix) then
           ix=ia(i)
           k=i
          endif
         enddo
c
        ix=ia(k)
        ia(k)=ia(j)
        ia(j)=ix
       enddo
c
      return
      end
      subroutine isorty (ia,len,n,ind)
c                ------  <  <   < >
      implicit double precision (a-h,o-z)
      dimension ia(len,n),ind(n)
c
       do i=1,n
        ind(i)=i
       enddo
c
       do j=1,n-1
        ix=ia(1,j)
        k=j
         do i=j+1,n
          if(ia(1,i).lt.ix) then
           ix=ia(1,i)
           k=i
          endif
         enddo
c
         do i=1,len
          ix=ia(i,k)
          ia(i,k)=ia(i,j)
          ia(i,j)=ix
         enddo
        m=ind(k)
        ind(k)=ind(j)
        ind(j)=m
       enddo
c
      return
      end
      subroutine ihsort (m,n)
c
c        1         2         3         4         5         6         7 
c2345678901234567890123456789012345678901234567890123456789012345678901234567890
c
c     Integer Heap-SORT 
c       member of length n is sorted in ascending order
c
      dimension m(n)
c
      if(n.le.1) return
c
      k=n/2+1
      ir=n
    1  continue
        if(k.gt.1) then                   ! still in hiring phase.
         k=k-1
         iia=m(k)
        else                              ! in retirement-and-promotion phase.
         iia=m(ir)                        ! clear a space at end of array.
         m(ir)=m(1)                       ! retire the top of the heap into it.
         ir=ir-1
          if(ir.eq.1) then                ! done with the last promotion.
           m(1)=iia                       ! the least competent worker of all!
           return
          endif
        endif
c
       i=k     ! whether in the hiring phase or promotion phase, we here set up
       j=k*2   ! to sift down element iia to its proper level.
c
    2   continue
         if(j.lt.ir.and.m(j).lt.m(j+1)) j=j+1 ! compare to the better underling.
         if(iia.lt.m(j)) then                 ! demote iia
          m(i)=m(j)
          i=j
          j=j*2
         else                               ! This is iia's level.
          j=ir+1                            ! set j to terminate the shift-down.
         endif
        if(j.le.ir) go to 2
       m(i)=iia                             ! put iia into its slot.
       go to 1
      end
      subroutine ipack (m,n,num)
      dimension m(n)
c
c     pack sorted array with eliminating redundant elements
c
      iend=1
      mcur=m(1)
       do i=2,n
        if(mcur.lt.m(i)) then
         mcur=m(i)
         iend=iend+1
         m(iend)=m(i)
        endif
       enddo
      num=iend
      return
      end
      subroutine ihsrt2 (m,n,mm)
c
c        1         2         3         4         5         6         7 
c2345678901234567890123456789012345678901234567890123456789012345678901234567890
c
c     Integer Heap-SORT-2 
c       member of length n is sorted in ascending order
c       index table is returned in mm(1:n) array
c
      dimension m(n),mm(n)
c                           set index array
       do i=1,n
        mm(i)=i
       enddo
c
      k=n/2+1
      ir=n
    1  continue
        if(k.gt.1) then                   ! still in hiring phase.
         k=k-1
         iia=m(k)
         iim=mm(k)
        else                              ! in retirement-and-promotion phase.
         iia=m(ir)                        ! clear a space at end of array.
         iim=mm(ir)
         m(ir)=m(1)                       ! retire the top of the heap into it.
         mm(ir)=mm(1)
         ir=ir-1
          if(ir.eq.1) then                ! done with the last promotion.
           m(1)=iia                       ! the least competent worker of all!
           mm(1)=iim
           return
          endif
        endif
c
       i=k     ! whether in the hiring phase or promotion phase, we here set up
       j=k*2   ! to sift down element iia to its proper level.
c
    2   continue
         if(j.lt.ir.and.m(j).lt.m(j+1)) j=j+1 ! compare to the better underling.
         if(iia.lt.m(j)) then                 ! demote iia
          m(i)=m(j)
          mm(i)=mm(j)
          i=j
          j=j*2
         else                               ! This is iia's level.
          j=ir+1                            ! set j to terminate the shift-down.
         endif
        if(j.le.ir) go to 2
       m(i)=iia                             ! put iia into its slot.
       mm(i)=iim
       go to 1
      end
      subroutine iparm (ind,ia,len,n,iw)
c                -----  <   <> <   <
      implicit double precision (a-h,o-z)
      dimension ia(len,n),ib(len,n),ind(n),iw(len,n)
c
c      do j=n,2,-1
c       k=ind(j)
c        if(k.ne.j) then
c         do i=1,len
c          ix=ia(i,k)
c          ia(i,k)=ia(i,j)
c          ia(i,j)=ix
c         enddo
c        endif
c      enddo
c
       do j=1,n
        k=ind(j)
         do i=1,len
          iw(i,k)=ia(i,j)
         enddo
       enddo
c
       do j=1,n
         do i=1,len
          ia(i,j)=iw(i,j)
         enddo
       enddo
      return
      end
      subroutine stpwch0 (nwatch) 
c************************************************
c     stop-watch initiallization
c************************************************
      implicit double precision (a-h,o-z)  
*     dimension xtime(100),xmflop(50) 
      common/stpwchx/xtime(50),xmflop(50) 
c
      n=min(nwatch,50)  
       do j=1,n         
        xtime(j)=0.d0  
        xmflop(j)=0.d0
       enddo  
      return  
      stop 
c************************************************ 
c     stop-watch called for start   
c************************************************ 
      entry stpwch1 (i)        
c     call cputime(t2,icode)   
c     xtime(i+n)=t2            
      t2=second()
      xtime(i+n)=t2
c     i1=mclock()
c     xtime(i+n)=i1*1.d0
      return   
c************************************************ 
c     stop-watch called for stop  
c************************************************ 
      entry stpwch2 (i,ymflop)  
c     call cputime(t2,icode)    
c     xtime(i)=xtime(i)+(t2-xtime(i+n))*1.0d-6  
      t2=second()
c     i1=mclock()
c     t2=i1*1.d0
      xtime(i)=xtime(i)+(t2-xtime(i+n))
      xmflop(i)=xmflop(i)+ymflop    
      return                        
c************************************************
c     stop-watch result print       
c************************************************
      entry stpwch3 (m)             
      mn=min(m,n)
*     write(*,*) 'stpwch3 n=',n,' m=',m
*     mn=m                   
      write(6,90)  mn               
       do j=1,mn 
        if(xtime(j).gt.0.d0) then   
c        y=xmflop(j)/xtime(j)
         p=xmflop(j)/xtime(j)
         q=xtime(j)  
c        p=(xmflop(j)/xtime(j))*100.d0
c        q=xtime(j)/100.d0   
         write(6,91) j,q,p   
        end if      
       enddo
      return        
c                 
   90 format(///,'  time measured   no. of stop-watches ',i2,/,  
     *'   no.           CPU  sec         Mflop/s')  
   91 format(i6,e18.4,f17.3)   
      end    
