      function idamax (n,x,ldx)
c     *******************************
c     ** find abs max element index**
c     *******************************
      double precision x(ldx,n),t
      t=abs(x(1,1))
      ix=1
      do j=2,n
        if(abs(x(1,j)).gt.t) then
          ix=j         
          t=abs(x(1,j))
        endif
      enddo  
      idamax=ix 
      return
      end
      subroutine dswap (n,x,ldx,y,ldy)
c     *******************************
c     ** vector swapping : x<->y  ***
c     *******************************
      double precision x(ldx,n),y(ldy,n),t
      do j=1,n
        t=x(1,j)
        x(1,j)=y(1,j)
        y(1,j)=t
      enddo   
      return
      end
      subroutine dscal (n,a,x,ldx)
c     *******************************
c     ** vector scaling  : x=a*x  ***
c     *******************************
      double precision x(ldx,n),a
      do j=1,n
        x(1,j)=a*x(1,j)
      enddo    
      return
      end
      subroutine dcopy (n,x,incx,y,incy)
c     *******************************
c     ** vector copy   y <== x    ***
c     *******************************
      double precision x(*),y(*) 
      jx=1-incx
      jy=1-incy
      do j=1,n
        y(jy+j*incy)=x(jx+j*incx)
      enddo    
      return
      end
      subroutine daxpy (n,a,x,ldx,y,ldy)
c     *******************************
c     ** computes  a*x+y : x=a*x  ***
c     *******************************
      double precision x(ldx,n),y(ldy,n),a
      do j=1,n
        y(1,j)=y(1,j)+a*x(1,j)
      enddo   
      return
      end
      function ddot (n,a,lda,b,ldb)
c     *******************************
c     ***       dot product       ***
c     *******************************
      double precision a(lda,n),b(ldb,n)
      double precision s,ddot    
      s=0.d0
      do i=1,n
        s=s+a(1,i)*b(1,i)
      enddo
      ddot=s
      return
      end
      function dnrm2 (n,a,lda)
c     *******************************
c     ***    Euclidean length     ***
c     *******************************
      double precision a(lda,n),s,dnrm2 
      s=0.d0
      do i=1,n
        s=s+a(1,i)*a(1,i)
      enddo
      dnrm2=sqrt(s)
      return
      end
