      subroutine docg (n,b,x,w,ldw,iter,resid
     &                ,info,icpa,irowa,a,pq,beta,rr)
      implicit double precision (a-h,o-z)
      integer r,z,p,q
      dimension x(*),b(*),w(ldw,*),pq(*),beta(*),rr(*)
c     matrix A is stored in CCS format
      dimension icpa(*),irowa(*),a(*)
c     dimension pp1(100)
c
      write(6,*) 'docg N=',n
c     write(6,*) 'docg Initial B'
c     write(6,9) (b(i),i=1,n)
c
c     write(*,*) 'docg given X vector'
c     write(*,9) (x(i),i=1,n)
coldriver
      dlogten=dlog(10.d0)
c
      info=0
*
*     Test the input parameters.
*
      if ( n.lt.0 ) then
         info = -1
      else if ( ldw.lt.max( 1, n ) ) then
         info = -2
      else if ( iter.le.0 ) then
         info = -3
      endif
      if ( info.ne.0 ) return
*
      maxit = iter
      tol   = resid
*
*     alias workspace columns.
*
      r = 1
      z = 2
      p = 3
      q = 4
*
*     set initial residual.
*
      call dcopy( n, b, 1, w(1,r), 1 )
      if ( dnrm2( n, x, 1 ).ne.zero ) then
         call matvec(-1.d0,x,1.d0,w(1,r),n,icpa,irowa,a)
         if ( dnrm2( n, w(1,r), 1 ).lt.tol ) go to 10
      endif
      bnrm2 = dnrm2( n, b, 1 )
c     write(6,*) 'docg  Bnrm2=',bnrm2
      rr(1)=bnrm2
      if ( bnrm2.eq.zero ) bnrm2 = 1.0
*
*        perform conjugate gradient iteration.
*
c     write(6,*) 'docg  Initial R'
c     write(6,9) (w(i,r),i=1,n)
c     write(6,*) 'iter  alpha    rho=rr^2    pq=p^T A p  resid=rr/Bnrm2'
       do k=1,maxit
c        write(6,*)  'Iteration ',k
*
         rho=rr(k)**2
*
*        compute direction vector p.
*
         if ( k.gt.1 ) then
            beta(k) = rho / rho1
            call dcopy( n, w(1,r), 1, w(1,z), 1 )
            call daxpy( n, beta(k), w(1,p), 1, w(1,z), 1 )
            call dcopy( n, w(1,z), 1, w(1,p), 1 )
         else
            beta(1)=0.d0
            call dcopy( n, w(1,r), 1, w(1,p), 1 )
         endif
c     write(6,*) 'Beta(',k,')=',beta(k),rho,rho1
*
*        compute scalar alpha (save a*p to q).
*
c        write(6,*) 'P vec'
c        write(6,9) (w(i,p),i=1,n)
         call matvec (1.d0,w(1,p),0.d0,w(1,q),n,icpa,irowa,a)
c        write(6,*) 'A*s vector'
c        write(6,9) (w(i,q),i=1,n)
         pq(k)=  ddot( n, w(1,p), 1, w(1,q), 1 )
         alpha =  rho / pq(k)
c        write(6,*) 'alpha=',alpha,rho,pq(k)
*
*        compute current solution vector x.
*
         call daxpy( n, alpha, w(1,p), 1, x, 1 )
c        write(6,*) 'X',k,' vector'
c        write(6,9) (x(i),i=1,n)
    9    format(5e12.4)
*
*        compute residual vector r, find norm,
*        then check for tolerance.
*
         call daxpy( n, -alpha,  w(1,q), 1, w(1,r), 1 )
c---------------------------------
c        write(6,*) 'R vec'
c        write(6,'(6e12.4)') (w(i,r),i=1,n)
         rr(k+1)=dnrm2( n, w(1,r), 1 )
c        write(6,*) 'rr(k+1)',rr(k+1)
c---------------------------------
         resid = rr(k+1) / bnrm2
coldriver
c        write(6,*) 'iter=',k,'alpha=',alpha,rho,pq(k),dlog(resid)/dlogten,resid
c        write(6,*) 'iter=',k,' alpha=',alpha,rho,pq(k),resid
c        write(6,*) k,alpha,rho,pq(k),resid
         write(*,*) ' residual =',resid
c
coldriver
*        compute true R 
c        call matvec (1.d0,x,0.d0,w(1,q),n,icpa,irowa,a)
c        rrr=0
c        do i=1,n
c          rrr=rrr+(w(i,q)-b(i))**2
c        enddo
c        write(6,*)  'true error=',sqrt(rrr),rr(k+1)
c
c
         if ( resid.le.tol ) go to 10
*
         rho1 = rho
*
       enddo
*
*     iteration fails.
*
      info  = k
      return
*
   10 continue
*
*     Iteration successful
*
      iter=k
      info = 0
c
      return
      end
      subroutine matvec (alpha,x,beta,y,n,icp,irow,a)
*
*  MATVEC  matrix-vector product
*
*               y := alpha*A*x + beta*y,
*
*          where alpha and beta are scalars, x and y are vectors,
*          and A is a matrix. Vector x must remain unchanged.
*          The solution is over-written on vector y.
*
c          The matrix is passed through arguments icp,irow,a (CCS) 
*
      implicit double precision (a-h,o-z)
      dimension x(*),y(*)
      dimension icp(*),irow(*),a(*)
c
        if(beta.ne.1.d0) then
         do i=1,n
          y(i)=beta*y(i)
         enddo
        endif
c
       do j=1,n
        nt=icp(j+1)-icp(j)
        k=icp(j)
c       y(j)=y(j)+alpha*a(k)*x(j) !!! lower triangular is given
         do it=1,nt-1
c         k=k+1                  !!!!!!!!!!!!
          i=irow(k)
          y(i)=y(i)+alpha*a(k)*x(j)
          y(j)=y(j)+alpha*a(k)*x(i)
          k=k+1                   !!!!!!!!!!!!
         enddo
        y(j)=y(j)+alpha*a(k)*x(j) !!!!!!!!!!!!
       enddo
      return
      end
      subroutine scamat (n,icp,irow,a,s)
      implicit double precision (a-h,o-z)
      dimension a(*),icp(n),irow(*),s(n)
c
c     make scaling matrix S
c
       do i=1,n
c       k=icp(i+1)-1
        k=icp(i)      !!! lower triangular is given
        s(i)=1.d0/sqrt(a(k))
       enddo
c
c     write(6,1110) (s(i),i=1,n)
 1110 format(10f8.2)
      return
      end
      subroutine scalea (n,icp,irow,a,s)
      implicit double precision (a-h,o-z)
      dimension a(*),icp(n),irow(*),s(n)
c
c     transform A with diagonal matrix S : SAS
c
c       i.e., a(i,j) <= s(i)*a(i,j)*s(j)
c             a(i,i) <= s(j)*a(i,j)*s(j)
c
       do j=1,n
        nt=icp(j+1)-icp(j)
        k=icp(j)
        a(k)=s(j)*a(k)*s(j)  !!!!!!!!!!!!!
         do it=1,nt-1
          k=k+1  !!!!!!!!!!!!!
          i=irow(k)
          a(k)=s(i)*a(k)*s(j)
c         k=k+1  !!!!!!!!!!!!!
         enddo
c       a(k)=s(j)*a(k)*s(j)   !!!!!!!!!!!!!
       enddo
c
      return
      end
      subroutine scaleb (n,b,s)
      implicit double precision (a-h,o-z)
      dimension b(n),s(n)
c
c     transform b with diagonal matrix S : Sb
c
       do i=1,n
        b(i)=s(i)*b(i)
       enddo
c
      return
      end
      subroutine ccsprt (icp,irow,a,n)
      implicit double precision (a-h,o-z)
      dimension a(*),icp(*),irow(*)
c     dimension p(10),ip(10)
      dimension p(8),ip(8)
c
c     print ccs (compressed column storage) matrix
c
       do j=1,n
        nt=icp(j+1)-icp(j)
        k=icp(j)
        write(6,*) 'column ',j,icp(j),' to ',icp(j+1)
        m=1
         do it=1,nt
          ip(m)=irow(k)
          p(m)=a(k)
          k=k+1
          m=m+1
c          if(m.eq.11) then
           if(m.eq.9) then
c           write(6,101) ip
c           write(6,102) p
            write(6,'(8i10)') (ip(l),l=1,m-1)
            write(6,'(8e10.3)') (p(l),l=1,m-1)
            m=1
           endif
         enddo
         if(m.ne.1) then
c         write(6,101) (ip(l),l=1,m-1)
c         write(6,102) (p(l),l=1,m-1)
          write(6,'(8i10)') (ip(l),l=1,m-1)
          write(6,'(8e10.3)') (p(l),l=1,m-1)
         endif
       enddo
      return
  101 format(10i8)
  102 format(10e8.2)
      end
