      subroutine docg (n,b,x,w,ldw,iter,resid &
     &                ,info,icpa,irowa,a,pq,beta,rr)
      implicit double precision (a-h,o-z)
      integer r,z,p,q
      dimension x(*),b(*),w(ldw,*),pq(*),beta(*),rr(*)
!     matrix A is stored in CCS format
      dimension icpa(*),irowa(*),a(*)
!
!     write(*,*) 'docg N=',n
!     write(*,*) 'docg Initial B'
!     write(*,9) (b(i),i=1,n)
!
      dlogten=dlog(10.d0)
!
      info=0
!
!     Test the input parameters.
!
      if ( n.lt.0 ) then
         info = -1
      else if ( ldw.lt.max( 1, n ) ) then
         info = -2
      else if ( iter.le.0 ) then
         info = -3
      endif
      if ( info.ne.0 ) return
!
      maxit = iter
      tol   = resid
!
!     alias workspace columns.
!
      r = 1
      z = 2
      p = 3
      q = 4
!
!     set initial residual.
!
      call dcopy( n, b, 1, w(1,r), 1 )
      if ( dnrm2( n, x, 1 ).ne.zero ) then
         call matvect(-1.d0,x,1.d0,w(1,r),n,icpa,irowa,a)
         if ( dnrm2( n, w(1,r), 1 ).lt.tol ) go to 10
      endif
      bnrm2 = dnrm2( n, b, 1 )
      rr(1)=bnrm2
      if ( bnrm2.eq.zero ) bnrm2 = 1.0
!
!        perform conjugate gradient iteration.
!
       do k=1,maxit
!
         rho=rr(k)**2
!
!        compute direction vector p.
!
         if ( k.gt.1 ) then
            beta(k) = rho / rho1
            call dcopy( n, w(1,r), 1, w(1,z), 1 )
            call daxpy( n, beta(k), w(1,p), 1, w(1,z), 1 )
            call dcopy( n, w(1,z), 1, w(1,p), 1 )
         else
            beta(1)=0.d0
            call dcopy( n, w(1,r), 1, w(1,p), 1 )
         endif
!
!        compute scalar alpha (save a*p to q).
!
         call matvect(1.d0,w(1,p),0.d0,w(1,q),n,icpa,irowa,a)
         pq(k)=  ddot( n, w(1,p), 1, w(1,q), 1 )
         alpha =  rho / pq(k)
!
!        compute current solution vector x.
!
         call daxpy( n, alpha, w(1,p), 1, x, 1 )
!
!        compute residual vector r, find norm,
!        then check for tolerance.
!
         call daxpy( n, -alpha,  w(1,q), 1, w(1,r), 1 )
!---------------------------------
!        write(*,*) 'R vec'
!        write(*,'(6e12.4)') (w(i,r),i=1,n)
         rr(k+1)=dnrm2( n, w(1,r), 1 )
!        write(6,*) 'rr(k+1)',rr(k+1)
!---------------------------------
         resid = rr(k+1) / bnrm2
!
!        write(*,*) 'iter=',k,'alpha=',alpha,rho,pq(k),dlog(resid)/dlogten,resid
!        write(*,*) 'iter=',k,' alpha=',alpha,rho,pq(k),resid
!        write(*,*) k,alpha,rho,pq(k),resid
!        write(*,*) k,resid
         write(*,*) k,dlog(resid)/dlogten
!
!
!        compute true R 
!        call matvect(1.d0,x,0.d0,w(1,q),n,icpa,irowa,a)
!        rrr=0
!        do i=1,n
!          rrr=rrr+(w(i,q)-b(i))**2
!        enddo
!        write(*,*)  'true error=',sqrt(rrr),rr(k+1)
!
!
         if ( resid.le.tol ) go to 10
!
         rho1 = rho
!
       enddo
!
!     iteration fails.
!
      info  = k
      return
!
   10 continue
!
!     Iteration successful
!
      iter=k
      info = 0
!
      return
      end
      subroutine matvect(alpha,x,beta,y,n,icp,irow,a)
!
!  MATVECT symmetric matrix vector product
!
!               y := alpha*A*x + beta*y,
!
!          where alpha and beta are scalars, x and y are vectors,
!          and A is a matrix. Vector x must remain unchanged.
!          The solution is over-written on vector y.
!
!          The matrix is passed through arguments icp,irow,a (CCS),
!          and the matrix is stored upper triangular portion.
!
      implicit double precision (a-h,o-z)
      dimension x(*),y(*)
      dimension icp(*),irow(*),a(*)
!
        if(beta.ne.1.d0) then
         do i=1,n
          y(i)=beta*y(i)
         enddo
        endif
!
       do j=1,n
        nt=icp(j+1)-icp(j)
        k=icp(j)
         do it=1,nt-1
          i=irow(k)
          y(i)=y(i)+alpha*a(k)*x(j)
          y(j)=y(j)+alpha*a(k)*x(i)
          k=k+1
         enddo
        y(j)=y(j)+alpha*a(k)*x(j) !  upper triangular is given
       enddo
      return
      end
      subroutine scamatt(n,icp,irow,a,s)
      implicit double precision (a-h,o-z)
      dimension a(*),icp(n),irow(*),s(n)
!
!     make scaling matrix S
!
       do i=1,n
        k=icp(i+1)-1  ! upper triangular is given
!       k=icp(i)      ! lower triangular is given
        s(i)=1.d0/sqrt(a(k))
       enddo
!
!     write(*,'(10f8.2)') (s(i),i=1,n)
      return
      end
      subroutine scaleat(n,icp,irow,a,s)
      implicit double precision (a-h,o-z)
      dimension a(*),icp(n),irow(*),s(n)
!
!     transform A with diagonal matrix S : SAS
!
!       i.e., a(i,j) <= s(i)*a(i,j)*s(j)
!             a(i,i) <= s(j)*a(i,j)*s(j)
!
       do j=1,n
        nt=icp(j+1)-icp(j)
        k=icp(j)
!       a(k)=s(j)*a(k)*s(j)  !!!!!!!!!!!!!
         do it=1,nt-1
!         k=k+1  !!!!!!!!!!!!!
          i=irow(k)
          a(k)=s(i)*a(k)*s(j)
          k=k+1  !!!!!!!!!!!!!
         enddo
        a(k)=s(j)*a(k)*s(j)   !!!!!!!!!!!!!
       enddo
!
      return
      end
      subroutine scaleb (n,b,s)
      implicit double precision (a-h,o-z)
      dimension b(n),s(n)
!
!     transform b with diagonal matrix S : Sb
!
       do i=1,n
        b(i)=s(i)*b(i)
       enddo
!
      return
      end
      subroutine ccsprt (icp,irow,a,n)
      implicit double precision (a-h,o-z)
      dimension a(*),icp(*),irow(*)
      dimension p(8),ip(8)
!
!     print ccs (compressed column storage) matrix
!
       do j=1,n
        nt=icp(j+1)-icp(j)
        k=icp(j)
        write(*,*) 'column ',j,'  position ',icp(j),' to ',icp(j+1)-1
        m=1
         do it=1,nt
          ip(m)=irow(k)
          p(m)=a(k)
          k=k+1
          m=m+1
           if(m.eq.9) then
            write(*,'(8i10)') (ip(l),l=1,m-1)
            write(*,'(8e10.3)') (p(l),l=1,m-1)
            m=1
           endif
         enddo
         if(m.ne.1) then
          write(*,'(8i10)') (ip(l),l=1,m-1)
          write(*,'(8e10.3)') (p(l),l=1,m-1)
         endif
       enddo
      return
      end
      subroutine bndcount (a,nb,n,m)
      implicit double precision (a-h,o-z)
      dimension a(nb,n)
!
!     count nonzero terms of bandmatrix
!
      m=0
      do j=1,n
        i1=max(j-nb+1,1)
        do i=i1,j
          if(a(nb-j+i,j).ne.0) then
            m=m+1
          endif
        enddo
      enddo
      return
      end
      subroutine bnd2ccs (a,nb,n,icp,irow,b)
      implicit double precision (a-h,o-z)
      dimension a(nb,n),b(*),icp(*),irow(*)
!
!     convert bandmatrix to ccs (compressed column storage) matrix
!
      m=0
      do j=1,n
        icp(j)=m+1
        i1=max(j-nb+1,1)
        do i=i1,j
          if(a(nb-j+i,j).ne.0) then
            m=m+1
            b(m)=a(nb-j+i,j)
            irow(m)=i
          endif
        enddo
      enddo
      icp(n+1)=m+1
      return
      end
      function idamax (n,x,ldx)
!     *******************************
!     ** find abs max element index**
!     *******************************
      double precision x(ldx,n),t
      t=abs(x(1,1))
      ix=1
       do j=2,n
        if(abs(x(1,j)).gt.t) then
         ix=j         
         t=abs(x(1,j))
        endif
       enddo  
      idamax=ix 
      return
      end
      subroutine dswap (n,x,ldx,y,ldy)
!     *******************************
!     ** vector swapping : x<->y  ***
!     *******************************
      double precision x(ldx,n),y(ldy,n),t
       do j=1,n
        t=x(1,j)
        x(1,j)=y(1,j)
        y(1,j)=t
       enddo   
      return
      end
      subroutine dscal (n,a,x,ldx)
!     *******************************
!     ** vector scaling  : x=a*x  ***
!     *******************************
      double precision x(ldx,n),a
       do j=1,n
        x(1,j)=a*x(1,j)
       enddo    
      return
      end
      subroutine dcopy (n,x,incx,y,incy)
!     *******************************
!     ** vector copy   y <== x    ***
!     *******************************
      double precision x(*),y(*) 
      jx=1-incx
      jy=1-incy
       do j=1,n
        y(jy+j*incy)=x(jx+j*incx)
       enddo    
      return
      end
      subroutine daxpy (n,a,x,ldx,y,ldy)
!     *******************************
!     ** computes  a*x+y : x=a*x  ***
!     *******************************
      double precision x(ldx,n),y(ldy,n),a
       do j=1,n
        y(1,j)=y(1,j)+a*x(1,j)
       enddo   
      return
      end
      function ddot (n,a,lda,b,ldb)
!     *******************************
!     ***       dot product       ***
!     *******************************
      double precision a(lda,n),b(ldb,n)
      double precision s,ddot    
      s=0.d0
       do i=1,n
        s=s+a(1,i)*b(1,i)
       enddo   
      ddot=s
      return
      end
      function dnrm2 (n,a,lda)
!     *******************************
!     ***    Euclidean length     ***
!     *******************************
      double precision a(lda,n),s,dnrm2 
      s=0.d0
       do i=1,n
        s=s+a(1,i)*a(1,i)
       enddo   
      dnrm2=sqrt(s)
      return
      end
