      program docg4x4
c23456789012345678901234567890123456789012345678901234567890123456789012
c     g77 docg4x4.f docg.o blass.o
c23456789012345678901234567890123456789012345678901234567890123456789012
      implicit double precision (a-h,o-z)
      parameter(nx=100,nz=300)
      dimension b(nx),x(nx),p1(nx),p2(nx),p3(nx),p4(nx),work(nz)
      dimension ia(nx+1),ja(nz),a(nz)  ! for CCS sparse matrix
      ia(1)=1;ia(2)=2;ia(3)=4;ia(4)=6;ia(5)=9
      ja(1)=1;ja(2)=1;ja(3)=3;ja(4)=1;ja(5)=4;ja(6)=2;ja(7)=3;ja(8)=4
      a(1)=4;a(2)=-1;a(3)=4;a(4)=-1;a(5)=4;a(6)=-1;a(7)=-1;a(8)=4
c     b(1)=140;b(2)=140;b(3)=200;b(4)=200
      b(1)=140;b(2)=160;b(3)=200;b(4)=210  ! 3 iterations.
      x(1)=0;x(2)=0;x(3)=0;x(4)=0
      iter=4; resid=1.e-9; n=4
      call docg (n,b,x,work,n,iter,resid,info,ia,ja,a,p2,p3,p4)
      write(*,*) 'Solution'
      write(*,*) (x(i),i=1,n)
      p1(1)=0;p1(2)=0;p1(3)=0;p1(4)=0
      call docg2(n,b,p1,work,n,iter,resid,info,ia,ja,a,p2,p3,p4,x)
      stop
      end
      subroutine docg2(n,b,x,w,ldw,iter,resid
     &                ,info,icpa,irowa,a,pq,beta,rr,xhat)
      implicit double precision (a-h,o-z)
      integer r,z,p,q
      dimension x(*),b(*),w(ldw,*),pq(*),beta(*),rr(*),xhat(*)
c     matrix A is stored in CCS format
      dimension icpa(*),irowa(*),a(*)
      dimension pp1(100)
c
      write(6,*) 'docg N=',n
c
      dlogten=dlog(10.d0)
c
      info=0
*
*     Test the input parameters.
*
      if ( n.lt.0 ) then
         info = -1
      else if ( ldw.lt.max( 1, n ) ) then
         info = -2
      else if ( iter.le.0 ) then
         info = -3
      endif
      if ( info.ne.0 ) return
*
      maxit = iter
      tol   = resid
*
*     alias workspace columns.
*
      r = 1
      z = 2
      p = 3
      q = 4
*
*     set initial residual.
*
      call dcopy( n, b, 1, w(1,r), 1 )
      if ( dnrm2( n, x, 1 ).ne.zero ) then
         call matvec(-1.d0,x,1.d0,w(1,r),n,icpa,irowa,a)
         if ( dnrm2( n, w(1,r), 1 ).lt.tol ) go to 10
      endif
      bnrm2 = dnrm2( n, b, 1 )
c     write(6,*) 'docg  Bnrm2=',bnrm2
      rr(1)=bnrm2
      if ( bnrm2.eq.zero ) bnrm2 = 1.0
*
*        perform conjugate gradient iteration.
*
c     write(6,*) 'docg  Initial R'
c     write(6,9) (w(i,r),i=1,n)
c     write(6,*) 'iter  alpha    rho=rr^2    pq=p^T A p  resid=rr/Bnrm2'
       do k=1,maxit
         write(6,*)  'Iteration ',k
*
         rho=rr(k)**2
*
*        compute direction vector p.
*
         if ( k.gt.1 ) then
            beta(k) = rho / rho1
            call dcopy( n, w(1,r), 1, w(1,z), 1 )
            call daxpy( n, beta(k), w(1,p), 1, w(1,z), 1 )
            call dcopy( n, w(1,z), 1, w(1,p), 1 )
         else
            beta(1)=0.d0
            call dcopy( n, w(1,r), 1, w(1,p), 1 )
         endif
      write(6,*) 'Beta(',k,')=',beta(k),rho,rho1
*
*        compute scalar alpha (save a*p to q).
*
c        write(6,*) 'P vec'
c        write(6,9) (w(i,p),i=1,n)
         call matvec (1.d0,w(1,p),0.d0,w(1,q),n,icpa,irowa,a)
         write(6,*) 'A*s vector'
         write(6,9) (w(i,q),i=1,n)
         pq(k)=  ddot( n, w(1,p), 1, w(1,q), 1 )
         alpha =  rho / pq(k)
c        write(6,*) 'alpha=',alpha,rho,pq(k)
*
*        compute current solution vector x.
*
         call daxpy( n, alpha, w(1,p), 1, x, 1 )
         write(6,*) 'X',k,' vector'
         write(6,9) (x(i),i=1,n)
    9    format(5e12.4)
***************  Adding for check **********************
         do i=1,n                                      !
           pp1(i)=x(i)-xhat(i)                         !
         enddo                                         !
         chk=ddot(n,w(1,q),1,pp1,1)                    !
         write(*,*) 'Check solution direction',chk     !
********************************************************
*
*        compute residual vector r, find norm,
*        then check for tolerance.
*
         call daxpy( n, -alpha,  w(1,q), 1, w(1,r), 1 )
c---------------------------------
         rr(k+1)=dnrm2( n, w(1,r), 1 )
c---------------------------------
         resid = rr(k+1) / bnrm2
         write(*,*) ' residual =',resid
         if ( resid.le.tol ) go to 10
*
         rho1 = rho
*
       enddo
*
*     iteration fails.
*
      info  = k
      return
*
   10 continue
*
*     Iteration successful
*
      iter=k
      info = 0
c
      return
      end
