      program dosd4x4
c
c     g77 dosd4x4.f blass.o
c
      implicit double precision (a-h,o-z)
      parameter(nx=100,nz=300)
      dimension b(nx),x(nx),p2(nx),p3(nx),p4(nx),work(nz)
      dimension ia(nx+1),ja(nz),a(nz)  ! for CCS sparse matrix
      ia(1)=1;ia(2)=2;ia(3)=4;ia(4)=6;ia(5)=9
      ja(1)=1;ja(2)=1;ja(3)=3;ja(4)=1;ja(5)=4;ja(6)=2;ja(7)=3;ja(8)=4
      a(1)=4;a(2)=-1;a(3)=4;a(4)=-1;a(5)=4;a(6)=-1;a(7)=-1;a(8)=4
      b(1)=140;b(2)=140;b(3)=200;b(4)=200
      x(1)=0;x(2)=0;x(3)=0;x(4)=0
      iter=19; resid=1.e-9; n=4
      call dosd (n,b,x,p2,p3,iter,resid,info,ia,ja,a)
      write(*,*) 'dosd end info=',info
      stop
      end
      subroutine dosd (n,b,x,t,r,iter,resid,info,icpa,irowa,a)
      implicit double precision (a-h,o-z)
      dimension x(*),b(*),t(*),r(*)
c     matrix A is stored in CCS format
      dimension icpa(*),irowa(*),a(*)
c
      write(6,*) 'dosd N=',n
c
      dlogten=dlog(10.d0)
c
      info=0
*
      if ( n.lt.0 ) then
         info = -1
      else if ( iter.le.0 ) then
         info = -3
      endif
      if ( info.ne.0 ) return
*
      maxit = iter
      tol   = resid
*
*
*     set initial residual.
*
      call dcopy( n, b, 1, r(1), 1 )
      if ( dnrm2( n, x, 1 ).ne.zero ) then
         call matvec(-1.d0,x,1.d0,r(1),n,icpa,irowa,a)
         if ( dnrm2( n, r(1), 1 ).lt.tol ) go to 10
      endif
      bnrm2 = dnrm2( n, b, 1 )
      rr=bnrm2
      if ( bnrm2.eq.zero ) bnrm2 = 1.0
*
      write(6,*) 'iter  alpha    rho=rr^2    pq=p^T A p  resid=rr/Bnrm2'
       do k=1,maxit
         write(6,*)  'iter =',k
*
         call matvec (1.d0,r(1),0.d0,t(1),n,icpa,irowa,a)  !  t=A*r
         rar= ddot( n, r(1), 1, t(1), 1 )
         rho=rr**2
         alpha =  rho / rar
         write(6,*) 'alpha=',alpha,rho
*
*        compute current solution vector x.
*
         call daxpy( n, alpha, r(1), 1, x, 1 )
         write(6,*) 'X vec'
         write(6,9) (x(i),i=1,n)
    9    format(4e15.7)
*
*        compute residual vector r, find norm,
*        then check for tolerance.
*
         call dcopy( n, b, 1, r(1), 1 )
         call matvec(-1.d0,x,1.d0,r(1),n,icpa,irowa,a)
c---------------------------------
         write(6,*) 'R vec'
         write(6,9) (r(i),i=1,n)
         rr=dnrm2( n, r(1), 1 )
c        write(6,*) 'rr(k+1)',rr(k+1)
c---------------------------------
         resid = rr / bnrm2
c
         write(6,*) k,alpha,rho,resid
c
c
         if ( resid.le.tol ) go to 10
*
         rho1 = rho
*
       enddo
*
*     iteration fails.
*
      info  = k
      return
*
   10 continue
*
*     Iteration successful
*
      iter=k
      info = 0
c
      return
      end
      subroutine matvec (alpha,x,beta,y,n,icp,irow,a)
*
*  MATVEC  matrix-vector product
*
*               y := alpha*A*x + beta*y,
*
*          where alpha and beta are scalars, x and y are vectors,
*          and A is a matrix. Vector x must remain unchanged.
*          The solution is over-written on vector y.
*
c          The matrix is passed through arguments icp,irow,a (CCS) 
*
      implicit double precision (a-h,o-z)
      dimension x(*),y(*)
      dimension icp(*),irow(*),a(*)
c
        if(beta.ne.1.d0) then
         do i=1,n
          y(i)=beta*y(i)
         enddo
        endif
c
       do j=1,n
        nt=icp(j+1)-icp(j)
        k=icp(j)
c       y(j)=y(j)+alpha*a(k)*x(j) !!! lower triangular is given
         do it=1,nt-1
c         k=k+1                  !!!!!!!!!!!!
          i=irow(k)
          y(i)=y(i)+alpha*a(k)*x(j)
          y(j)=y(j)+alpha*a(k)*x(i)
          k=k+1                   !!!!!!!!!!!!
         enddo
        y(j)=y(j)+alpha*a(k)*x(j) !!!!!!!!!!!!
       enddo
      return
      end
