      subroutine esteig (pp,beta,rr,n,dd,sd)
      implicit double precision (a-h,o-z)
      dimension pp(*),beta(*),rr(*),dd(*),sd(*)
!
!     write(*,*) 'pp'
!     write(*,1) (pp(i),i=1,n)
!     write(*,*) 'beta'
!     write(*,1) (beta(i),i=1,n)
!     write(*,*) 'rr'
!     write(*,1) (rr(i),i=1,n)
    1 format(10e10.2)
!
      dd(1)=pp(1)
      sd(1)=-pp(1)*beta(2)
       do i=2,n-1
        dd(i)=pp(i)+pp(i-1)*beta(i)**2
        sd(i)=-pp(i)*beta(i+1)
       enddo
      dd(n)=pp(n)+pp(n-1)*beta(n)**2
      sd(n)=0.d0
!
!     write(*,*) 'Dd'
!     write(*,1) (dd(i),i=1,n)
!     write(*,*) 'Sd'
!     write(*,1) (sd(i),i=1,n)
!
       do i=1,n
        dd(i)=dd(i)/rr(i)**2
       enddo
!
       do i=1,n-1
        sd(i)=sd(i)/(rr(i)*rr(i+1))
       enddo
!
!     write(*,*) 'DD'
!     write(*,1) (dd(i),i=1,n)
!     write(*,*) 'SD'
!     write(*,1) (sd(i),i=1,n)
      return
      end
      subroutine extrem (dd,sd,n,epsu,emin,emax)
      implicit double precision (a-h,o-z)              
      dimension dd(n),sd(n)
      double precision,dimension(:), allocatable:: f
      allocate (f(n))
!
!     find extremal eigenvalues 
!     from tridiagonal symmetric matrix of order n
!       
!     1. check multiple roots
!                                                                
       ratiom=1.d99
       imm=0
       do i=1,n-1
        ratio=abs(sd(i)/epsu)/(abs(dd(i))+abs(dd(i+1)))
        if(ratio.lt.ratiom) then
         ratiom=ratio
         im=i
        endif
       enddo
!
      compar=1.d99
      icompa=0
       do k=1,n-1
        above=abs(sd(k))
        below=abs(dd(k)+abs(dd(k+1)))
         if(above/below.lt.compar) then
          compar=above/below
          icompa=k
         endif
         if(above/epsu.lt.below) then
          write(*,*) 'extrem multi-root',k,above,below
          sd(k+1)=0.d0
         endif
       enddo
!
       do k=1,n
        f(k)=sd(k)**2
       enddo
!
!     2. upper and lower range by Gerschgorin's theorem
!
      wll=dd(n)-abs(sd(n))                                              
      wuu=dd(n)+abs(sd(n))                                              
       do k=1,n-1                                                  
        s=abs(sd(k))+abs(sd(k+1))                                         
        wll=min(wll,dd(k)-s)                                              
        wuu=max(wuu,dd(k)+s)                                              
       enddo
!                                                                       
      fn=0.0d0                                                          
       do k=1,n                                                    
        fn=fn+abs(dd(k))+abs(sd(k))                                       
       enddo
!                                                                       
      eps1=epsu*(abs(wll)+abs(wuu))                                     
      eps2=fn*1.0d-3                                                    
      epsu2=2.0d0*epsu                                                  
!
!     write(*,*) 'wl wu eps',wll,wuu,epsu2          
      nblk=0                                                            
      kf=1 
!
      emin=wuu; emax=wll
!     =======================================
!     Loop over submatrices
!
       Do kk=1,n
        if(kk.le.n.and.sd(kk).ne.0.0d0)  cycle 
        kl=kk
        nblk=nblk+1  
!
!       find smallest eigenvalue
!
         kn=kl-kf+1; wl=wll; wu=wuu; icont=0
!
         call findev (dd(kf),f(kf),kn,1,wl,wu,w,epsu2,eps1,epsu,1,iter,icont)
         if(icont.ne.0) then
           write(*,*) 'fail to obtain smallest eigenvalue'
         else
!          write(*,*) ' smallest eigenvalue',wl,' iter=',iter
           if(wl.lt.emin) emin=wl
         endif
!
!       find largest eigenvalue
!
         wu=wuu; icont=0
         call findev (dd(kf),f(kf),kn,kn,wl,wu,w,epsu2,eps1,epsu,1,iter,icont)
         if(icont.ne.0) then
           write(*,*) 'fail to obtain largest eigenvalue'
         else
!          write(*,*) ' largest eigenvalue',wl,' iter=',iter
           if(wl.gt.emax) emax=wl
         endif
!
!     ----------------------------------------
!
        kf=kl+1                                                           
       Enddo
!     =======================================
      if(nblk.ge.2) write(*,*) 'extrml nblk=',nblk,' emin,emax',emin,emax
!
      deallocate (f)
      return
      end 
      subroutine findev (d,f,n,kx,wl,wu,w,epsu2,eps1,epsu,ne,iter,icont)
      implicit double precision (a-h,o-z)
      dimension d(n),f(n)
!
      ngrotl=-10; ngrotu=-10
      maxit=n*10
!
!     write(*,*) 'findev  n=',n
!     write(*,*) (d(i),i=1,n)
!     write(*,*) (f(i),i=1,n)
!
      call dtdbx (d,f,n,wl,det,ipwr,ncslpm)
      detl=det; ipwrl=ipwr
!
      call dtdbx (d,f,n,wu,det,ipwr,ncslpm)
      detu=det; ipwru=ipwr
      iter=0
!   =============================
      Do
!       Perform bisection search using Sturm sequence property until range includes single root.
!       Count up Sturm sequence with computing determinant
!
        w=(wl+wu)*0.5
        call dtdbx (d,f,n,w,det,ipwr,ncslpm)   ! det|A-wI| and NCSLPM
!
        if(ncslpm.ge.kx)  then
          wu=w; detu=det; ngrotu=ncslpm   
        else
          wl=w; detl=det; ngrotl=ncslpm 
        endif
!       write(*,*) 'iter=',iter,' w=',w,' No. of Neg roots',ncslpm
        if(wu-wl.lt.epsu2*(abs(wl)+abs(wu))+eps1) exit
        iter=iter+1
        if(iter.gt.maxit) then
          write(*,*) ' findev ERROR iteration exceeds maxit=',maxit
          icont=maxit; exit
        endif 
!   -----------------------------
        If(ngrotu-ngrotl.eq.1) then
!          ------------------
!         Inclusion successful, there exists only one root between wl and wu.
!         write(*,*) 'inclusion successful. iter=',iter
!   -----------------------------
          Do
            w=(wl+wu)*0.5
            call dtdbx (d,f,n,w,det,ipwr,ncslpm)    !  compute det|A-wI|
!
            if(det*detl.lt.0.) then
              wu=w; detu=det
            else
              wl=w; detl=det
            endif
!
            if(wu-wl.lt.epsu2*(abs(wl)+abs(wu))+eps1) exit
            iter=iter+1
            if(iter.gt.maxit) then
              write(*,*)  ' findev ERROR iteration exceeds maxit=',maxit
              icont=maxit; exit
            endif 
          Enddo
!   -----------------------------
        Endif 
      ENDDO
!   =============================
      Return
      END
      SUBROUTINE dtdbx(a, b, n, w ,det,ipwr,ncslpm)
!                ----- <  <  <  <  >   >    >
!     det*2**ipwr = det( A - wI )
!     Number of Changes in the Leading Principal Minors
!
      implicit double precision (a-h,o-z)
      dimension a(n),b(n)             !  b stored b**2
!
      ipwr=0; ncs=0; p=1.d0
      q=a(1)-w
      if(q.lt.0.d0) ncs=ncs+1
      do i=2,n
        r=q*(a(i)-w)-p*b(i-1)
        if(r*q.lt.0.d0) ncs=ncs+1
        if(abs(r).gt.2.d0**128) then
          r=r*2.d0**(-128); q=q*2.d0**(-128); ipwr=ipwr+128
        else if(abs(r).lt.2.d0**(-128)) then
          r=r*2.d0**128; q=q*2.d0**128; ipwr=ipwr-128
        endif
        p=q; q=r
      enddo
      det=r; ncslpm=ncs
      return
      END    
