      PROGRAM PlotLens  ! chase ray through four lenses
      data iww/800/, iwh/600/
c
      call plots ('PlotLens ',iww,iwh)
c     ----- single lens -----
      call plot (100.,480.,-3)
      call lenssingle
c     ----- double lens -----
      call plot (0.,-130.,-3)
      call lensdouble
c     ----- Tesser type -----
      call plot (0.,-130.,-3)
      call lenstesser
c     ----- Gauss type  -----
      call plot (0.,-130.,-3)
      call lensgauss
c     ----- end of plot -----
      call plot (0.,0.,999)
      stop
      end
      SUBROUTINE lenssingle
      implicit double precision (A-H,O-R,T-Z)
      dimension saber(50)
      data nray/25/,f/5.d0/
c
      call plot (0.,0.,-3)
c   --------------------------
      r1=120.; a=0.d0
      p=-1.d0; c1=r1; r2=r1
      c2=5.d0-c1   ! 5.-100.
      call pline (-50.,0.,500.,0.)   !  X axis
c ------------------------------------------------------------
      call factor (real(f))
      call plot(real(c1),0.,3)     !  move to lens center  
      call arc (real(r1),170.,180.)
c ------------------------------------------------------------
      call plot(real(c2),0.,3)     !  move to lens center  
      call arc (real(r2),0.,10.)
c ------------------------------------------------------------
      rrat=1.8d0   ! r1=75.7 ==> f=51.6
      dy=16.d0/dble(nray)
c
       do i=1,nray
        y=i*dy; q=y
        call incdnt(c1,r1,p,q,a,x1,y1)
        call snell (c1,r1,a,x1,y1,rrat,g)
        call incdnt(c2,r2,x1,y1,g,x2,y2)
        call snell (c2,r2,g,x2,y2,1.d0/rrat,gg)
        x3=(gg*x2-y2)/gg
c
        call plot (real(p),real(q),3)
        call plot (real(x1),real(y1),2)
        call plot (real(x2),real(y2),2)
        call plot (real(x3),0.,2)
        saber(i)=x3       ! save Aberration point
       enddo
c
      dmx=0.
      call plot(saber(1),0.0,3)
       do i=1,nray
        sy=i*dy
        call plot(saber(i),sy,2)
        if(abs(saber(i)-saber(1)).gt.dmx) dmx=abs(saber(i)-saber(1))
       enddo
c
      write(*,*) 'LensSingle xmax =',dmx
c
      call factor (1.0)
      return
      end
      SUBROUTINE pline (x1,y1,x2,y2)
      call plot(x1,y1,3)
      call plot(x2,y2,2)
      return
      end
      SUBROUTINE lensdouble
      implicit double precision (A-H,O-R,T-Z)
      dimension saber(50)
      data nray/25/,f/5.d0/
c
      call plot (0.,0.,3)
      sox=0; soy=0
      a=0.d0; p=-1.d0
      r1=38.; c1=r1; c2=7.d0-r1
      r2=r1; r3=r1*2; r4=r3
      c3=10.0-r3; c4=11.0+r4
c
      rrat=1.8d0   ! r1=38. ==> f=87.8
c
      call pline (-20.,0.,440.,0.)
c
      call plot(real(c1*f),0.,3)     !  move to lens center  
      call arc (real(r1*f),155.,180.)
c
      sx=c2*f+sox; sr=r2*f
      call plot (sx,0.,3)     !  move to lens center  
      call arc (sr,0.,25.)
c
      sx=c3*f+sox; sr=r3*f
      call plot (sx,0.,3)     !  move to lens center  
      call arc (sr,0.,12.)
c
      sx=c4*f+sox; sr=r4*f
      call plot (sx,0.,3)     !  move to lens center  
      call arc (sr,168.,180.)
c
      dy=16.d0/dble(nray)
c
       do i=1,nray
        y=i*dy
        q=y
c
        call incdnt (c1,r1,p,q,a,x1,y1)
        call snell (c1,r1,a,x1,y1,rrat,g)
c
        call incdnt (c2,r2,x1,y1,g,x2,y2)
        call snell (c2,r2,g,x2,y2,1.d0/rrat,gg)
c
        call incdnt (c3,r3,x2,y2,g,x3,y3)
        call snell (c3,r3,g,x3,y3,rrat,gg)
c
        call incdnt (c4,r4,x3,y3,g,x4,y4)
        call snell (c4,r4,g,x4,y4,rrat,gg)
c
        x5=x4-y4/gg
        call plot (real(p*f),real(q*f),3)
        call plot (real(x1*f),real(y1*f),2)
        sx=x2*f; sy=y2*f
        call plot (sx,sy,2)
        sx=x3*f; sy=y3*f
        call plot (sx,sy,2)
        sx=x4*f; sy=y4*f
        call plot (sx,sy,2)
        sx=x5*f; sy=0.
        call plot (sx,sy,2)
c
        saber(i)=sx       ! save Aberration point
       enddo
c
      dmx=0.
      call plot(saber(1),0.0,3)
       do i=1,nray
        sy=i*dy*f
        call plot(saber(i),sy,2)
        if(abs(saber(i)-saber(1)).gt.dmx) dmx=abs(saber(i)-saber(1))
       enddo
      write(*,*) 'LensDouble Aberration max=',dmx/f
c
      return
      end
      SUBROUTINE lenstesser
      implicit double precision (A-H,O-R,T-Z)
      real xy(2,50)
      data nray/25/,f/5.d0/
c
      fzero=0.d0
      finfty=1.0d0/fzero
c
      call plot (0.,0.,3)
c
      f=4.d0          !  scaling
      sf=f            !  scaling in single precision
      s=51.6d0/100.d0 !  scale factor for normlized fucus-length to actual.
c
c     ------------- center of arc  ---------------------
      c1=50.01d0*s
      c2=finfty
      c3=-89.94d0*s 
      c4=70.69d0*s 
      c5=finfty
c     ---------
      c6=97.14d0*s
      c7=-25.93d0*s
c     ------------- radius of lens ---------------------
      r1=50.01d0*s
      r2=finfty
      r3=111.05d0*s
      r4=44.68d0*s
      r5=finfty
      r6=57.06d0*s
      r7=78.42d0*s
c     ------------- reflactive index ------------------
      rf1=1.66d0
      rf2=1.615d0
      rf3=1.522d0
      rf4=1.68d0
c
      a=0.d0
      p=-1.d0
c
      call factor(sf)
      call pline (0.,0.,real(3*c1+20.),0.)
c
      call plot (real(c1),0.,3)     !  move to lens center  
      call arc (real(r1),145.,180.)
c
      call pline (s*12.65,0.,s*12.65,57./sf)
c
      call plot (real(c3),0.,3)     !  move to lens center  
      call arc (real(r3),0.,14.)
c
      call plot (real(c4),0.,3)     !  move to lens center  
      call arc (real(r4),148.,180.)
c
      call pline (s*37.71,0.,s*37.71,52./sf)
c
      call plot (real(c6),0.,3)     !  move to lens center  
      call arc (real(r6),154.,180.)
c
      call plot (real(c7),0.,3)     !  move to lens center  
      call arc (real(r7),0.,18.)
c
       do i=1,nray
        y=i*.58d0
c      ------------------------------------------------------------
        call plot (0.,real(y),3)
c      ----------------------------------- Entering lens-1
        x=c1-sqrt(r1**2-y**2)
        call rayplot(x,y,1.d0)             ! plot until incidental x,y
        call snell (c1,r1,a,x,y,rf1,g)     ! Angle at entring lens-1
c      ----------------------------------- Exiting lens-1
        xx=12.65d0*s                       ! Exiting lens-1 to lens-2 (R=Infty)
        yy=y+g*(xx-x) 
        call rayplot(xx,yy,1.d0)    
        call snell (c2,r2,g,xx,yy,1.d0/rf1,gg)  ! Exit lens-2 to air
c      ----------------------------------- Entering lens-2
        call incdnt (c3,r3,xx,yy,gg,xxx,yyy)
        call rayplot(xxx,yyy,1.d0)    
        call snell (c3,r3,gg,xxx,yyy,rf2,ggg)    ! Angle at entering lens-2
c      ----------------------------------- Exiting lens-2
        call incdnt (c4,r4,xxx,yyy,ggg,xxxx,yyyy)
        call rayplot(xxxx,yyyy,1.d0)    
        call snell (c4,r4,ggg,xxxx,yyyy,1.d0/rf2,gggg) ! Angle at exit/enter at 24.3
c      -----------------------------------
        x5=37.71d0*s              ! Entering lens-3
        y5=yyyy+gggg*(x5-xxxx)
        call rayplot(x5,y5,1.d0)    
        call snell (c5,r5,gggg,x5,y5,rf3,g5)  ! Angle at exit lens-3 
c      -----------------------------------
        call incdnt (c6,r6,x5,y5,g5,x6,y6)
        call rayplot(x6,y6,1.d0)
        rfi=rf4/rf3
        call snell (c6,r6,g5,x6,y6,rfi,g6)  ! Angle at exit lens-3 
c      -----------------------------------
        call incdnt (c7,r7,x6,y6,g6,x7,y7)
        call rayplot(x7,y7,1.d0)
        call snell (c7,r7,g6,x7,y7,1.d0/rf4,g7)  ! Angle at exit lens-4 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        xfin=x7-y7/g7
        call rayplot(xfin,0.d0,1.d0)    
c
        xy(1,i)=xfin
        xy(2,i)=y
c
        focus=y/g7
       enddo
c
      sg=xy(1,1)
      call plot (sg,0.,3)
       do i=1,nray
        si=xy(1,i)-sg
        call plot ((si+sg),xy(2,i),2)
       enddo
c
      call plot (sg+34./sf,0.,3)
      call plot (sg+34./sf,real(xy(2,nray)),2)
      call plot (sg+34./sf,0.,3)
      dmx=0.d0
c
       do i=1,nray
        if(abs(xy(1,i)-sg).gt.dmx) dmx=abs(xy(1,i)-sg)
        si=(xy(1,i)-sg)*10.
        call plot ((si+sg)+34./sf,xy(2,i),2)
       enddo
c
      write(6,*) 'LensTesser xmax =',dmx 
      call factor(1.0)
c
      return
      end
      SUBROUTINE lensgauss
      implicit double precision (A-H,O-R,T-Z)
      real xy(2,50)
      data nray/25/
c
      fzero=0.d0
      finfty=1.0d0/fzero
c
      call plot (0.,0.,3)
c
      sox=0; soy=0
      f=6.d0          !  scaling
      sf=f            !  scaling in single precision
      s=51.6d0/100.d0 !  scale factor for normlized fucus-length to actual.
c
c     ------------- center of arc  ---------------------
      c1=59.94d0*s
      c2=176.88d0*s   ! 9.57+167.31
      c3=50.25d0*s    ! 9.95+40.3
      c4=finfty
      c5=53.12d0*s    ! 50.25+2.87
c     ---------
      c6=23.68d0*s    ! 51.37-27.69
      c7=finfty
      c8=20.63d0*s    ! 60.93-40.30
      c9=finfty
      c10=9.98d0*s    ! 69.92-59.94
c
c     ------------- radius of lens ---------------------
      r1=59.94d0*s
      r2=167.31d0*s
      r3=40.3d0*s
      r4=finfty
      r5=25.67*s 
c     ---------
      r6=27.69d0*s
      r7=finfty
      r8=40.30d0*s
      r9=finfty
      r10=59.94d0*s
c
c     ------------- reflactive index ------------------
      rf1=1.78831d0
      rf2=1.66755d0
      rf3=1.72825d0
      rf4=1.62588d0
      rf5=1.717d0
      rf6=1.717d0
c
      a=0.d0
      p=-1.d0
c
      sx=c1*f+sox+270.d0
      call pline (0.,0.,sx,0.)
c
      sx=c1*f+sox; sr=r1*f
      call plot (sx,0.,3)
      call arc (sr,150.,180.)
c
      sx=c2*f+sox; sr=r2*f
      call plot (sx,0.,3)
      call arc (sr,170.,180.)
c
      sx=c3*f+sox; sr=r3*f
      call plot (sx,0.,3)
      call arc (sr,145.,180.)
c
      sx=24.3*s*f+sox
      call pline (sx,0.,sx,65.)
c
      sx=c5*f+sox; sr=r5*f
      call plot (sx,0.,3)
      call arc (sr,135.,180.)
c
      sx=c6*f+sox; sr=r6*f
      call plot (sx,0.,3)
      call arc (sr,0.,34.)
c
      sx=53.28*s*f+sox
      call pline (sx,0.,sx,50.)
c
      sx=c8*f+sox; sr=r8*f
      call plot (sx,0.,3)
      call arc (sr,0.,24.)
c
      sx=61.31*s*f+sox
      call pline (sx,0.,sx,70.)
c
      sx=c10*f+sox; sr=r10*f
      call plot (sx,0.,3)
      call arc (sr,0.,24.)
c
       do i=1,nray
        y=i*.50d0
c      ------------------------------------------------------------
        sx=0.0
        sy=y*f
        call plot (sx,sy,3)
c      ----------------------------------- Entering lens-1
        x=c1-sqrt(r1**2-y**2)
        call rayplot(x,y,f)                ! plot until incidental x,y
        call snell (c1,r1,a,x,y,rf1,g)     ! Angle at entring lens-1
c      ----------------------------------- Exiting lens-1
        call incdnt (c2,r2,x,y,g,xx,yy)    ! where ray Exit from lens-1
        call rayplot(xx,yy,f)    
        call snell (c2,r2,g,xx,yy,1.d0/rf1,gg)   ! Exit lens-1 to air
c      ----------------------------------- Entering lens-2
        call incdnt (c3,r3,xx,yy,gg,xxx,yyy)
        call rayplot(xxx,yyy,f)    
        call snell (c3,r3,gg,xxx,yyy,rf2,ggg)    ! Angle at entering lens-2
c      ----------------------------------- Exiting lens-2 (R=Infty)
        xxxx=24.3d0*s                    ! Exiting lens-2 to lens-3
        yyyy=yyy+ggg*(xxxx-xxx)          ! It also entering lens-3
        call rayplot(xxxx,yyyy,f)    
        rfi=rf3/rf2
        call snell (c3,r4,ggg,xxxx,yyyy,rfi,gggg) ! Angle at exit/enter at 24.3
c      ----------------------------------- Exiting lens-3 
        call incdnt (c5,r5,xxxx,yyyy,gggg,x5,y5)   ! where exiting lens-3
        call rayplot(x5,y5,f)    
        call snell (c5,r5,gggg,x5,y5,1.d0/rf3,g5)  ! Angle at exit lens-3 
c      -------------------- special treatment of closer point to lens-4
        xpoint=48.d0*s
        ypoint=g5*(xpoint-x5)+y5
c      ----------------------------------- Entering lens-4
        call incdnt (c6,r6,xpoint,ypoint,g5,x6,y6) ! where ray entering lens-4
        call rayplot(x6,y6,f)    
        call snell (c6,r6,g5,x6,y6,rf4,g6)  ! Angle at entering lens-4
ccccccccccccccccccccccccccccc
        xp=53.28d0*s              ! Exiting lens-4 / Entering lens-5
        yp=y6+g6*(xp-x6)          ! It also entering lens-5
        call snell (c7,r7,g6,xp,yp,rf5/rf4,g6)  ! Angle at exit/enter at 53.28
c      ----------------------------------- Exiting lens-5
        call incdnt (c8,r8,xp,yp,g6,x7,y7) ! where ray exiting lens-5
        call rayplot(x7,y7,f)    
        call snell (c8,r8,g6,x7,y7,1.d0/rf5,g7)    ! Angle at exiting lens-5
c
        xp=61.31d0*s              ! Entering lens-6 (R=Infty)
        yp=y7+g7*(xp-x7)          !
        call snell (c9,r9,g7,xp,yp,rf5,g8)  ! Angle at entering lens-6
c      ----------------------------------- Exiting lens-6
        call incdnt (c10,r10,xp,yp,g8,x8,y8) ! where ray exiting lens-6
        call rayplot(x8,y8,f)    
        call snell (c10,r10,g8,x8,y8,1.d0/rf5,g9) ! Angle at exiting lens-6
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        xfin=x8-y8/g9
        call rayplot(xfin,0.d0,f)    
c
        xy(1,i)=xfin
        xy(2,i)=y
       enddo
c
      sg=xy(1,1)
      call plot (sg*sf,0.,3)
       do i=1,nray
        si=xy(1,i)-sg
        call plot ((si+sg)*sf,xy(2,i)*sf,2)
       enddo
c
      sg=xy(1,1)
      call plot (sg*sf+30.,0.,3)
      call plot (sg*sf+30.,75.,2)
c
      dmx=0.d0
       do i=1,nray
        si=(xy(1,i)-sg)*10.
        if(abs(xy(1,i)-sg).gt.dmx) dmx=abs(xy(1,i)-sg)
        call plot ((si+sg)*sf+30.,xy(2,i)*sf,2)
       enddo
c
      write(6,*) 'LensGauss xmax =',dmx 
c
      return
      end
      SUBROUTINE incdnt (c,r,p,q,a,x,y)
c
c     spherical lens :  ((X-c)**2 + Y**2 = r**2
c     incidental ray going through (p,q) : Y-q = a (X-p)
c
      implicit double precision (A-H,O-Z)
c
      aa=1.d0+a**2
      bb=a**2*p+c-a*q
      cc=c**2+a**2*p**2-2*a*q*p+q**2-r**2
      x1=(bb-sqrt(bb**2-aa*cc))/aa
      x2=(bb+sqrt(bb**2-aa*cc))/aa
       if(abs(x1-p).lt.abs(x2-p)) then
        x=x1
       else
        x=x2
       endif
      y=a*(x-p)+q
c
      return
      end
      SUBROUTINE snell (c,r,a,x,y,rf,g)
c
c     spherical lens :  ((X-c)**2 + Y**2 = r**2
c     incidental ray comming to (x,y) : Y-y = a (X-x)
c     rf : refractive index  
c     g (output), inclination of refracted ray :  Y-y = g (X-x)
c
      implicit double precision (A-H,O-Z)
      fzero=0.d0
      finfty=1.0d0/fzero
c
      alpha=atan(a)         ! incidental ray   BY radian
c
       if(r.eq.finfty) then
        beta=0.d0
       else
        beta=atan(y/(x-c))    ! direction normal BY radian
       endif
c
      sbma=sin(beta-alpha)
      sbmg=sbma/rf            ! sin(beta-gamma)
      bmg=asin(sbmg)
      gamma=beta-bmg
      g=tan(gamma)
c
      return
      end
      SUBROUTINE rayplot (x,y,f)
      implicit double precision (A-H,O-R,T-Z)
c
      sx=x*f
      sy=y*f
      call plot (sx,sy,2)
c
      return
      end
