      parameter (ncase=8)
      dimension angle(ncase)
      character*100 ch,charg
      character*5 clabel
      data ch/'ball'/,iww/600/,iwh/400/
      data g/9.8/,n/20/,v/35./,angle/5.,10.,20.,30.,40.,45.,50.,60./
      RAD(X)  = X * 3.141592 / 180.0
c
c  ---  determine figure size  ---
c
      xaxis=v**2/g; yaxis=v**2/(2*g)
      f=float(iww)/xaxis     
      write(*,*) ' Xmax=',xaxis,' Ymax=',yaxis,' f=',f
c
c  --- first figure  ---
c
      call plots (ch,iww,iwh)
      call factor (f)
      call plot  (5.,10.,-3)
      call pline  (0.,0.,xaxis,0.)
      call pline  (0.,0.,0.,yaxis)
      Do k=1,ncase
        vx=v*cos(rad(angle(k))); vy=v*sin(rad(angle(k)))
        time=2*vy/g; dt=time/n; mark=mod(k,3)+1; ymax=0
        call plot  (0.,0.,3)
        do i=1,n
          t=i*dt; x=vx*t; y=vy*t-0.5*g*t*t
          if(y.gt.ymax) then
            at=x; ymax=y
          endif
          call plot (x,y,2)
          call centsym (x,y,mark,0.1*f)
        enddo
        write(clabel,'(f4.1)') angle(k)
        call symbol (at,ymax,clabel)
      Enddo
c
c  --- second figure  ---
c
      call newpage
      call factor (f)
      call plot  (10.,10.,-3)
      call pline  (0.,0.,xaxis,0.)
      call pline  (0.,0.,0.,yaxis)
      Do k=1,ncase
        vx=v*cos(rad(angle(k))); vy=v*sin(rad(angle(k)))
        time=2*vy/g; dt=time/n; ymax=0
        call newpen (k*3)
        call plot  (0.,0.,3)
        do i=1,n
          t=i*dt; x=vx*t; y=vy*t-0.5*g*t*t
          if(y.gt.ymax) then
            at=x; ymax=y
          endif
          call plot (x,y,2)
          call centsym (x,y,2,0.1*f)
        enddo
        write(clabel,'(f4.1)') angle(k)
        call symbol (at,ymax,clabel)
      Enddo
c
c  --- end of plot ---
c
      call plot (t,y,999)
c
      stop
      END
      SUBROUTINE pline (x1,y1,x2,y2)
      call plot(x1,y1,3)
      call plot(x2,y2,2)
      return
      end
