#include <stdio.h>
#define CHARLEN 100
#define NCOLOR   32

int      Icol, Ipage;
int      Wx=0, Wy=0, Ww, Wh;
float    Fctr, Curx, Cury;
FILE *output;

/*********  plots        ***************************/
/* initialize,  title:title name, ww:WindowWidth, wh:WindowHeights */
void plots(char *title, int *ww, int *wh)
{
int    i;
float    p;
     output=fopen("calcomp.ps","w");
     fprintf(output,"%%!PS-Adobe-1.2\n");
     Ww=*ww; Wh=*wh;
     printf("%%%%BoundingBox: 0 0 %i %i\n",Ww,Wh);
     fprintf(output,"%%%%BoundingBox: 0 0 %i %i\n",*ww,*wh);
     fprintf(output,"%%%%\n");
     fprintf(output,"%%%%Page: 1\n");
     fprintf(output,"/pline{newpath moveto lineto stroke}def\n");
     fprintf(output,"/circle{newpath 0 360 arc }def\n");
     fprintf(output,"/square{newpath /Dim exch def moveto Dim Dim rmoveto 0 Dim 2 mul neg rlineto Dim 2 mul neg 0 rlineto 0 Dim 2 mul rlineto closepath }def\n");
     fprintf(output,"/xmark{newpath /Dim exch def moveto Dim Dim rmoveto Dim 2 mul neg Dim 2 mul neg rlineto 0 Dim 2 mul rmoveto Dim 2 mul Dim 2 mul neg rlineto closepath }def\n");
     fprintf(output,"/Courier findfont\n");
     fprintf(output,"10 scalefont\n");
     fprintf(output,"setfont\n");
     fprintf(output," .6 setlinewidth\n");
     /* Initialize internal variables */
     Curx=0.; Cury=0.; Fctr=1.; Icol=0; Ipage+=1;
     printf("plots exit\n");
}
/*********  newpage_( )  ***********************/
void newpage ()
{
     fprintf(output,"showpage\n");
     Curx=0.; Cury=0.; Fctr=1.; Icol=0; Ipage+=1;
     fprintf(output,"%%%%Page: %i\n",Ipage);
     fprintf(output," .6 setlinewidth\n");
     printf("page %i initialized\n",Ipage);
}
/*********  plot_( x, y, opr )  ***********************/
void plot(float *x, float *y, int *opr)
{
      int i;
      float xx0,yy0,xx1,yy1,px,py;
      px=*x*Fctr; py=*y*Fctr;
      switch ( (*opr) )
      {
          case -3 : /* End of plotting a page, new origin for new page */ 
               printf("%f %f translate\n",px,py);
               fprintf(output,"%f %f translate\n",px,py);
               break;
          case 2  :       /* move to (x,y) with pen down */
               xx0 = Curx; yy0 = Cury;
               xx1 = px;   yy1 = py;
    /*         fprintf(output,"%i %f %f %f %f pline\n",Icol,xx0,yy0,xx1,yy1);   */
               fprintf(output,"%f %f %f %f pline\n",xx0,yy0,xx1,yy1);
               break;
          case 999 :                  /* end of plot                 */
               fprintf(output,"showpage\n");
               fclose(output);
               printf("End of plot\n");
               break;
          default :   /*  case 3 'move to (x,y) with pen up' */
               break;        /* OR other *opr is specified   */
      }
      Curx = px, Cury = py;
}
/*********  where_( x, y )  ***********************/
void where(float *x, float *y){
      *x=Curx; *y=Cury;
}
/*********  factor ( f )    *****************************/
void factor (float *f){
     Fctr = (*f);
}
/*********  curve ( x1, y1, x2, y2, x3, y3)  ********************/
void curve(float *x1, float *y1, float *x2, float *y2,float *x3, float *y3)
{
      float p1x,p1y,p2x,p2y,p3x,p3y;
      p1x=*x1*Fctr; p1y=*y1*Fctr;
      p2x=*x2*Fctr; p2y=*y2*Fctr;
      p3x=*x3*Fctr; p3y=*y3*Fctr;
      fprintf(output,"newpath %f %f moveto\n",Curx,Cury);
      fprintf(output,"%f %f %f %f %f %f curveto stroke\n",p1x,p1y,p2x,p2y,p3x,p3y);
      Curx=p3x, Cury=p3y;
}
/*********  arc ( r, anglefrom, angleto )  ********************/
void arc(float *r, float *anglefrom, float *angleto)
{
      float rr,fr,to;
/*    fprintf(output,"newpath %f %f moveto\n",Curx,Cury);  */
      rr=*r*Fctr; fr=*anglefrom; to=*angleto;
      fprintf(output,"newpath %f %f %f %f %f arc stroke\n",Curx,Cury,rr,fr,to);
      Curx=Curx+rr*cos(to*3.141592/180.), Cury=Cury+rr*sin(to*3.141592/180.);
}
/*********  symbol ( x, y, text )  ********************/
void symbol(float *x, float *y, char *text)
{
     char ch[CHARLEN];
     int  i,i1,len;
     float xx,yy;

/*   extract symbols from text into ch[0:len-1]    */
     for(i=0; (i<CHARLEN) && (*(text+i) == ' ' ) ; i++ );
     i1 = i;
     for(i=i1; (i<CHARLEN) && (*(text+i) != ' ' ) ; i++ )
         ch[i-i1] = *(text+i);
     ch[i]='\0';
     len  = i - i1;
/*   printf("len = %i\n",len);   */
     xx = (*x)*Fctr; yy = (*y)*Fctr;
     fprintf(output,"newpath %f %f moveto\n",xx,yy);
     fprintf(output,"(%s) show\n",ch);
}
/*********  centsym ( x, y, int , fsize )  ****************/
void centsym(float *x, float *y, int *mark, float *fm)
{
     float xx0,yy0,xx1,yy1,Fctrsav,fsize;
     int   num3=3,num2=2;

     fsize=Fctr*(*fm);           /*  font size   */
     switch ( (*mark) )
     {
          case 3  :       /*  X mark  */
              xx0 = (*x) * Fctr; yy0 = (*y) * Fctr;
              fprintf(output,"%f %f %f xmark stroke\n",xx0,yy0,fsize);
              Curx=xx0, Cury=yy0;
              break;
          case 2  :       /*  square  */
              xx0 = (*x) * Fctr; yy0 = (*y) * Fctr;
              fprintf(output,"%f %f %f square stroke\n",xx0,yy0,fsize);
              Curx=xx0, Cury=yy0;
              break;
          default :       /*  circle  */
              xx0 = (*x) * Fctr; yy0 = (*y) * Fctr;
              fprintf(output,"%f %f %f circle stroke\n",xx0,yy0,fsize);
              Curx=xx0, Cury=yy0;
              break;
      }
}
/*********  newpen ( icolor   )  ***********************/
void newpen(int *icolor)
{
int ival;
float    red,  blue;
     if(*icolor%NCOLOR==0){
         fprintf(output,"0 0 0 setrgbcolor\n");
     } else {
         ival =(NCOLOR-(*icolor))%NCOLOR;
         red =(float)ival/(float)NCOLOR;
         ival=(*icolor)%NCOLOR;
         blue=(float)ival/(float)NCOLOR;
         fprintf(output,"%f 0 %f setrgbcolor\n",red,blue);
     }
}
/*********  linewidth (iwidth)  ***************************/
void linewidth(int *iwidth)
{
     fprintf(output,"%i setlinewidth\n",*iwidth);
}
/*********  special ( text )  ********************/
void special( char *text)
{
     fprintf(output,"%s\n",text);
     fprintf(output,"%%%%\n");
}
/*********  wrapper for GNU Fortran  *************/

void plots_(char *disp, int *ww, int *wh)
{    plots (      disp,      ww,      wh);}

void plot_(float *x, float *y, int *opr)
{    plot (       x,        y,      opr);}

void curve_(float *x1, float *y1, float *x2, float *y2,float *x3, float *y3)
{    curve (       x1,        y1,        x2,        y2,       x3,        y3);}

void arc_(float *r, float *anglefrom, float *angleto)
{    arc (       r,        anglefrom,        angleto);}

void symbol_(float *x, float *y, char *text)
{    symbol (       x,        y,       text);}

void centsym_(float *x, float *y, int *mark, float *fm)
{    centsym (       x,        y,      mark,        fm);}

void where_(float *x, float *y)
{    where (       x,        y);}

void factor_(float *f)
{    factor (       f);}

void newpen_(int *icolor)
{    newpen (     icolor);}

void linewidth_(int *iwidth)
{    linewidth (     iwidth);}

void newpage_()
{    newpage ();}

void special_( char *text)
{    special (       text);}

