#include <stdio.h>
#define CHARLEN 100
#define NCOLOR   33

int      Icol, Ipage, Iput;
int      Wx=0, Wy=0, Ww, Wh;
float    Fctr, Curx, Cury;
FILE *output;

/*********  plots        ***************************/
/* initialize,  title:title name, ww:WindowWidth, wh:WindowHeights */
void plots(char *title, int *ww, int *wh)
{
int    i;
float    p;
     output=fopen("calcompt.tex","w");
     fprintf(output,"\\documentclass{jarticle}\n");
     fprintf(output,"\\usepackage{pstricks}\n");
     fprintf(output,"\\begin{document}\n");
     fprintf(output,"\\begin{figure}\n");
     fprintf(output,"\\begin{center}\n");
     fprintf(output,"\\psset{unit=1pt}\n");
     Ww=*ww; Wh=*wh;
     fprintf(output,"\\begin{pspicture}(0,0)(%d,%d)\n",Ww,Wh);
     /* Initialize internal variables */
     Iput=0; Fctr=1.; Icol=1; Ipage+=1;
     printf("plots exit\n");
}
/*********  newpage_( )  ***********************/
void newpage ()
{
     int i;
     for(i=0; i<Iput; i++) fprintf(output,"}\n");
     fprintf(output,"\\end{pspicture}\n");
     fprintf(output,"\\end{center}\n");
     fprintf(output,"\\end{figure}\n");
     fprintf(output,"%%%%%%%%%%%%%\n");
     fprintf(output,"\\begin{figure}\n");
     fprintf(output,"\\begin{center}\n");
     fprintf(output,"\\psset{unit=1pt}\n");
     fprintf(output,"\\begin{pspicture}(0,0)(%d,%d)\n",Ww,Wh);
     /* Initialize internal variables */
     Iput=0; Fctr=1.; Icol=1; Ipage+=1;
}
/*********  plot_( x, y, opr )  ***********************/
void plot(float *x, float *y, int *opr)
{
      int i;
      float xx0,yy0,xx1,yy1,px,py;
      px=*x*Fctr; py=*y*Fctr;
      switch ( (*opr) )
      {
          case -3 : /* new origin will be used, \put(x,y){ */ 
               printf("\\put(%f,%f){\n",px,py);
               fprintf(output,"\\put(%f,%f){\n",px,py);
               Iput+=1;
               break;
          case 2  :       /* move to (x,y) with pen down */
               xx0 = Curx; yy0 = Cury;
               xx1 = px;   yy1 = py;
               if(Icol<=1) fprintf(output,"\\psline(%f,%f)(%f,%f)\n",xx0,yy0,xx1,yy1);
               if(Icol==2) fprintf(output,"\\psline[linecolor=red](%f,%f)(%f,%f)\n",xx0,yy0,xx1,yy1);
               if(Icol==3) fprintf(output,"\\psline[linecolor=blue](%f,%f)(%f,%f)\n",xx0,yy0,xx1,yy1);
               if(Icol==4) fprintf(output,"\\psline[linecolor=green](%f,%f)(%f,%f)\n",xx0,yy0,xx1,yy1);
               if(Icol==5) fprintf(output,"\\psline[linecolor=cyan](%f,%f)(%f,%f)\n",xx0,yy0,xx1,yy1);
               if(Icol==6) fprintf(output,"\\psline[linecolor=magenta](%f,%f)(%f,%f)\n",xx0,yy0,xx1,yy1);
               if(Icol==7) fprintf(output,"\\psline[linecolor=yellow](%f,%f)(%f,%f)\n",xx0,yy0,xx1,yy1);
               break;
          case 999 :                  /* end of plot                 */
               for(i=0; i<Iput; i++) fprintf(output,"}\n");
               fprintf(output,"\\end{pspicture}\n");
               fprintf(output,"\\end{center}\n");
               fprintf(output,"\\end{figure}\n");
               fprintf(output,"\\end{document}\n");
               fclose(output);
               printf("End of plot\n");
               break;
          default :   /*  case 3 'move to (x,y) with pen up' */
               break;        /* OR other *opr is specified   */
      }
      Curx = px, Cury = py;
}
/*********  where_( x, y )  ***********************/
void where(float *x, float *y){
      *x=Curx; *y=Cury;
}
/*********  factor ( f )    *****************************/
void factor (float *f){
     Fctr = (*f);
}
/*********  curve ( x1, y1, x2, y2, x3, y3)  ********************/
void curve(float *x1, float *y1, float *x2, float *y2,float *x3, float *y3)
{
      float p1x,p1y,p2x,p2y,p3x,p3y;
      p1x=*x1*Fctr; p1y=*y1*Fctr;
      p2x=*x2*Fctr; p2y=*y2*Fctr;
      p3x=*x3*Fctr; p3y=*y3*Fctr;
      fprintf(output,"\\psbezier(%f,%f)(%f,%f)(%f,%f)(%f,%f)\n",Curx,Cury,p1x,p1y,p2x,p2y,p3x,p3y);
      Curx=p3x, Cury=p3y;
}
/*********  arc ( r, anglefrom, angleto )  ********************/
void arc(float *r, float *anglefrom, float *angleto)
{
      float rr,fr,to;
/*    fprintf(output,"newpath %f %f moveto\n",Curx,Cury);  */
      rr=*r*Fctr; fr=*anglefrom; to=*angleto;
      fprintf(output,"\\psarc(%f,%f){%f}{%f}{%f}\n",Curx,Cury,rr,fr,to);
      Curx=Curx+rr*cos(to*3.141592/180.), Cury=Cury+rr*sin(to*3.141592/180.);
}
/*********  symbol ( x, y, text )  ********************/
void symbol(float *x, float *y, char *text)
{
     char ch[CHARLEN];
     int  i,i1,len;
     float xx,yy;

/*   extract symbols from text into ch[0:len-1]    */
     for(i=0; (i<CHARLEN) && (*(text+i) == ' ' ) ; i++ );
     i1 = i;
     for(i=i1; (i<CHARLEN) && (*(text+i) != ' ' ) ; i++ )
         ch[i-i1] = *(text+i);
     ch[i]='\0';
     len  = i - i1;
/*   printf("len = %i\n",len);   */
     xx = (*x)*Fctr; yy = (*y)*Fctr;
     fprintf(output,"\\uput[90](%f,%f){%s}\n",xx,yy,ch);
}
/*********  centsym ( x, y, int , fsize )  ****************/
void centsym(float *x, float *y, int *mark, float *fm)
{
     float xx0,yy0,xx1,yy1,Fctrsav,fsize;
     int   num3=3,num2=2,mdot;

     fsize=Fctr*(*fm);           /*  font size   */
     mdot=(*mark)%5+1;
     xx0 = (*x) * Fctr; yy0 = (*y) * Fctr;
     switch ( mdot )
     {
          case 5  :       /*  triangle* mark  */
              fprintf(output,"\\psdots[dotstyle=triangle*](%f,%f)\n",xx0,yy0);
              break;
          case 4  :       /*  square* mark  */
              fprintf(output,"\\psdots[dotstyle=square*](%f,%f)\n",xx0,yy0);
              break;
          case 3  :       /*  circle*  mark  */
              fprintf(output,"\\psdots[dotstyle=*](%f,%f)\n",xx0,yy0);
              break;
          case 2  :       /*  square  */
              fprintf(output,"\\psdots[dotstyle=square](%f,%f)\n",xx0,yy0);
              break;
          default :       /*  circle  */
              fprintf(output,"\\psdots[dotstyle=o](%f,%f)\n",xx0,yy0);
              break;
      }
      Curx=xx0, Cury=yy0;
}
/*********  newpen ( icolor   )  ***********************/
void newpen(int *icolor)
{
     Icol = *icolor%8;
}
/*********  linewidth (iwidth)  ***************************/
void linewidth(int *iwidth)
{}
/*********  special ( text )  ********************/
void special( char *text) { }
/*********  wrapper for GNU Fortran  *************/

void plots_(char *disp, int *ww, int *wh)
{    plots (      disp,      ww,      wh);}

void plot_(float *x, float *y, int *opr)
{    plot (       x,        y,      opr);}

void curve_(float *x1, float *y1, float *x2, float *y2,float *x3, float *y3)
{    curve (       x1,        y1,        x2,        y2,       x3,        y3);}

void arc_(float *r, float *anglefrom, float *angleto)
{    arc (       r,        anglefrom,        angleto);}

void symbol_(float *x, float *y, char *text)
{    symbol (       x,        y,       text);}

void centsym_(float *x, float *y, int *mark, float *fm)
{    centsym (       x,        y,      mark,        fm);}

void where_(float *x, float *y)
{    where (       x,        y);}

void factor_(float *f)
{    factor (       f);}

void newpen_(int *icolor)
{    newpen (     icolor);}

void newpage_()
{    newpage ();}

void linewidth_(int *iwidth)
{    linewidth (     iwidth);}

void special_( char *text)
{    special (       text);}

