/*  Linux (GNU) : gcc calcompx.c -c,
                  g77 plotest.f calcompx.o -lX11 -L/usr/X11R6/lib 
  -- REMEMBER ! --  gcc requires to modify entry name such as,
                    plots --> plots_
*/
#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#define CHARLEN 100
#define NCOLOR 32

Display   *Dpp;
Window     Wd;
GC         gd[NCOLOR+1];
XEvent ev ; /*    XKeyEvent  is included in XEvent  */
XFontStruct  *fontinfo;
unsigned long pixels[NCOLOR+1];
int      ICOL, IPEN, Wx=0, Wy=0, Ww, Wh;
float    Fctr, Orgx, Orgy, Curx, Cury;
int  screen,black,white;
/***** for redrawing   *************/
int  Nopr,Nchar;
char Chxy[10000];
typedef struct{int type,x,y,r,s,t,u;}XY;
XY XYopr[5000];

/*********  Xline stores both line ends, then XDrawLine ***/
Xline (int x0,int y0,int x1,int y1){
  XDrawLine(Dpp,Wd,gd[ICOL],x0,y0,x1,y1);
  XYopr[Nopr].type=1; XYopr[Nopr].x=x0; XYopr[Nopr].y=y0;
  XYopr[Nopr].r=x1; XYopr[Nopr].s=y1; Nopr+=1;
} 
/*********  Xarc stores center coord. etc. then XDrawArc ***/
Xarc  (int x0,int y0,int r0,int r1,int a0,int a1){
  XDrawArc(Dpp,Wd,gd[ICOL],x0,y0,r0,r1,a0,a1);
  XYopr[Nopr].type=2; XYopr[Nopr].x=x0; XYopr[Nopr].y=y0; XYopr[Nopr].r=r0;
  XYopr[Nopr].s=r1; XYopr[Nopr].t=a0; XYopr[Nopr].u=a1; Nopr+=1;
} 
/*********  Xrectangle stores arguments, then XDrawRectangle ***/
Xrectangle (int x0,int y0,int r0,int r1){
  XDrawRectangle(Dpp,Wd,gd[ICOL],x0,y0,r0,r1);
  XYopr[Nopr].type=3; XYopr[Nopr].x=x0; XYopr[Nopr].y=y0;
  XYopr[Nopr].r=r0; XYopr[Nopr].s=r1; Nopr+=1;
} 
/*********  Xstring stores char, then XDrawString ***/
Xstring (int x0,int y0,char *chtx,int len){
  int i;
 /*  XSetFont (Dpp, gd[ICOL], fontinfo->fid);   */
  XDrawString (Dpp,Wd,gd[ICOL],x0,y0,chtx,len);
  XYopr[Nopr].type=4; XYopr[Nopr].x=x0; XYopr[Nopr].y=y0; XYopr[Nopr].r=len;
  for(i=0; i<len ; i++ ) Chxy[Nchar+i] = *(chtx+i);
  Nchar+=len; Nopr+=1;
}
/*********  Xlineattributes , then XLineAttributes ***/
Xlineattributes(){
  XYopr[Nopr].type=5; XYopr[Nopr].x=ICOL; XYopr[Nopr].y=IPEN;
  XSetLineAttributes(Dpp,gd[ICOL],IPEN,LineSolid,CapButt,JoinMiter);
  Nopr+=1;
}
/*********  re_draw after Exposure Event  ************/
void re_draw(){
  char chtx[CHARLEN]; 
  int i,len,j,k=0;
  IPEN=1, ICOL=0;
  for(i=0; i<Nopr; i++){
     switch ( XYopr[i].type ){
       case 1 : 
         XDrawLine(Dpp,Wd,gd[ICOL],XYopr[i].x,XYopr[i].y,XYopr[i].r,XYopr[i].s); 
         break;
       case 2 : 
         XDrawArc(Dpp,Wd,gd[ICOL],XYopr[i].x,XYopr[i].y,XYopr[i].r,XYopr[i].s,XYopr[i].t,XYopr[i].u); 
         break;
       case 3 : 
         XDrawRectangle(Dpp,Wd,gd[ICOL],XYopr[i].x,XYopr[i].y,XYopr[i].r,XYopr[i].s); 
         break;
       case 4 : 
         len=XYopr[i].r;
         for(j=0; j<len; j++) chtx[j]=Chxy[k+j]; /*  *(chtx+j)=Chxy[k+j]; */
         XDrawString (Dpp,Wd,gd[ICOL],XYopr[i].x,XYopr[i].y,chtx,len); 
         k+=len; break;
       case 5 : 
         ICOL=XYopr[i].x; IPEN=XYopr[i].y;
         XSetLineAttributes(Dpp,gd[ICOL],IPEN,LineSolid,CapButt,JoinMiter);
         break;
       default :
         break;
     }
  }
}
/*********  plots        ***************************/
/* initialize,  disp:display name, ww:WindowWidth, wh:Windowheights */
plots(char *disp, int *ww, int *wh){
  XColor   colors;
  Colormap cmap;
  Window   rw;
/*XSetWindowAttributes attr;  */
  int  fontascent,fontheight;
  int  i,mid,pix;
  char dispname[CHARLEN];
  unsigned long plane_masks[NCOLOR+1];

/*   get display name      */
  for(i=0; (i<CHARLEN) && (*(disp+i) != ' '); i++) dispname[i]= *(disp+i);
  dispname[i]='\0';
  printf ( dispname ); printf ( "\n" );

  Dpp    = XOpenDisplay(NULL);    /* connects to server  */
  screen = XDefaultScreen(Dpp);
  Ww     = *ww; Wh     = *wh;
  black  = XBlackPixel(Dpp,screen);
  white  = XWhitePixel(Dpp,screen);

/*  for color allocation   */
  cmap   = DefaultColormap(Dpp,screen);

  rw = XDefaultRootWindow (Dpp);          /* window_id for root window  */
  Wd = XCreateSimpleWindow(Dpp,rw,Wx,Wy,Ww,Wh,2,white,black); /* generate window  */
  XStoreName (Dpp, Wd, dispname );        /* Name of window  */

/* change window attributes    */
/* attr.backing_store = Always;
  XChangeWindowAttributes(Dpp, Wd, CWBackingStore, &attr );
*/
  XMapWindow (Dpp,Wd);                /* map window */
  XSelectInput(Dpp,Wd,KeyPressMask|ExposureMask);  /* select event type  2008.Sep.14 */

/******  font definition      ************/
    fontinfo = XLoadQueryFont(Dpp, "fixed" );
    fontascent = fontinfo->max_bounds.ascent;
    fontheight = fontascent + fontinfo->max_bounds.descent;

/******  color definition     ************/
    gd[0]  = XCreateGC(Dpp,rw,0,NULL);
    colors.red   = 65535;
    colors.green = 65535;
    colors.blue  = 65535;
    colors.flags = DoRed|DoGreen|DoBlue;
    XAllocColor(Dpp,cmap,&colors);
    XSetForeground(Dpp,gd[0],colors.pixel);

    mid=(NCOLOR+1)/2;
    pix=65536/(NCOLOR-1);
    for(i=1;i<(NCOLOR+1);i++){
      gd[i]  = XCreateGC(Dpp,rw,0,NULL);
/*    colors.red   = (pix*(i-1)<65535) ? pix*(i-1) : 65535; */
/*    colors.green = 0; */
/*    colors.blue  = (pix*(NCOLOR-i)<65535) ? pix*(NCOLOR-i) : 65535;  */
/**************/
      if(i <=  mid ) {
        colors.blue = 65535;
        colors.green= (2*pix*(i-1))<65535 ? 2*pix*(i-1) : 65535;
        colors.red  = 0;
      }else{
        colors.blue = 2*pix*(mid-i);
        colors.green= 2*pix*(NCOLOR-i);
        colors.red  = ((i-mid)*2*pix < 65535) ? (i-mid)*2*pix : 65535;
      }
/*      printf("%d %d %d \n",colors.red,colors.green,colors.blue);   */
        colors.flags = DoRed|DoGreen|DoBlue;
        XAllocColor(Dpp,cmap,&colors);
        XSetForeground(Dpp,gd[i],colors.pixel);
    }

/* Initialize IPEN=unit width, ICOL=white, Nopr=Nchar=0 for Exposure event */
    ICOL=0; IPEN=1; Nopr=Nchar=0;
    Orgx=Orgy=Curx=Cury=0; Fctr=1 ;
    XSetLineAttributes(Dpp,gd[ICOL],1,LineSolid,CapButt,JoinMiter);
}
/*********  symbol ( x, y, text )  ********************/
void symbol(float *x, float *y, char *text){
  char ch[CHARLEN];
  int  i,i1,len,xx,yy,textwidth;

/*   extract symbols from text into ch[0:len-1]    */
  for(i=0; (i<CHARLEN) && (*(text+i) == ' '); i++);
  i1 = i;
  for(i=i1; (i<CHARLEN) && (*(text+i) != ' '); i++) ch[i-i1] = *(text+i);
  ch[i]='\0'; len=i-i1;
  textwidth = XTextWidth (fontinfo,ch,len);
  xx=(*x)*Fctr + Orgx-textwidth/2; yy =(*y)*Fctr + Orgy;
  XSetFont (Dpp,gd[ICOL],(*fontinfo).fid);   /* XSetFont (Dpp,gd[ICOL],fontinfo->fid); */
/*XDrawString (Dpp,Wd,gd[ICOL],xx,Wh-yy,ch,len);  */
  Xstring     (                xx,Wh-yy,ch,len);
}
/*********  centsym ( x, y, int ,fsize )  ********************/
void centsym(float *x, float *y, int *mark, float *fm){
  int xx0,yy0,xx1,yy1,isize;
  float px,py,fsize;

  px=*x*Fctr; py=*y*Fctr; fsize=Fctr*(*fm);
  switch ( (*mark) ){
    case 3 :   /* mark =  X   */
      xx0=(int)(px+Orgx-fsize); yy0=(int)(py+Orgy-fsize);
      xx1=xx0+2*fsize; yy1=yy0+2*fsize;
   /* XDrawLine(Dpp,Wd,gd[ICOL],xx0,Wh-yy0,xx1,Wh-yy1);  */
      Xline    (                xx0,Wh-yy0,xx1,Wh-yy1);
      yy0=(int)(py+Orgy+fsize); yy1=yy0-2*fsize; 
   /* XDrawLine(Dpp,Wd,gd[ICOL],xx0,Wh-yy0,xx1,Wh-yy1);  */
      Xline    (                xx0,Wh-yy0,xx1,Wh-yy1);
      Curx=px; Cury=py;
      break;
    case 2 :   /* mark =  rectangle  */
      xx0=(int)(px-0.5*fsize+Orgx); yy0=(int)(py+0.5*fsize+Orgy);
      isize=(int)(fsize);
   /* XDrawRectangle(Dpp,Wd,gd[ICOL],xx0,Wh-yy0,isize,isize);  */
      Xrectangle    (                xx0,Wh-yy0,isize,isize);  
      Curx=px; Cury=py;
      break;
    default :   /*  mark =  circle     */
      xx0=(int)(px-0.5*fsize+Orgx); yy0=(int)(py+0.5*fsize+Orgy);
      isize=(int)(fsize/2);
   /* XDrawArc(Dpp,Wd,gd[ICOL],xx0,Wh-yy0,2*isize,2*isize,0*64,360*64);    */
      Xarc    (                xx0,Wh-yy0,2*isize,2*isize,0*64,360*64);  
      Curx=px; Cury=py;
      break;
  }
}
/*********  linewidth ( width  )  ***********************/
void linewidth(int *width){
  IPEN=*width;
/*XSetLineAttributes(Dpp,gd[ICOL],IPEN,LineSolid,CapButt,JoinMiter);*/
  Xlineattributes   ();
}
/*********  plot ( x, y, opr )  ***********************/
void plot(float *x, float *y, int *opr){
  int i,ix0,iy0,ix1,iy1;
  float px,py;
  px=*x*Fctr; py=*y*Fctr;
  switch ( (*opr) ){
    case -3 :                   /* move origin     */ 
      Orgx+=px; Orgy+=py;
      break;
    case 2  :       /* move to (x,y) with pen down */
      ix0=(int)(Curx+Orgx); iy0=(int)(Cury+Orgy);
      ix1=(int)(px  +Orgx); iy1=(int)(py  +Orgy); 
   /* XDrawLine(Dpp,Wd,gd[ICOL],ix0,Wh-iy0,ix1,Wh-iy1);  */
      Xline    (                ix0,Wh-iy0,ix1,Wh-iy1);
      break;
    case 999 :                  /* end of plot     */
      XFlush (Dpp);
      while(1){
        XNextEvent(Dpp, &ev);
        if(ev.type == Expose) re_draw();
        if(ev.type == KeyPress) exit(1);
      }
      for(i=1;i<(NCOLOR+1);i++)
      XFreeGC (Dpp, gd[i]);
      XDestroyWindow (Dpp, Wd);
      XFlush (Dpp) ;
      XCloseDisplay(Dpp);
      break;
    default : /* case 3 'move to (x,y) with pen up'*/
      break;       /* OR other *opr is specified*/
  }
  Curx=px; Cury=py; 
}
/*********  where_( x, y )  ***********************/
void where(float *x, float *y){
  *x=Curx+Orgx; *y=Cury+Orgy;
}
/*********  factor ( f )    *****************************/
void factor (float *f){
  Fctr = (*f);
}
/*********  newpage_( )  ******************* 2008.Sep.4  */
void newpage(){
  XFlush (Dpp);
  while(1){        /*     wait until key in  */
    XNextEvent(Dpp, &ev);
    if(ev.type == Expose) re_draw();
    if(ev.type == KeyPress) break;
  }
  XClearWindow (Dpp,Wd);
/* Initialize with IPEN=unit width, ICOL=white, clear Nline, Narc */
  ICOL=0; IPEN=1; Nopr=Nchar=0;
  XSetLineAttributes (Dpp,gd[ICOL],1,LineSolid,CapButt,JoinMiter);
  Orgx=Orgy=Curx=Cury=0; Fctr=1;
}
/*********  xpause_( )  ******************* 2008.Sep.12 */
void xpause(){
  while(1){
    XNextEvent(Dpp, &ev);
    if(ev.type == KeyPress) break;
  }
}
/*********  curve ( x1, y1, x2, y2, x3, y3  )  ********************/
void curve (float *x1, float *y1, float *x2, float *y2, float *x3, float *y3){
  int i,n=64,num3=3,num2=2;
  double p0x,p0y,p1x,p1y,p2x,p2y,p3x,p3y,t;
  float xbuf,ybuf,Fctrsav;

  p0x=(double)Curx; p0y=(double)Cury;
  p1x=*x1*Fctr; p1y=*y1*Fctr; 
  p2x=*x2*Fctr; p2y=*y2*Fctr;
  p3x=*x3*Fctr; p3y=*y3*Fctr;
  Fctrsav=Fctr; Fctr=1.0;
  plot (&Curx,&Cury,&num3);
    for(i=0; i<n+1; i++){
      t=(double)i / (double)n ;
      xbuf=(float)((1-t)*(1-t)*(1-t)*p0x+3*(1-t)*(1-t)*t*p1x+3*(1-t)*t*t*p2x+t*t*t*p3x);
      ybuf=(float)((1-t)*(1-t)*(1-t)*p0y+3*(1-t)*(1-t)*t*p1y+3*(1-t)*t*t*p2y+t*t*t*p3y);
      plot (&xbuf,&ybuf,&num2);
    }
    Fctr=Fctrsav;
    Curx=(float)p3x, Cury=(float)p3y;
}
/*********  arc ( r, angle1, angle2 )  ******  2008.Sep.5  *********/
void arc(float *r, float *angle1, float *angle2){
  float rr;
  int ia1,ia2,ir,ix,iy;
  rr=*r*Fctr; ir=(int)(rr);
  ia1=(int)(*angle1), ia2=(int)(*angle2);
  ix=(int)(Curx-rr+Orgx), iy=(int)(Cury+rr+Orgy);
/*XDrawArc(Dpp,Wd,gd[ICOL],ix,Wh-iy,2*ir,2*ir,ia1*64,(ia2-ia1)*64);  */
  Xarc    (                ix,Wh-iy,2*ir,2*ir,ia1*64,(ia2-ia1)*64);  
/*Curx=Curx+rr*cos(*angle2*3.141592/180.),Cury=Cury+rr*sin(*angle2*3.141592/180.);  */
  Curx=Curx+rr*cos(*angle2*0.0174532925), Cury=Cury+rr*sin(*angle2*0.0174532925);
}

/*********  color_(icolor)  *****************************/
void newpen(int *icolor){
  if( (*icolor) >= 0 && (*icolor) < (NCOLOR+1) ) ICOL = *icolor;
/*  XSetLineAttributes (Dpp,gd[ICOL],IPEN,LineSolid,CapButt,JoinMiter);  */
    Xlineattributes();
}
/*********  special ( text )  ********************/
void special( char *text){}


/* wrapper for GNU Fortran                      */
void plots_(char *disp, int *ww, int *wh){
     plots (      disp,      ww,      wh); }
void curve_(float *x1, float *y1, float *x2, float *y2,float *x3, float *y3){
     curve (       x1,        y1,        x2,        y2,       x3,        y3);}
void arc_(float *r, float *anglefrom, float *angleto){
     arc (       r,        anglefrom,        angleto);}
void symbol_(float *x, float *y, char *text){
     symbol (       x,        y,       text); }
void centsym_(float *x, float *y, int *mark, float *fm){
     centsym (       x,        y,      mark,        fm); }
void linewidth_(int *width){
     linewidth (     width); }
void plot_(float *x, float *y, int *opr){
     plot(        x,        y,      opr); }
void where_(float *x, float *y){
     where (       x,        y); }
void factor_(float *f){
     factor (       f); }
void newpen_(int *icolor){
     newpen (     icolor); }
void newpage_(){
     newpage (); }
void xpause_(){
     xpause (); }
void special_( char *text){}
