/*******************************************************
*  plotCT2D                                            *
*******************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
/** external function **/
extern void plots();
extern void plot();
extern void newpen();
/** size **/
/* #define XOFFSET  100  */
/* #define YOFFSET  400  */
#define XOFFSET  40
#define YOFFSET  30
#define WIDTH    400
#define HEIGHT   300
/**********************
  main
***********************/
int main(int argc, char *argv[])
{
	FILE *fp_plt;
	int i;
	char  title[1024];
	int   numnp,nume;
	float *xx,*yy;
	int   **id;
	float *uu,*vv;
	float factor=1.0;
	float xmin,ymin,xmax,ymax,umax,xymax;
	float x,y;
	float scale;
/** using calcomp **/
	int iww,iwh;
	float f1,f2;
	int i1;
/** Debug **/
	FILE *fp_debug=stdout;
/*** File Open ***/
	if( argc < 2 ){
		fprintf(fp_debug,"### plot file should be specified\n");
		fflush (fp_debug);
		return 1;
	}else{
		if( (fp_plt=fopen(argv[1],"r")) == NULL){
			fprintf(fp_debug,"plt file cannot be opened!\n");
			return 1;
		}
	}
	if( argc > 2 ) factor=(float) atof( argv[2] );
/*****************/
/*** Read Data ***/
/*****************/
/** title ***/
	fgets(title,1024 , fp_plt);
/** Number of nodes, elements ***/
	fscanf(fp_plt,"%d %d\n",&numnp,&nume);
/** allocate **/
/** vector **/
	if ( ( xx=(float * )malloc( numnp * sizeof( float ) ) ) == NULL ) {
		fprintf(stdout,"Error:Memory does not enough!\n");
		exit(1);
	}
	if ( ( yy=(float * )malloc( numnp * sizeof( float ) ) ) == NULL ) {
		fprintf(stdout,"Error:Memory does not enough!\n");
		exit(1);
	}
	if ( ( uu=(float * )malloc( numnp * sizeof( float ) ) ) == NULL ) {
		fprintf(stdout,"Error:Memory does not enough!\n");
		exit(1);
	}
	if ( ( vv=(float * )malloc( numnp * sizeof( float ) ) ) == NULL ) {
		fprintf(stdout,"Error:Memory does not enough!\n");
		exit(1);
	}
/** matrix **/
	if ( ( id=(int ** )malloc( nume * sizeof( int * ) ) ) == NULL ) {
		fprintf(stdout,"Error:Memory does not enough!\n");
		exit(1);
	}
	if ( ( id[0]=(int * )malloc( nume * 2 * sizeof( int ) ) ) == NULL ) {
		fprintf(stdout,"Error:Memory does not enough!\n");
		exit(1);
	}
	for(i=1;i<nume;i++) id[i]=id[i-1]+2;
/** nodes ***/
	for(i=0;i<numnp;i++) fscanf (fp_plt,"%e %e\n",&xx[i],&yy[i]);
/** elements ***/
	for(i=0;i<nume;i++)  fscanf (fp_plt,"%d %d\n",&id[i][0],&id[i][1]);
/** Results (displacement) ***/
	for(i=0;i<numnp;i++) fscanf (fp_plt,"%e %e\n",&uu[i],&vv[i]);
/*** File Close ***/
	fclose(fp_plt);
/*****************/
/*** Echo Data ***/
/*****************/
	fprintf(fp_debug,"numnp=%d nume=%d\n",numnp,nume);
/** nodes ***/
	for(i=0;i<numnp;i++) fprintf (fp_debug,"%d: %e %e\n",i,xx[i],yy[i]);
/** elements ***/
	for(i=0;i<nume;i++)  fprintf (fp_debug,"%d: %d %d\n",i,id[i][0],id[i][1]);
/** Results (displacement) ***/
	for(i=0;i<numnp;i++) fprintf (fp_debug,"%d: %e %e\n",i,uu[i],vv[i]);
/*****************/
/*** Draw      ***/
/*****************/
/** factor, if factor is not given  **/
        if(factor == 0) {
		xmin=xx[0] ;
		ymin=yy[0] ;
		xmax=xx[0] ;
		ymax=yy[0] ;
		umax=sqrt(uu[0]*uu[0]+vv[0]*vv[0]) ;
		for(i=1;i<numnp;i++) {
			if( xx[i] > xmax ) xmax=xx[i] ;
			if( yy[i] > ymax ) ymax=yy[i] ;
			if( xx[i] < xmin ) xmin=xx[i] ;
			if( yy[i] < ymin ) ymin=yy[i] ;
			if( sqrt(uu[i]*uu[i]+vv[i]*vv[i]) > umax ) umax=sqrt(uu[i]*uu[i]+vv[i]*vv[i]) ;
		}
                if(xmax-xmin > ymax-ymin) {
			xymax=xmax-xmin;
		} else {
			xymax=ymax-ymin;
		}
		factor=(xymax*0.05)/umax;
		fprintf(fp_debug,"umax=%e  factor=%e\n",umax,factor);
        }
/** scale **/
	xmin=xx[0]+ uu[0] * factor ;
	ymin=yy[0]+ vv[0] * factor ;
	xmax=xx[0]+ uu[0] * factor ;
	ymax=yy[0]+ vv[0] * factor ;
	for(i=1;i<numnp;i++) {
		if( xx[i]+ uu[i] * factor  > xmax ) xmax=xx[i]+uu[i] * factor ;
		if( yy[i]+ vv[i] * factor  > ymax ) ymax=yy[i]+vv[i] * factor ;
		if( xx[i]+ uu[i] * factor  < xmin ) xmin=xx[i]+uu[i] * factor ;
		if( yy[i]+ vv[i] * factor  < ymin ) ymin=yy[i]+vv[i] * factor ;
		if( sqrt(uu[i]*uu[i]+vv[i]*vv[i]) > umax ) umax=sqrt(uu[i]*uu[i]+vv[i]*vv[i]) ;
	}
/** Init **/
/*	iww=WIDTH;
	iwh=HEIGHT;   */
	iww=(WIDTH*4)/5;
	iwh=(HEIGHT*4)/5;
	plots (title,&iww,&iwh);
/** set scale **/
	scale=(float)iww/(xmax-xmin);
	if( (float)iwh/(ymax -ymin) < scale ) scale= (float)iwh/(ymax -ymin);
	fprintf(fp_debug,"xmin=%e xmax=%e\n",xmin,xmax);
	fprintf(fp_debug,"ymin=%e ymax=%e\n",ymin,ymax);
	fprintf(fp_debug,"scale=%e\n",scale);
/** Loopover element (Undeformed) **/
	for(i=0;i<nume;i++){
/** point 1 **/
		x=xx[ id[i][0] - 1];y=yy[ id[i][0] - 1];
/*		f1=xmin + scale * (x-xmin) + (float)XOFFSET;
		f2=ymin + scale * (y-ymin) + (float)YOFFSET;   */
		f1= scale * (x-xmin) + (float)XOFFSET;
		f2= scale * (y-ymin) + (float)YOFFSET;
		i1=3;
		plot(&f1,&f2,&i1);
/** point 2 **/
		x=xx[ id[i][1] - 1]; y=yy[ id[i][1] - 1];
/*		f1=xmin + scale * (x-xmin) + (float)XOFFSET;
		f2=ymin + scale * (y-ymin) + (float)YOFFSET;    */
		f1= scale * (x-xmin) + (float)XOFFSET;
		f2= scale * (y-ymin) + (float)YOFFSET;
		i1=2;
		plot(&f1,&f2,&i1);
	}
/** Loopover element (Deformed) **/
/** change line width **/
	i1=2;
  	newpen(&i1);
	for(i=0;i<nume;i++){
/** point 1 **/
		x=xx[ id[i][0] - 1] + uu[id[i][0] - 1] * factor ; y=yy[ id[i][0] - 1] +vv[id[i][0] - 1] * factor ;
/*		f1=xmin + scale * (x-xmin) + (float)XOFFSET;
		f2=ymin + scale * (y-ymin) + (float)YOFFSET;   */
		f1= scale * (x-xmin) + (float)XOFFSET;
		f2= scale * (y-ymin) + (float)YOFFSET;
		i1=3;
		plot(&f1,&f2,&i1);
/** point 2 **/
		x=xx[ id[i][1] - 1] + uu[id[i][1] - 1] * factor ; y=yy[ id[i][1] - 1] +vv[id[i][1] - 1] * factor ;
/*		f1=xmin + scale * (x-xmin) + (float)XOFFSET;
		f2=ymin + scale * (y-ymin) + (float)YOFFSET;    */
		f1= scale * (x-xmin) + (float)XOFFSET;
		f2= scale * (y-ymin) + (float)YOFFSET;
		i1=2;
		plot(&f1,&f2,&i1);
	}
/** finalize **/
	i1=999; plot (&f1,&f2,&i1);
}

